/*     */ package com.jaspersoft.jasperserver.api.engine.scheduling.domain;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.JasperServerAPI;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.jaxb.DateToStringXmlAdapter;
/*     */ import java.io.Serializable;
/*     */ import java.util.Date;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @JasperServerAPI
/*     */ public abstract class ReportJobTrigger
/*     */   implements Serializable
/*     */ {
/*     */   private static final long serialVersionUID = 1L;
/*     */   public static final byte START_TYPE_NOW = 1;
/*     */   public static final byte START_TYPE_SCHEDULE = 2;
/*     */   public static final int JS_MISFIRE_INSTRUCTION_NOT_SET = 0;
/*     */   public static final int JS_MISFIRE_INSTRUCTION_IGNORE_MISFIRE_POLICY = -1;
/*     */   public static final int JS_MISFIRE_INSTRUCTION_SMART_POLICY = -999;
/*     */   private long id;
/*  72 */   private int version = -1;
/*     */   private String timezone;
/*     */   private String calendarName;
/*  75 */   private byte startType = 2;
/*     */   private Date startDate;
/*     */   private Date endDate;
/*  78 */   private int misfireInstruction = 0;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobTrigger() {}
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long getId()
/*     */   {
/*  96 */     return this.id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setId(long id)
/*     */   {
/* 110 */     this.id = id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getVersion()
/*     */   {
/* 125 */     return this.version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setVersion(int version)
/*     */   {
/* 139 */     this.version = version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(DateToStringXmlAdapter.class)
/*     */   public Date getStartDate()
/*     */   {
/* 156 */     return this.startDate;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setStartDate(Date startDate)
/*     */   {
/* 172 */     this.startDate = startDate;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public byte getStartType()
/*     */   {
/* 184 */     return this.startType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlElement
/*     */   public void setStartType(byte startType)
/*     */   {
/* 202 */     this.startType = startType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(DateToStringXmlAdapter.class)
/*     */   public Date getEndDate()
/*     */   {
/* 212 */     return this.endDate;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setEndDate(Date endDate)
/*     */   {
/* 226 */     this.endDate = endDate;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getTimezone()
/*     */   {
/* 241 */     return this.timezone;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setTimezone(String timezone)
/*     */   {
/* 251 */     this.timezone = timezone;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getCalendarName()
/*     */   {
/* 260 */     return this.calendarName;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setCalendarName(String calendarName)
/*     */   {
/* 272 */     this.calendarName = calendarName;
/*     */   }
/*     */   
/*     */   public int getMisfireInstruction() {
/* 276 */     return this.misfireInstruction;
/*     */   }
/*     */   
/*     */   public void setMisfireInstruction(int i) {
/* 280 */     this.misfireInstruction = i;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean equals(ReportJobTrigger rjt)
/*     */   {
/* 311 */     return (this.startType == rjt.getStartType()) && (this.timezone.equals(rjt.getTimezone())) && (((this.calendarName == null) && (rjt.getCalendarName() == null)) || ((this.calendarName != null) && (rjt.getCalendarName() != null) && (this.calendarName.compareTo(rjt.getCalendarName()) == 0) && (((this.startDate == null) && (rjt.getStartDate() == null)) || ((this.startDate != null) && (rjt.getStartDate() != null) && (this.startDate.compareTo(rjt.getStartDate()) == 0) && (((this.endDate == null) && (rjt.getEndDate() == null)) || ((this.endDate != null) && (rjt.getEndDate() != null) && (this.endDate.compareTo(rjt.getEndDate()) == 0) && (this.misfireInstruction == rjt.getMisfireInstruction())))))));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobTrigger(ReportJobTrigger jobTrigger)
/*     */   {
/* 333 */     setId(jobTrigger.getId());
/* 334 */     setVersion(jobTrigger.getVersion());
/* 335 */     setStartDate(jobTrigger.getStartDate());
/* 336 */     setStartType(jobTrigger.getStartType());
/* 337 */     setEndDate(jobTrigger.getEndDate());
/* 338 */     setTimezone(jobTrigger.getTimezone());
/* 339 */     setCalendarName(jobTrigger.getCalendarName());
/* 340 */     setMisfireInstruction(jobTrigger.getMisfireInstruction());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\domain\ReportJobTrigger.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */