/*      */ package com.jaspersoft.jasperserver.api.metadata.xml.domain.impl;
/*      */ 
/*      */ import com.jaspersoft.jasperserver.api.metadata.common.domain.ResourceReference;
/*      */ import java.util.ArrayList;
/*      */ import java.util.Date;
/*      */ import java.util.HashMap;
/*      */ import java.util.Iterator;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import java.util.Set;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class ResourceDescriptor
/*      */ {
/*      */   public static final String TYPE_FOLDER = "folder";
/*      */   public static final String TYPE_REPORTUNIT = "reportUnit";
/*      */   public static final String TYPE_OLAPUNIT = "olapUnit";
/*      */   public static final String TYPE_DASHBOARD_STATE = "dashboardState";
/*      */   public static final String TYPE_DASHBOARD = "dashboard";
/*      */   public static final String TYPE_REPORT_OPTIONS = "reportOptions";
/*      */   public static final String TYPE_DATASOURCE_DOMAIN = "domain";
/*      */   public static final String TYPE_DOMAIN_TOPICS = "domainTopic";
/*      */   public static final String TYPE_ADHOC_REPORT = "adhocReport";
/*      */   public static final String TYPE_ADHOC_DATA_VIEW = "adhocDataView";
/*      */   public static final String TYPE_DATASOURCE = "datasource";
/*      */   public static final String TYPE_DATASOURCE_JDBC = "jdbc";
/*      */   public static final String TYPE_DATASOURCE_JNDI = "jndi";
/*      */   public static final String TYPE_DATASOURCE_BEAN = "bean";
/*      */   public static final String TYPE_DATASOURCE_VIRTUAL = "virtual";
/*      */   public static final String TYPE_DATASOURCE_CUSTOM = "custom";
/*      */   public static final String TYPE_DATASOURCE_AWS = "aws";
/*      */   public static final String TYPE_IMAGE = "img";
/*      */   public static final String TYPE_FONT = "font";
/*      */   public static final String TYPE_JRXML = "jrxml";
/*      */   public static final String TYPE_CLASS_JAR = "jar";
/*      */   public static final String TYPE_RESOURCE_BUNDLE = "prop";
/*      */   public static final String TYPE_REFERENCE = "reference";
/*      */   public static final String TYPE_INPUT_CONTROL = "inputControl";
/*      */   public static final String TYPE_DATA_TYPE = "dataType";
/*      */   public static final String TYPE_OLAP_MONDRIAN_CONNECTION = "olapMondrianCon";
/*      */   public static final String TYPE_OLAP_XMLA_CONNECTION = "olapXmlaCon";
/*      */   public static final String TYPE_MONDRIAN_SCHEMA = "olapMondrianSchema";
/*      */   public static final String TYPE_ACCESS_GRANT_SCHEMA = "accessGrantSchema";
/*      */   public static final String TYPE_UNKNOW = "unknow";
/*      */   public static final String TYPE_LOV = "lov";
/*      */   public static final String TYPE_QUERY = "query";
/*      */   public static final String TYPE_CONTENT_RESOURCE = "contentResource";
/*      */   public static final String TYPE_STYLE_TEMPLATE = "jrtx";
/*      */   public static final String TYPE_XML_FILE = "xml";
/*      */   public static final String XML_ATT_NAME = "name";
/*      */   public static final String XML_ATT_WSTYPE = "wsType";
/*      */   public static final String XML_ATT_URI_STRING = "uriString";
/*      */   public static final String XML_ATT_IS_NEW = "isNew";
/*      */   public static final byte DT_TYPE_TEXT = 1;
/*      */   public static final byte DT_TYPE_NUMBER = 2;
/*      */   public static final byte DT_TYPE_DATE = 3;
/*      */   public static final byte DT_TYPE_DATE_TIME = 4;
/*      */   public static final byte IC_TYPE_BOOLEAN = 1;
/*      */   public static final byte IC_TYPE_SINGLE_VALUE = 2;
/*      */   public static final byte IC_TYPE_SINGLE_SELECT_LIST_OF_VALUES = 3;
/*      */   public static final byte IC_TYPE_SINGLE_SELECT_QUERY = 4;
/*      */   public static final byte IC_TYPE_MULTI_VALUE = 5;
/*      */   public static final byte IC_TYPE_MULTI_SELECT_LIST_OF_VALUES = 6;
/*      */   public static final byte IC_TYPE_MULTI_SELECT_QUERY = 7;
/*      */   public static final byte IC_TYPE_SINGLE_SELECT_LIST_OF_VALUES_RADIO = 8;
/*      */   public static final byte IC_TYPE_SINGLE_SELECT_QUERY_RADIO = 9;
/*      */   public static final byte IC_TYPE_MULTI_SELECT_LIST_OF_VALUES_CHECKBOX = 10;
/*      */   public static final byte IC_TYPE_MULTI_SELECT_QUERY_CHECKBOX = 11;
/*      */   public static final String PROP_VERSION = "PROP_VERSION";
/*      */   public static final String PROP_PARENT_FOLDER = "PROP_PARENT_FOLDER";
/*      */   public static final String PROP_RESOURCE_TYPE = "PROP_RESOURCE_TYPE";
/*      */   public static final String PROP_CREATION_DATE = "PROP_CREATION_DATE";
/*      */   public static final String PROP_FILERESOURCE_HAS_DATA = "PROP_HAS_DATA";
/*      */   public static final String PROP_FILERESOURCE_IS_REFERENCE = "PROP_IS_REFERENCE";
/*      */   public static final String PROP_FILERESOURCE_REFERENCE_URI = "PROP_REFERENCE_URI";
/*      */   public static final String PROP_FILERESOURCE_WSTYPE = "PROP_WSTYPE";
/*      */   public static final String PROP_DATA = "PROP_DATA";
/*      */   public static final String PROP_DATASOURCE_MAPPING = "DATASOURCE_MAPPING";
/*      */   public static final String PROP_DATASOURCE_DRIVER_CLASS = "PROP_DATASOURCE_DRIVER_CLASS";
/*      */   public static final String PROP_DATASOURCE_CONNECTION_URL = "PROP_DATASOURCE_CONNECTION_URL";
/*      */   public static final String PROP_DATASOURCE_USERNAME = "PROP_DATASOURCE_USERNAME";
/*      */   public static final String PROP_DATASOURCE_PASSWORD = "PROP_DATASOURCE_PASSWORD";
/*      */   public static final String PROP_DATASOURCE_JNDI_NAME = "PROP_DATASOURCE_JNDI_NAME";
/*      */   public static final String PROP_DATASOURCE_BEAN_NAME = "PROP_DATASOURCE_BEAN_NAME";
/*      */   public static final String PROP_DATASOURCE_BEAN_METHOD = "PROP_DATASOURCE_BEAN_METHOD";
/*      */   public static final String PROP_DATASOURCE_CUSTOM_SERVICE_CLASS = "PROP_DATASOURCE_CUSTOM_SERVICE_CLASS";
/*      */   public static final String PROP_DATASOURCE_CUSTOM_PROPERTY_MAP = "PROP_DATASOURCE_CUSTOM_PROPERTY_MAP";
/*      */   public static final String PROP_DATASOURCE_SUB_DS_ID = "PROP_DATASOURCE_SUB_DS_ID";
/*      */   public static final String PROP_DATASOURCE_AWS_ACCESS_KEY = "PROP_DATASOURCE_AWS_ACCESS_KEY";
/*      */   public static final String PROP_DATASOURCE_AWS_SECRET_KEY = "PROP_DATASOURCE_AWS_SECRET_KEY";
/*      */   public static final String PROP_DATASOURCE_AWS_ROLE_ARN = "PROP_DATASOURCE_AWS_ROLE_ARN";
/*      */   public static final String PROP_DATASOURCE_AWS_REGION = "PROP_DATASOURCE_AWS_REGION";
/*      */   public static final String PROP_DATASOURCE_AWS_DB_NAME = "PROP_DATASOURCE_AWS_DB_NAME";
/*      */   public static final String PROP_DATASOURCE_AWS_DB_INSTANCE_IDENTIFIER = "PROP_DATASOURCE_AWS_DB_INSTANCE_IDENTIFIER";
/*      */   public static final String PROP_DATASOURCE_AWS_DB_SERVICE = "PROP_DATASOURCE_AWS_DB_SERVICE";
/*      */   public static final String PROP_RU_DATASOURCE_TYPE = "PROP_RU_DATASOURCE_TYPE";
/*      */   public static final String PROP_RU_IS_MAIN_REPORT = "PROP_RU_IS_MAIN_REPORT";
/*      */   public static final String PROP_RU_INPUTCONTROL_RENDERING_VIEW = "PROP_RU_INPUTCONTROL_RENDERING_VIEW";
/*      */   public static final String PROP_RU_REPORT_RENDERING_VIEW = "PROP_RU_REPORT_RENDERING_VIEW";
/*      */   public static final String PROP_RU_ALWAYS_PROPMT_CONTROLS = "PROP_RU_ALWAYS_PROPMT_CONTROLS";
/*      */   public static final String PROP_RU_CONTROLS_LAYOUT = "PROP_RU_CONTROLS_LAYOUT";
/*      */   public static final byte RU_CONTROLS_LAYOUT_POPUP_SCREEN = 1;
/*      */   public static final byte RU_CONTROLS_LAYOUT_SEPARATE_PAGE = 2;
/*      */   public static final byte RU_CONTROLS_LAYOUT_TOP_OF_PAGE = 3;
/*      */   public static final byte RU_CONTROLS_LAYOUT_IN_PAGE = 4;
/*      */   public static final String PROP_DATATYPE_STRICT_MAX = "PROP_DATATYPE_STRICT_MAX";
/*      */   public static final String PROP_DATATYPE_STRICT_MIN = "PROP_DATATYPE_STRICT_MIN";
/*      */   public static final String PROP_DATATYPE_MIN_VALUE = "PROP_DATATYPE_MIN_VALUE";
/*      */   public static final String PROP_DATATYPE_MAX_VALUE = "PROP_DATATYPE_MAX_VALUE";
/*      */   public static final String PROP_DATATYPE_PATTERN = "PROP_DATATYPE_PATTERN";
/*      */   public static final String PROP_DATATYPE_TYPE = "PROP_DATATYPE_TYPE";
/*      */   public static final String PROP_LOV = "PROP_LOV";
/*      */   public static final String PROP_LOV_LABEL = "PROP_LOV_LABEL";
/*      */   public static final String PROP_LOV_VALUE = "PROP_LOV_VALUE";
/*      */   public static final String PROP_INPUTCONTROL_TYPE = "PROP_INPUTCONTROL_TYPE";
/*      */   public static final String PROP_INPUTCONTROL_IS_MANDATORY = "PROP_INPUTCONTROL_IS_MANDATORY";
/*      */   public static final String PROP_INPUTCONTROL_IS_READONLY = "PROP_INPUTCONTROL_IS_READONLY";
/*      */   public static final String PROP_INPUTCONTROL_IS_VISIBLE = "PROP_INPUTCONTROL_IS_VISIBLE";
/*      */   public static final String PROP_QUERY = "PROP_QUERY";
/*      */   public static final String PROP_QUERY_VISIBLE_COLUMNS = "PROP_QUERY_VISIBLE_COLUMNS";
/*      */   public static final String PROP_QUERY_VISIBLE_COLUMN_NAME = "PROP_QUERY_VISIBLE_COLUMN_NAME";
/*      */   public static final String PROP_QUERY_VALUE_COLUMN = "PROP_QUERY_VALUE_COLUMN";
/*      */   public static final String PROP_QUERY_LANGUAGE = "PROP_QUERY_LANGUAGE";
/*      */   public static final String PROP_QUERY_DATA = "PROP_QUERY_DATA";
/*      */   public static final String PROP_QUERY_DATA_ROW = "PROP_QUERY_DATA_ROW";
/*      */   public static final String PROP_QUERY_DATA_ROW_COLUMN = "PROP_QUERY_DATA_ROW_COLUMN";
/*      */   public static final String PROP_XMLA_URI = "PROP_XMLA_URI";
/*      */   public static final String PROP_XMLA_CATALOG = "PROP_XMLA_CATALOG";
/*      */   public static final String PROP_XMLA_DATASOURCE = "PROP_XMLA_DATASOURCE";
/*      */   public static final String PROP_XMLA_USERNAME = "PROP_XMLA_USERNAME";
/*      */   public static final String PROP_XMLA_PASSWORD = "PROP_XMLA_PASSWORD";
/*      */   public static final String PROP_MDX_QUERY = "PROP_MDX_QUERY";
/*      */   public static final String PROP_CONTENT_RESOURCE_TYPE = "CONTENT_TYPE";
/*      */   public static final String PROP_DATA_ATTACHMENT_ID = "DATA_ATTACHMENT_ID";
/*      */   public static final String PROP_REPORT_URI = "PROP_REPORT_URI";
/*      */   public static final String PROP_INPUT_VALUES = "PROP_INPUT_VALUES";
/*      */   public static final String PROP_OPTIONS_NAME = "PROP_OPTIONS_NAME";
/*      */   public static final String PROP_SECURITY_PERMISSION_MASK = "PROP_SECURITY_PERMISSION_MASK";
/*      */   public static final String CONTENT_TYPE_PDF = "pdf";
/*      */   public static final String CONTENT_TYPE_HTML = "html";
/*      */   public static final String CONTENT_TYPE_XLS = "xls";
/*      */   public static final String CONTENT_TYPE_RTF = "rtf";
/*      */   public static final String CONTENT_TYPE_CSV = "csv";
/*      */   public static final String CONTENT_TYPE_IMAGE = "img";
/*      */   public static final String REFERENCE_TYPE = "referenceType";
/*  224 */   private List properties = new ArrayList();
/*  225 */   private HashMap hm = new HashMap();
/*      */   
/*      */   private String name;
/*      */   
/*      */   private String label;
/*      */   
/*      */   private String description;
/*      */   
/*  233 */   private boolean isNew = false;
/*      */   
/*      */   private String wsType;
/*      */   
/*      */   private String uriString;
/*      */   private Date creationDate;
/*  239 */   private List children = new ArrayList();
/*  240 */   private List parameters = new ArrayList();
/*      */   
/*      */ 
/*  243 */   private List queryDataCache = null;
/*      */   private byte[] data;
/*      */   private String fileType;
/*      */   private String referenceType;
/*      */   
/*      */   public byte[] getData() {
/*  249 */     return this.data;
/*      */   }
/*      */   
/*      */   public void setData(byte[] data) {
/*  253 */     this.data = data;
/*      */   }
/*      */   
/*      */   public String getWsType()
/*      */   {
/*  258 */     return this.wsType;
/*      */   }
/*      */   
/*      */   public void setWsType(String wsType) {
/*  262 */     this.wsType = wsType;
/*      */   }
/*      */   
/*      */   public String getReferenceType() {
/*  266 */     return this.referenceType;
/*      */   }
/*      */   
/*      */   public void setReferenceType(String referenceType) {
/*  270 */     this.referenceType = referenceType;
/*      */   }
/*      */   
/*      */   public String getUriString() {
/*  274 */     return this.uriString;
/*      */   }
/*      */   
/*      */   public void setUriString(String uriString) {
/*  278 */     this.uriString = uriString;
/*      */   }
/*      */   
/*      */   public String getName() {
/*  282 */     return this.name;
/*      */   }
/*      */   
/*      */   public void setName(String name) {
/*  286 */     this.name = name;
/*      */   }
/*      */   
/*      */   public String getLabel() {
/*  290 */     return this.label;
/*      */   }
/*      */   
/*      */   public void setLabel(String label) {
/*  294 */     this.label = label;
/*      */   }
/*      */   
/*      */   public String getDescription() {
/*  298 */     return this.description;
/*      */   }
/*      */   
/*      */   public void setDescription(String description) {
/*  302 */     this.description = description;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public int getVersion()
/*      */   {
/*  310 */     Integer i = getResourcePropertyValueAsInteger("PROP_VERSION");
/*  311 */     if (i != null) return i.intValue();
/*  312 */     return 0;
/*      */   }
/*      */   
/*      */   public void setVersion(int version) {
/*  316 */     setResourceProperty("PROP_VERSION", "" + version);
/*      */   }
/*      */   
/*      */   public String getParentFolder()
/*      */   {
/*  321 */     return getResourcePropertyValue("PROP_PARENT_FOLDER");
/*      */   }
/*      */   
/*      */   public void setParentFolder(String parentFolder) {
/*  325 */     setResourceProperty("PROP_PARENT_FOLDER", "" + parentFolder);
/*      */   }
/*      */   
/*      */   public String getResourceType() {
/*  329 */     return getResourcePropertyValue("PROP_RESOURCE_TYPE");
/*      */   }
/*      */   
/*      */   public void setResourceType(String resourceType) {
/*  333 */     setResourceProperty("PROP_RESOURCE_TYPE", "" + resourceType);
/*      */   }
/*      */   
/*      */   public boolean getIsNew() {
/*  337 */     return this.isNew;
/*      */   }
/*      */   
/*      */   public void setIsNew(boolean isNew) {
/*  341 */     this.isNew = isNew;
/*      */   }
/*      */   
/*      */   public Date getCreationDate() {
/*  345 */     return this.creationDate;
/*      */   }
/*      */   
/*      */   public void setCreationDate(Date creationDate) {
/*  349 */     this.creationDate = creationDate;
/*      */   }
/*      */   
/*      */   public boolean getHasData()
/*      */   {
/*  354 */     String s = getResourcePropertyValue("PROP_HAS_DATA");
/*  355 */     if (s != null) return s.equals("true");
/*  356 */     return false;
/*      */   }
/*      */   
/*      */   public void setHasData(boolean hasData) {
/*  360 */     setResourceProperty("PROP_HAS_DATA", "" + hasData);
/*      */   }
/*      */   
/*      */   public boolean getIsReference() {
/*  364 */     String s = getResourcePropertyValue("PROP_IS_REFERENCE");
/*  365 */     if (s != null) return s.equals("true");
/*  366 */     return false;
/*      */   }
/*      */   
/*      */   public void setIsReference(boolean isReference) {
/*  370 */     setResourceProperty("PROP_IS_REFERENCE", "" + isReference);
/*      */   }
/*      */   
/*      */   public String getReferenceUri() {
/*  374 */     return getResourcePropertyValue("PROP_REFERENCE_URI");
/*      */   }
/*      */   
/*      */   public void setReferenceUri(String referenceUri) {
/*  378 */     setResourceProperty("PROP_REFERENCE_URI", referenceUri);
/*      */   }
/*      */   
/*      */   public String getDriverClass() {
/*  382 */     return getResourcePropertyValue("PROP_DATASOURCE_DRIVER_CLASS");
/*      */   }
/*      */   
/*      */   public void setDriverClass(String driverClass) {
/*  386 */     setResourceProperty("PROP_DATASOURCE_DRIVER_CLASS", driverClass);
/*      */   }
/*      */   
/*      */   public String getConnectionUrl() {
/*  390 */     return getResourcePropertyValue("PROP_DATASOURCE_CONNECTION_URL");
/*      */   }
/*      */   
/*      */   public void setConnectionUrl(String connectionUrl) {
/*  394 */     setResourceProperty("PROP_DATASOURCE_CONNECTION_URL", connectionUrl);
/*      */   }
/*      */   
/*      */   public String getPassword() {
/*  398 */     return getResourcePropertyValue("PROP_DATASOURCE_PASSWORD");
/*      */   }
/*      */   
/*      */   public void setPassword(String password) {
/*  402 */     setResourceProperty("PROP_DATASOURCE_PASSWORD", password);
/*      */   }
/*      */   
/*      */   public String getUsername() {
/*  406 */     return getResourcePropertyValue("PROP_DATASOURCE_USERNAME");
/*      */   }
/*      */   
/*      */   public void setUsername(String username) {
/*  410 */     setResourceProperty("PROP_DATASOURCE_USERNAME", username);
/*      */   }
/*      */   
/*      */   public String getJndiName() {
/*  414 */     return getResourcePropertyValue("PROP_DATASOURCE_JNDI_NAME");
/*      */   }
/*      */   
/*      */   public void setJndiName(String jndiName) {
/*  418 */     setResourceProperty("PROP_DATASOURCE_JNDI_NAME", jndiName);
/*      */   }
/*      */   
/*      */   public void setServiceClass(String svcClass) {
/*  422 */     setResourceProperty("PROP_DATASOURCE_CUSTOM_SERVICE_CLASS", svcClass);
/*      */   }
/*      */   
/*      */   public String getServiceClass() {
/*  426 */     return getResourcePropertyValue("PROP_DATASOURCE_CUSTOM_SERVICE_CLASS");
/*      */   }
/*      */   
/*      */   public void setAwsAccessKey(String awsAccessKey) {
/*  430 */     setResourceProperty("PROP_DATASOURCE_AWS_ACCESS_KEY", awsAccessKey);
/*      */   }
/*      */   
/*      */   public String getAwsAccessKey() {
/*  434 */     return getResourcePropertyValue("PROP_DATASOURCE_AWS_ACCESS_KEY");
/*      */   }
/*      */   
/*      */   public void setAwsSecretKey(String awsSecretKey) {
/*  438 */     setResourceProperty("PROP_DATASOURCE_AWS_SECRET_KEY", awsSecretKey);
/*      */   }
/*      */   
/*      */   public String getAwsSecretKey() {
/*  442 */     return getResourcePropertyValue("PROP_DATASOURCE_AWS_SECRET_KEY");
/*      */   }
/*      */   
/*      */   public void setAwsRoleARN(String roleARN) {
/*  446 */     setResourceProperty("PROP_DATASOURCE_AWS_ROLE_ARN", roleARN);
/*      */   }
/*      */   
/*      */   public String getAwsRoleARN() {
/*  450 */     return getResourcePropertyValue("PROP_DATASOURCE_AWS_ROLE_ARN");
/*      */   }
/*      */   
/*      */   public void setAwsRegion(String awsRegion) {
/*  454 */     setResourceProperty("PROP_DATASOURCE_AWS_REGION", awsRegion);
/*      */   }
/*      */   
/*      */   public String getAwsRegion() {
/*  458 */     return getResourcePropertyValue("PROP_DATASOURCE_AWS_REGION");
/*      */   }
/*      */   
/*      */   public void setAwsDbName(String awsDbName) {
/*  462 */     setResourceProperty("PROP_DATASOURCE_AWS_DB_NAME", awsDbName);
/*      */   }
/*      */   
/*      */   public String getAwsDbName() {
/*  466 */     return getResourcePropertyValue("PROP_DATASOURCE_AWS_DB_NAME");
/*      */   }
/*      */   
/*      */   public void setAwsDbInstanceIdentifier(String awsDbInstanceIdentifier) {
/*  470 */     setResourceProperty("PROP_DATASOURCE_AWS_DB_INSTANCE_IDENTIFIER", awsDbInstanceIdentifier);
/*      */   }
/*      */   
/*      */   public String getAwsDbInstanceIdentifier() {
/*  474 */     return getResourcePropertyValue("PROP_DATASOURCE_AWS_DB_INSTANCE_IDENTIFIER");
/*      */   }
/*      */   
/*      */   public void setAwsDbService(String awsDbService) {
/*  478 */     setResourceProperty("PROP_DATASOURCE_AWS_DB_SERVICE", awsDbService);
/*      */   }
/*      */   
/*      */   public String getAwsDbService() {
/*  482 */     return getResourcePropertyValue("PROP_DATASOURCE_AWS_DB_SERVICE");
/*      */   }
/*      */   
/*      */ 
/*      */   public void setSchema(String schema)
/*      */   {
/*  488 */     setResourceProperty("SCHEMA", schema);
/*      */   }
/*      */   
/*      */   public void setBundles(List bundles) {}
/*      */   
/*      */   public void setDefaultBoundleLocalStr(String defaultBundleLocal)
/*      */   {
/*  495 */     setResourceProperty("DEFAULT_BUNDLE_LOCAL", defaultBundleLocal);
/*      */   }
/*      */   
/*      */   public void setSecurityFile(String securityFile) {
/*  499 */     setResourceProperty("DEFAULT_BUNDLE_LOCAL", securityFile);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   public void setDataSources(Map<String, ResourceReference> dataSources) {}
/*      */   
/*      */ 
/*      */   public void setPropertyMap(Map map)
/*      */   {
/*  509 */     ResourceProperty rp = new ResourceProperty("PROP_DATASOURCE_CUSTOM_PROPERTY_MAP");
/*      */     
/*  511 */     Iterator ki = map.keySet().iterator();
/*  512 */     while (ki.hasNext()) {
/*  513 */       String k = (String)ki.next();
/*  514 */       rp.getProperties().add(new ResourceProperty(k, (String)map.get(k)));
/*      */     }
/*  516 */     setResourceProperty(rp);
/*      */   }
/*      */   
/*      */   public Map getPropertyMap()
/*      */   {
/*  521 */     ResourceProperty rp = getResourceProperty("PROP_DATASOURCE_CUSTOM_PROPERTY_MAP");
/*      */     
/*  523 */     Map map = new HashMap();
/*  524 */     if (rp != null)
/*      */     {
/*  526 */       for (int i = 0; i < rp.getProperties().size(); i++)
/*      */       {
/*  528 */         ResourceProperty rpChild = (ResourceProperty)rp.getProperties().get(i);
/*  529 */         map.put(rpChild.getName(), rpChild.getValue());
/*      */       }
/*      */     }
/*  532 */     return map;
/*      */   }
/*      */   
/*      */   public ResourceProperty getProperty(String key) {
/*  536 */     return (ResourceProperty)this.hm.get(key);
/*      */   }
/*      */   
/*      */   public String getDataSourceType()
/*      */   {
/*  541 */     return getResourcePropertyValue("PROP_RU_DATASOURCE_TYPE");
/*      */   }
/*      */   
/*      */   public void setDataSourceType(String dataSourceType) {
/*  545 */     setResourceProperty("PROP_RU_DATASOURCE_TYPE", dataSourceType);
/*      */   }
/*      */   
/*      */   public boolean isMainReport() {
/*  549 */     String s = getResourcePropertyValue("PROP_RU_IS_MAIN_REPORT");
/*  550 */     if (s != null) return s.equals("true");
/*  551 */     return false;
/*      */   }
/*      */   
/*      */   public void setMainReport(boolean isMainReport) {
/*  555 */     setResourceProperty("PROP_RU_IS_MAIN_REPORT", "" + isMainReport);
/*      */   }
/*      */   
/*      */   public List getChildren() {
/*  559 */     return this.children;
/*      */   }
/*      */   
/*      */   public void setChildren(List children) {
/*  563 */     this.children = children;
/*      */   }
/*      */   
/*      */   public boolean isStrictMax() {
/*  567 */     String s = getResourcePropertyValue("PROP_DATATYPE_STRICT_MAX");
/*  568 */     if (s != null) return s.equals("true");
/*  569 */     return false;
/*      */   }
/*      */   
/*      */   public void setStrictMax(boolean strictMax) {
/*  573 */     setResourceProperty("PROP_DATATYPE_STRICT_MAX", "" + strictMax);
/*      */   }
/*      */   
/*      */   public boolean isStrictMin() {
/*  577 */     String s = getResourcePropertyValue("PROP_DATATYPE_STRICT_MIN");
/*  578 */     if (s != null) return s.equals("true");
/*  579 */     return false;
/*      */   }
/*      */   
/*      */   public static boolean isFileType(String fileType) {
/*  583 */     return ("pdf".equals(fileType)) || ("html".equals(fileType)) || ("xls".equals(fileType)) || ("rtf".equals(fileType)) || ("csv".equals(fileType)) || ("img".equals(fileType)) || ("prop".equals(fileType)) || ("font".equals(fileType)) || ("jar".equals(fileType)) || ("jrxml".equals(fileType)) || ("jrtx".equals(fileType)) || ("xml".equals(fileType));
/*      */   }
/*      */   
/*      */ 
/*      */   public void setStrictMin(boolean strictMin)
/*      */   {
/*  589 */     setResourceProperty("PROP_DATATYPE_STRICT_MIN", "" + strictMin);
/*      */   }
/*      */   
/*      */   public String getMinValue() {
/*  593 */     return getResourcePropertyValue("PROP_DATATYPE_MIN_VALUE");
/*      */   }
/*      */   
/*      */   public void setMinValue(String minValue) {
/*  597 */     setResourceProperty("PROP_DATATYPE_MIN_VALUE", minValue);
/*      */   }
/*      */   
/*      */   public String getMaxValue() {
/*  601 */     return getResourcePropertyValue("PROP_DATATYPE_MAX_VALUE");
/*      */   }
/*      */   
/*      */   public void setMaxValue(String maxValue) {
/*  605 */     setResourceProperty("PROP_DATATYPE_MAX_VALUE", maxValue);
/*      */   }
/*      */   
/*      */   public String getPattern() {
/*  609 */     return getResourcePropertyValue("PROP_DATATYPE_PATTERN");
/*      */   }
/*      */   
/*      */   public void setPattern(String pattern) {
/*  613 */     setResourceProperty("PROP_DATATYPE_PATTERN", pattern);
/*      */   }
/*      */   
/*      */   public byte getDataType() {
/*  617 */     String s = getResourcePropertyValue("PROP_DATATYPE_TYPE");
/*  618 */     if ((s == null) || (s.length() == 0)) return 0;
/*  619 */     return Byte.valueOf(s).byteValue();
/*      */   }
/*      */   
/*      */   public void setDataType(byte dataType) {
/*  623 */     setResourceProperty("PROP_DATATYPE_TYPE", "" + dataType);
/*      */   }
/*      */   
/*      */   public void setFileType(String fileType) {
/*  627 */     this.fileType = fileType;
/*      */   }
/*      */   
/*      */   public String getFileType() {
/*  631 */     return this.fileType;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public List getListOfValues()
/*      */   {
/*  652 */     ResourceProperty rp = getResourceProperty("PROP_LOV");
/*      */     
/*  654 */     List listOfValues = new ArrayList();
/*  655 */     if (rp != null)
/*      */     {
/*  657 */       for (int i = 0; i < rp.getProperties().size(); i++)
/*      */       {
/*  659 */         ResourceProperty rpChild = (ResourceProperty)rp.getProperties().get(i);
/*  660 */         ListItem li = new ListItem(rpChild.getValue() != null ? rpChild.getValue() : rpChild.getName(), rpChild.getName());
/*  661 */         listOfValues.add(li);
/*      */       }
/*      */     }
/*      */     
/*  665 */     return listOfValues;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setListOfValues(List listOfValues)
/*      */   {
/*  673 */     ResourceProperty rp = new ResourceProperty("PROP_LOV");
/*      */     
/*  675 */     for (int i = 0; i < listOfValues.size(); i++)
/*      */     {
/*  677 */       ListItem li = (ListItem)listOfValues.get(i);
/*  678 */       rp.getProperties().add(new ResourceProperty(li.getValue() + "", li.getLabel()));
/*      */     }
/*      */     
/*  681 */     setResourceProperty(rp);
/*      */   }
/*      */   
/*      */   public byte getControlType() {
/*  685 */     String s = getResourcePropertyValue("PROP_INPUTCONTROL_TYPE");
/*  686 */     if ((s == null) || (s.length() == 0)) return 0;
/*  687 */     return Byte.valueOf(s).byteValue();
/*      */   }
/*      */   
/*      */   public void setControlType(byte controlType) {
/*  691 */     setResourceProperty("PROP_INPUTCONTROL_TYPE", "" + controlType);
/*      */   }
/*      */   
/*      */   public boolean isMandatory() {
/*  695 */     String s = getResourcePropertyValue("PROP_INPUTCONTROL_IS_MANDATORY");
/*  696 */     if (s != null) return s.equals("true");
/*  697 */     return false;
/*      */   }
/*      */   
/*      */   public void setMandatory(boolean mandatory) {
/*  701 */     setResourceProperty("PROP_INPUTCONTROL_IS_MANDATORY", "" + mandatory);
/*      */   }
/*      */   
/*      */   public boolean isReadOnly() {
/*  705 */     String s = getResourcePropertyValue("PROP_INPUTCONTROL_IS_READONLY");
/*  706 */     if (s != null) return s.equals("true");
/*  707 */     return false;
/*      */   }
/*      */   
/*      */   public void setReadOnly(boolean readOnly) {
/*  711 */     setResourceProperty("PROP_INPUTCONTROL_IS_READONLY", "" + readOnly);
/*      */   }
/*      */   
/*      */   public boolean isVisible() {
/*  715 */     String s = getResourcePropertyValue("PROP_INPUTCONTROL_IS_VISIBLE");
/*  716 */     if (s != null) return s.equals("true");
/*  717 */     return true;
/*      */   }
/*      */   
/*      */   public void setVisible(boolean visible) {
/*  721 */     setResourceProperty("PROP_INPUTCONTROL_IS_VISIBLE", "" + visible);
/*      */   }
/*      */   
/*      */   public String getBeanName() {
/*  725 */     return getResourcePropertyValue("PROP_DATASOURCE_BEAN_NAME");
/*      */   }
/*      */   
/*      */   public void setBeanName(String beanName) {
/*  729 */     setResourceProperty("PROP_DATASOURCE_BEAN_NAME", "" + beanName);
/*      */   }
/*      */   
/*      */   public String getBeanMethod() {
/*  733 */     return getResourcePropertyValue("PROP_DATASOURCE_BEAN_METHOD");
/*      */   }
/*      */   
/*      */   public void setBeanMethod(String beanMethod) {
/*  737 */     setResourceProperty("PROP_DATASOURCE_BEAN_METHOD", "" + beanMethod);
/*      */   }
/*      */   
/*      */   public String getSql() {
/*  741 */     return getResourcePropertyValue("PROP_QUERY");
/*      */   }
/*      */   
/*      */   public void setSql(String sql) {
/*  745 */     setResourceProperty("PROP_QUERY", sql);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public String[] getQueryVisibleColumns()
/*      */   {
/*  755 */     ResourceProperty rp = getResourceProperty("PROP_QUERY_VISIBLE_COLUMNS");
/*      */     
/*  757 */     List columnList = new ArrayList();
/*  758 */     if (rp != null)
/*      */     {
/*      */ 
/*      */ 
/*  762 */       for (int i = 0; i < rp.getProperties().size(); i++)
/*      */       {
/*  764 */         ResourceProperty rpChild = (ResourceProperty)rp.getProperties().get(i);
/*  765 */         if (rpChild.getName().equals("PROP_QUERY_VISIBLE_COLUMN_NAME"))
/*      */         {
/*  767 */           columnList.add(rpChild.getValue());
/*      */         }
/*      */       }
/*      */       
/*  771 */       String[] columns = new String[columnList.size()];
/*  772 */       for (int i = 0; i < columnList.size(); i++)
/*      */       {
/*  774 */         columns[i] = ("" + columnList.get(i));
/*      */       }
/*      */       
/*  777 */       return columns;
/*      */     }
/*  779 */     return new String[0];
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setQueryVisibleColumns(String[] queryVisibleColumns)
/*      */   {
/*  789 */     ResourceProperty rp = new ResourceProperty("PROP_QUERY_VISIBLE_COLUMNS");
/*      */     
/*  791 */     for (int i = 0; i < queryVisibleColumns.length; i++)
/*      */     {
/*  793 */       rp.getProperties().add(new ResourceProperty("PROP_QUERY_VISIBLE_COLUMN_NAME", queryVisibleColumns[i]));
/*      */     }
/*      */     
/*  796 */     setResourceProperty(rp);
/*      */   }
/*      */   
/*      */   public String getQueryValueColumn() {
/*  800 */     return getResourcePropertyValue("PROP_QUERY_VALUE_COLUMN");
/*      */   }
/*      */   
/*      */   public void setQueryValueColumn(String queryValueColumn) {
/*  804 */     setResourceProperty("PROP_QUERY_VALUE_COLUMN", queryValueColumn);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public List getQueryData()
/*      */   {
/*  817 */     if (this.queryDataCache != null) { return this.queryDataCache;
/*      */     }
/*  819 */     this.queryDataCache = new ArrayList();
/*      */     
/*  821 */     ResourceProperty rp = getResourceProperty("PROP_QUERY_DATA");
/*  822 */     if (rp != null)
/*      */     {
/*      */ 
/*  825 */       for (int i = 0; i < rp.getProperties().size(); i++)
/*      */       {
/*  827 */         ResourceProperty rpRow = (ResourceProperty)rp.getProperties().get(i);
/*  828 */         if (rpRow.getName().equals("PROP_QUERY_DATA_ROW"))
/*      */         {
/*  830 */           InputControlQueryDataRow icqdr = new InputControlQueryDataRow();
/*  831 */           icqdr.setValue(rpRow.getValue());
/*      */           
/*      */ 
/*  834 */           for (int k = 0; k < rpRow.getProperties().size(); k++)
/*      */           {
/*  836 */             ResourceProperty rpRowChild = (ResourceProperty)rpRow.getProperties().get(k);
/*  837 */             if (rpRowChild.getName().equals("PROP_QUERY_DATA_ROW_COLUMN"))
/*      */             {
/*  839 */               icqdr.getColumnValues().add(rpRowChild.getValue());
/*      */             }
/*      */           }
/*      */           
/*  843 */           this.queryDataCache.add(icqdr);
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*  848 */     return this.queryDataCache;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setQueryData(List queryData)
/*      */   {
/*  860 */     this.queryDataCache = null;
/*      */     
/*  862 */     ResourceProperty rp = new ResourceProperty("PROP_QUERY_DATA");
/*      */     
/*  864 */     for (int i = 0; i < queryData.size(); i++)
/*      */     {
/*  866 */       InputControlQueryDataRow icqdr = (InputControlQueryDataRow)queryData.get(i);
/*      */       
/*  868 */       ResourceProperty rpRow = new ResourceProperty("PROP_QUERY_DATA_ROW", "" + icqdr.getValue());
/*      */       
/*  870 */       for (int k = 0; k < icqdr.getColumnValues().size(); k++)
/*      */       {
/*  872 */         Object columnValue = icqdr.getColumnValues().get(k);
/*  873 */         rpRow.getProperties().add(new ResourceProperty("PROP_QUERY_DATA_ROW_COLUMN", "" + columnValue));
/*      */       }
/*      */       
/*  876 */       rp.getProperties().add(rpRow);
/*      */     }
/*      */     
/*  879 */     setResourceProperty(rp);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public List getProperties()
/*      */   {
/*  888 */     return this.properties;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setProperties(List properties)
/*      */   {
/*  896 */     this.properties = properties;
/*  897 */     this.hm.clear();
/*  898 */     for (int i = 0; i < properties.size(); i++)
/*      */     {
/*  900 */       ResourceProperty rp = (ResourceProperty)properties.get(i);
/*  901 */       this.hm.put(rp.getName(), rp);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResourceProperty(String resourcePropertyName, String value)
/*      */   {
/*  911 */     if (resourcePropertyName == null) return;
/*  912 */     if (value == null)
/*      */     {
/*  914 */       removeResourceProperty(resourcePropertyName);
/*      */     }
/*      */     else
/*      */     {
/*  918 */       ResourceProperty rp = new ResourceProperty(resourcePropertyName);
/*  919 */       rp.setValue(value);
/*  920 */       setResourceProperty(rp);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResourceProperty(String resourcePropertyName, boolean value)
/*      */   {
/*  934 */     setResourceProperty(resourcePropertyName, Boolean.toString(value));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResourceProperty(String resourcePropertyName, int value)
/*      */   {
/*  947 */     setResourceProperty(resourcePropertyName, Integer.toString(value));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResourceProperty(ResourceProperty rp)
/*      */   {
/*  956 */     if (rp == null) return;
/*  957 */     removeResourceProperty(rp.getName());
/*  958 */     getProperties().add(rp);
/*  959 */     this.hm.put(rp.getName(), rp);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void removeResourceProperty(ResourceProperty rp)
/*      */   {
/*  967 */     removeResourceProperty(rp.getName());
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void removeResourceProperty(String resourcePropertyName)
/*      */   {
/*  975 */     Object obj = this.hm.remove(resourcePropertyName);
/*  976 */     if (obj != null)
/*      */     {
/*  978 */       getProperties().remove(obj);
/*      */     }
/*      */   }
/*      */   
/*      */   public ResourceProperty getResourceProperty(String resourcePropertyName)
/*      */   {
/*  984 */     return (ResourceProperty)this.hm.get(resourcePropertyName);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public String getResourcePropertyValue(String resourcePropertyName)
/*      */   {
/*  994 */     ResourceProperty rp = getResourceProperty(resourcePropertyName);
/*  995 */     if (rp != null) { return rp.getValue();
/*      */     }
/*  997 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Boolean getResourcePropertyValueAsBoolean(String resourcePropertyName)
/*      */   {
/*      */     try
/*      */     {
/* 1008 */       ResourceProperty rp = getResourceProperty(resourcePropertyName);
/* 1009 */       if (rp != null) return Boolean.valueOf(rp.getValue());
/*      */     } catch (Exception ex) {}
/* 1011 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Integer getResourcePropertyValueAsInteger(String resourcePropertyName)
/*      */   {
/*      */     try
/*      */     {
/* 1022 */       ResourceProperty rp = getResourceProperty(resourcePropertyName);
/* 1023 */       if (rp != null) return Integer.valueOf(rp.getValue());
/*      */     } catch (Exception ex) {}
/* 1025 */     return null;
/*      */   }
/*      */   
/*      */   public List getParameters() {
/* 1029 */     return this.parameters;
/*      */   }
/*      */   
/*      */   public void setParameters(List parameters) {
/* 1033 */     this.parameters = parameters;
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-common-ws-6.0.jar!\com\jaspersoft\jasperserver\api\metadata\xml\domain\impl\ResourceDescriptor.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */