/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.organizations;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.authority.Organization;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.authority.OrganizationsListWrapper;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class BatchOrganizationsAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private final MultivaluedMap<String, String> params;
/*    */   
/*    */   public BatchOrganizationsAdapter(SessionStorage sessionStorage)
/*    */   {
/* 43 */     super(sessionStorage);
/* 44 */     this.params = new MultivaluedHashMap();
/*    */   }
/*    */   
/*    */   public BatchOrganizationsAdapter parameter(OrganizationParameter orgParam, String value) {
/* 48 */     this.params.add(orgParam.getParamName(), value);
/* 49 */     return this;
/*    */   }
/*    */   
/*    */   public OperationResult<OrganizationsListWrapper> get() {
/* 53 */     JerseyRequest<OrganizationsListWrapper> request = buildRequest(OrganizationsListWrapper.class);
/* 54 */     request.addParams(this.params);
/* 55 */     return request.get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<OrganizationsListWrapper>, R> callback) {
/* 59 */     final JerseyRequest<OrganizationsListWrapper> request = buildRequest(OrganizationsListWrapper.class);
/* 60 */     request.addParams(this.params);
/*    */     
/* 62 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 65 */         callback.execute(request.get());
/*    */       }
/*    */       
/* 68 */     });
/* 69 */     ThreadPoolUtil.runAsynchronously(task);
/* 70 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult<Organization> create(Organization clientTenant) {
/* 74 */     JerseyRequest<Organization> request = buildRequest(Organization.class);
/* 75 */     request.addParams(this.params);
/* 76 */     return request.post(clientTenant);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreate(final Organization clientTenant, final Callback<OperationResult<Organization>, R> callback) {
/* 80 */     final JerseyRequest<Organization> request = buildRequest(Organization.class);
/* 81 */     request.addParams(this.params);
/*    */     
/* 83 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 86 */         callback.execute(request.post(clientTenant));
/*    */       }
/*    */       
/* 89 */     });
/* 90 */     ThreadPoolUtil.runAsynchronously(task);
/* 91 */     return task;
/*    */   }
/*    */   
/*    */   private <T> JerseyRequest<T> buildRequest(Class<T> responseType) {
/* 95 */     return JerseyRequest.buildRequest(this.sessionStorage, responseType, new String[] { "/organizations" }, new DefaultErrorHandler());
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\organizations\BatchOrganizationsAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */