/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.dto.authority.ClientUser;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.attributes.BatchAttributeAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.attributes.BatchAttributeInterfaceAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.attributes.SingleAttributeAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.attributes.SingleAttributeInterfaceAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import java.util.regex.Matcher;
/*     */ import java.util.regex.Pattern;
/*     */ 
/*     */ public class SingleUserRequestAdapter extends AbstractAdapter
/*     */ {
/*     */   private String userUriPrefix;
/*  22 */   private StringBuilder uri = new StringBuilder("");
/*     */   
/*     */   @Deprecated
/*     */   public SingleUserRequestAdapter(SessionStorage sessionStorage, String organizationId, String username) {
/*  26 */     super(sessionStorage);
/*  27 */     if (organizationId != null) {
/*  28 */       this.userUriPrefix = ("/organizations/" + organizationId + "/users/" + username);
/*     */     } else {
/*  30 */       this.userUriPrefix = ("/users/" + username);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public SingleUserRequestAdapter(SessionStorage sessionStorage, String organizationId)
/*     */   {
/*  38 */     super(sessionStorage);
/*  39 */     if (organizationId != null) {
/*  40 */       this.uri.append("/organizations/").append(organizationId).append("/users/");
/*     */     } else {
/*  42 */       this.uri.append("/users/");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public SingleUserRequestAdapter(String userId, String organizationId, SessionStorage sessionStorage)
/*     */   {
/*  51 */     super(sessionStorage);
/*  52 */     if ((organizationId != null) && (!organizationId.equals("")) && (userId != null) && (!userId.equals(""))) {
/*  53 */       this.uri.append("/organizations/").append(organizationId).append("/users/").append(userId);
/*  54 */     } else if ((organizationId == null) && (userId != null) && (!userId.equals(""))) {
/*  55 */       this.uri.append("/users/").append(userId);
/*     */     } else {
/*  57 */       throw new IllegalArgumentException("Wrong parameters has been passed!");
/*     */     }
/*     */   }
/*     */   
/*     */   public SingleAttributeAdapter attribute() {
/*  62 */     return new SingleAttributeAdapter(this.sessionStorage, this.uri);
/*     */   }
/*     */   
/*     */   public BatchAttributeAdapter multipleAttributes() {
/*  66 */     return new BatchAttributeAdapter(this.sessionStorage, this.uri);
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public SingleAttributeInterfaceAdapter attribute(String attributeName) {
/*  71 */     if (("".equals(attributeName)) || ("/".equals(attributeName))) {
/*  72 */       throw new IllegalArgumentException("'attributeName' mustn't be an empty string");
/*     */     }
/*  74 */     return new SingleAttributeInterfaceAdapter(this.sessionStorage, this.userUriPrefix, attributeName);
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public BatchAttributeInterfaceAdapter attributes() {
/*  79 */     return new BatchAttributeInterfaceAdapter(this.sessionStorage, this.userUriPrefix);
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public OperationResult<ClientUser> get() {
/*  84 */     return buildRequest().get();
/*     */   }
/*     */   
/*     */ 
/*     */   public OperationResult<ClientUser> get(String userId)
/*     */   {
/*  90 */     if (Pattern.compile("^.*?users/([^/]+)$").matcher(this.uri.toString()).find()) {
/*  91 */       return request().get();
/*     */     }
/*     */     
/*  94 */     this.uri.append(userId);
/*  95 */     return request().get();
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public <R> RequestExecution asyncGet(final Callback<OperationResult<ClientUser>, R> callback) {
/* 100 */     final JerseyRequest<ClientUser> request = buildRequest();
/* 101 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 104 */         callback.execute(request.get());
/*     */       }
/* 106 */     });
/* 107 */     ThreadPoolUtil.runAsynchronously(task);
/* 108 */     return task;
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncGet(final Callback<OperationResult<ClientUser>, R> callback, String userId) {
/* 112 */     if (!Pattern.compile("^.*?users/([^/]+)$").matcher(this.uri.toString()).find()) {
/* 113 */       this.uri.append(userId);
/*     */     }
/* 115 */     final JerseyRequest<ClientUser> request = request();
/* 116 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 119 */         callback.execute(request.get());
/*     */       }
/* 121 */     });
/* 122 */     ThreadPoolUtil.runAsynchronously(task);
/* 123 */     return task;
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public OperationResult<ClientUser> createOrUpdate(ClientUser user) {
/* 128 */     return buildRequest().put(user);
/*     */   }
/*     */   
/*     */   public OperationResult<ClientUser> updateOrCreate(ClientUser user) {
/* 132 */     this.uri.append(user.getUsername());
/* 133 */     if ((!this.uri.toString().contains("organizations")) && (user.getTenantId() != null)) {
/* 134 */       this.uri.insert(0, "/organizations/" + user.getTenantId());
/*     */     }
/* 136 */     return request().put(user);
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public <R> RequestExecution asyncCreateOrUpdate(final ClientUser user, final Callback<OperationResult<ClientUser>, R> callback) {
/* 141 */     final JerseyRequest<ClientUser> request = buildRequest();
/* 142 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 145 */         callback.execute(request.put(user));
/*     */       }
/* 147 */     });
/* 148 */     ThreadPoolUtil.runAsynchronously(task);
/* 149 */     return task;
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCreateOrUpdate(final ClientUser user, final Callback<OperationResult<ClientUser>, R> callback, String userId) {
/* 153 */     if (!Pattern.compile("^.*?users/([^/]+)$").matcher(this.uri.toString()).find()) {
/* 154 */       this.uri.append(userId);
/*     */     }
/* 156 */     final JerseyRequest<ClientUser> request = request();
/* 157 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 160 */         callback.execute(request.put(user));
/*     */       }
/* 162 */     });
/* 163 */     ThreadPoolUtil.runAsynchronously(task);
/* 164 */     return task;
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public OperationResult delete() {
/* 169 */     return buildRequest().delete();
/*     */   }
/*     */   
/*     */   public OperationResult delete(String userId) {
/* 173 */     this.uri.append(userId);
/* 174 */     return request().delete();
/*     */   }
/*     */   
/*     */   public OperationResult delete(ClientUser user) {
/* 178 */     this.uri.append(user.getUsername());
/* 179 */     return request().delete();
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult<ClientUser>, R> callback) {
/* 184 */     final JerseyRequest<ClientUser> request = buildRequest();
/* 185 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 188 */         callback.execute(request.delete());
/*     */       }
/* 190 */     });
/* 191 */     ThreadPoolUtil.runAsynchronously(task);
/* 192 */     return task;
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult<ClientUser>, R> callback, String userId) {
/* 196 */     this.uri.append(userId);
/* 197 */     final JerseyRequest<ClientUser> request = request();
/* 198 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 201 */         callback.execute(request.delete());
/*     */       }
/* 203 */     });
/* 204 */     ThreadPoolUtil.runAsynchronously(task);
/* 205 */     return task;
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   private JerseyRequest<ClientUser> buildRequest() {
/* 210 */     return JerseyRequest.buildRequest(this.sessionStorage, ClientUser.class, new String[] { this.userUriPrefix }, new DefaultErrorHandler());
/*     */   }
/*     */   
/*     */   private JerseyRequest<ClientUser> request()
/*     */   {
/* 215 */     return JerseyRequest.buildRequest(this.sessionStorage, ClientUser.class, new String[] { this.uri.toString() }, new DefaultErrorHandler());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\users\SingleUserRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */