/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ExportExecutionDescriptor;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ExportExecutionOptions;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ReportExecutionDescriptor;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ReportExecutionStatusEntity;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ReportExecutionRequestBuilder
/*     */   extends AbstractAdapter
/*     */ {
/*     */   private final String requestId;
/*     */   
/*     */   public ReportExecutionRequestBuilder(SessionStorage sessionStorage, String requestId)
/*     */   {
/*  39 */     super(sessionStorage);
/*  40 */     this.requestId = requestId;
/*     */   }
/*     */   
/*     */   public OperationResult<ReportExecutionStatusEntity> status() {
/*  44 */     return JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionStatusEntity.class, new String[] { "/reportExecutions", this.requestId, "/status" }).get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncStatus(final Callback<OperationResult<ReportExecutionStatusEntity>, R> callback)
/*     */   {
/*  49 */     final JerseyRequest<ReportExecutionStatusEntity> request = JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionStatusEntity.class, new String[] { "/reportExecutions", this.requestId, "/status" });
/*     */     
/*     */ 
/*  52 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  55 */         callback.execute(request.get());
/*     */       }
/*     */       
/*  58 */     });
/*  59 */     ThreadPoolUtil.runAsynchronously(task);
/*  60 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<ReportExecutionDescriptor> executionDetails() {
/*  64 */     return JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionDescriptor.class, new String[] { "/reportExecutions", this.requestId }).get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncExecutionDetails(final Callback<OperationResult<ReportExecutionDescriptor>, R> callback)
/*     */   {
/*  69 */     final JerseyRequest<ReportExecutionDescriptor> request = JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionDescriptor.class, new String[] { "/reportExecutions", this.requestId });
/*     */     
/*     */ 
/*  72 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  75 */         callback.execute(request.get());
/*     */       }
/*     */       
/*  78 */     });
/*  79 */     ThreadPoolUtil.runAsynchronously(task);
/*  80 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<ReportExecutionStatusEntity> cancelExecution() {
/*  84 */     ReportExecutionStatusEntity statusEntity = new ReportExecutionStatusEntity();
/*  85 */     statusEntity.setValue("cancelled");
/*  86 */     return JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionStatusEntity.class, new String[] { "/reportExecutions", this.requestId, "/status" }).put(statusEntity);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCancelExecution(final Callback<OperationResult<ReportExecutionStatusEntity>, R> callback)
/*     */   {
/*  91 */     final ReportExecutionStatusEntity statusEntity = new ReportExecutionStatusEntity();
/*  92 */     statusEntity.setValue("cancelled");
/*  93 */     final JerseyRequest<ReportExecutionStatusEntity> request = JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionStatusEntity.class, new String[] { "/reportExecutions", this.requestId, "/status" });
/*     */     
/*     */ 
/*  96 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  99 */         callback.execute(request.put(statusEntity));
/*     */       }
/*     */       
/* 102 */     });
/* 103 */     ThreadPoolUtil.runAsynchronously(task);
/* 104 */     return task;
/*     */   }
/*     */   
/*     */   public ExportExecutionRequestBuilder export(String exportId) {
/* 108 */     return new ExportExecutionRequestBuilder(this.sessionStorage, this.requestId, exportId);
/*     */   }
/*     */   
/*     */   public OperationResult<ExportExecutionDescriptor> runExport(ExportExecutionOptions exportExecutionOptions) {
/* 112 */     return JerseyRequest.buildRequest(this.sessionStorage, ExportExecutionDescriptor.class, new String[] { "/reportExecutions", this.requestId, "/exports" }).post(exportExecutionOptions);
/*     */   }
/*     */   
/*     */ 
/*     */   public <R> RequestExecution asyncRunExport(final ExportExecutionOptions exportExecutionOptions, final Callback<OperationResult<ExportExecutionDescriptor>, R> callback)
/*     */   {
/* 118 */     final JerseyRequest<ExportExecutionDescriptor> request = JerseyRequest.buildRequest(this.sessionStorage, ExportExecutionDescriptor.class, new String[] { "/reportExecutions", this.requestId, "/exports" });
/*     */     
/*     */ 
/* 121 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 124 */         callback.execute(request.post(exportExecutionOptions));
/*     */       }
/*     */       
/* 127 */     });
/* 128 */     ThreadPoolUtil.runAsynchronously(task);
/* 129 */     return task;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\reporting\ReportExecutionRequestBuilder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */