/*    */ package com.netapp.asup.data.function.filter;
/*    */ 
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*    */ import com.netapp.asup.data.function.Function;
/*    */ import com.netapp.asup.data.function.aggregation.ARMAPathInstanceIterator;
/*    */ import com.netapp.asupdata.client.ARMA.ARMAObjectInstanceImpl;
/*    */ import java.util.ArrayList;
/*    */ import java.util.HashMap;
/*    */ import java.util.Iterator;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ import java.util.Map.Entry;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.generic.GenericData.Array;
/*    */ import org.apache.avro.generic.GenericData.Record;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ public class FilterFunction implements Function
/*    */ {
/*    */   private static final String FILTER_INPUT = "filterInput";
/*    */   private static final String FILTER_OUTPUT = "filterOutput";
/*    */   
/*    */   public GenericRecord execute(ARMAObjectInstance instance, GenericRecord input, Schema outputSchema) throws Exception
/*    */   {
/* 26 */     Map<Utf8, GenericData.Array<GenericRecord>> inputMap = (Map)input.get("filterInput");
/* 27 */     Map<Utf8, GenericData.Array<GenericRecord>> outputMap = new HashMap();
/*    */     
/* 29 */     Utf8 path = null;
/* 30 */     ARMAPathInstanceIterator iterator = null;
/* 31 */     List<ARMAObjectInstance> instances = null;
/*    */     
/* 33 */     boolean isMatching = false;
/*    */     
/* 35 */     Schema filterArrSchema = outputSchema.getField("filterOutput").schema().getValueType();
/*    */     
/*    */ 
/*    */ 
/* 39 */     for (Map.Entry<Utf8, GenericData.Array<GenericRecord>> inputEntry : inputMap.entrySet())
/*    */     {
/* 41 */       path = (Utf8)inputEntry.getKey();
/* 42 */       iterator = new ARMAPathInstanceIterator(instance, path.toString().split("/"));
/* 43 */       instances = new ArrayList();
/* 44 */       while (iterator.hasNext()) {
/* 45 */         isMatching = false;
/* 46 */         ARMAObjectInstance objInstance = iterator.next();
/*    */         
/* 48 */         Iterator i$ = ((GenericData.Array)inputEntry.getValue()).iterator(); do { if (!i$.hasNext()) break; GenericRecord filterGR = (GenericRecord)i$.next();
/*    */           
/* 50 */           isMatching = FilterExecutor.getFilterExecutor(filterGR).match(objInstance);
/*    */         }
/* 52 */         while (isMatching);
/*    */         
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 58 */         if (isMatching) {
/* 59 */           instances.add(objInstance);
/*    */         }
/*    */       }
/*    */       
/* 63 */       GenericData.Array<GenericRecord> filterOutArray = new GenericData.Array(instances.size(), filterArrSchema);
/*    */       
/* 65 */       for (ARMAObjectInstance ins : instances) {
/* 66 */         filterOutArray.add(getFilterOutputRecord(filterArrSchema, ins));
/*    */       }
/* 68 */       outputMap.put(path, filterOutArray);
/*    */     }
/*    */     
/*    */ 
/* 72 */     GenericRecord output = new GenericData.Record(outputSchema);
/* 73 */     output.put("filterOutput", outputMap);
/* 74 */     return output;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   private GenericRecord getFilterOutputRecord(Schema filterArrSchema, ARMAObjectInstance objInstance)
/*    */   {
/* 82 */     ARMAObjectInstanceImpl ins = (ARMAObjectInstanceImpl)objInstance;
/*    */     
/* 84 */     GenericRecord filterOutputRecord = new GenericData.Record(filterArrSchema.getElementType());
/*    */     
/* 86 */     filterOutputRecord.put("systemId", ins.getSystemId());
/* 87 */     filterOutputRecord.put("instanceKey", ins.getInstanceKey());
/* 88 */     return filterOutputRecord;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\filter\FilterFunction.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */