/*     */ package com.netapp.asup.filter;
/*     */ 
/*     */ import com.netapp.asup.metamodel.MergeType;
/*     */ import com.netapp.asupdata.client.ARMA.ARMAObjectInstanceImpl;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.LinkedHashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ public class FilterMetaData
/*     */ {
/*  17 */   private Set<String> reqObjs = new HashSet();
/*  18 */   private Map<String, Set<InstanceKey>> objAdds = new HashMap();
/*  19 */   private Map<String, Set<InstanceKey>> objSubtract = new HashMap();
/*  20 */   private Map<String, Map<String, Set<InstanceKey>>> subtractParentInstaces = new LinkedHashMap();
/*     */   
/*     */ 
/*     */ 
/*     */   public FilterMetaData() {}
/*     */   
/*     */ 
/*     */   public FilterMetaData(List<Utf8> objects)
/*     */   {
/*  29 */     for (Utf8 utf8 : objects) {
/*  30 */       String objectName = utf8.toString().toLowerCase();
/*  31 */       this.reqObjs.add(objectName);
/*  32 */       addEmptyInstances(objectName);
/*     */     }
/*     */   }
/*     */   
/*     */   public FilterMetaData(Set<String> reqObjs) {
/*  37 */     for (String reqObj : reqObjs) {
/*  38 */       addEmptyInstances(reqObj);
/*     */     }
/*  40 */     this.reqObjs = reqObjs;
/*     */   }
/*     */   
/*     */   public void addInstance(ARMAObjectInstanceImpl instance)
/*     */   {
/*  45 */     String objName = instance.getObjectName();
/*  46 */     if (this.reqObjs.contains(objName)) {
/*  47 */       Set<InstanceKey> addInstanceSet = (Set)this.objAdds.get(objName);
/*  48 */       if (null == addInstanceSet) {
/*  49 */         addInstanceSet = new HashSet();
/*  50 */         this.objAdds.put(objName, addInstanceSet);
/*     */       }
/*  52 */       addinstanceKey(addInstanceSet, instance);
/*     */     }
/*     */   }
/*     */   
/*     */   public void removeInstance(ARMAObjectInstanceImpl instance)
/*     */   {
/*  58 */     String objName = instance.getObjectName();
/*  59 */     if (this.reqObjs.contains(objName)) {
/*  60 */       Set<InstanceKey> removeInstanceSet = (Set)this.objSubtract.get(objName);
/*  61 */       if (null == removeInstanceSet) {
/*  62 */         removeInstanceSet = new HashSet();
/*  63 */         this.objSubtract.put(objName, removeInstanceSet);
/*     */       }
/*  65 */       addinstanceKey(removeInstanceSet, instance);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public void removeParentInstances(String path, ARMAObjectInstanceImpl instance)
/*     */   {
/*  72 */     String objName = instance.getObjectName();
/*  73 */     if (this.reqObjs.contains(objName)) {
/*  74 */       Map<String, Set<InstanceKey>> objectsMap = (Map)this.subtractParentInstaces.get(path);
/*     */       
/*  76 */       if (null == objectsMap) {
/*  77 */         objectsMap = new HashMap();
/*  78 */         this.subtractParentInstaces.put(path, objectsMap);
/*     */       }
/*     */       
/*  81 */       Set<InstanceKey> removeInstanceList = (Set)objectsMap.get(objName);
/*  82 */       if (null == removeInstanceList) {
/*  83 */         removeInstanceList = new HashSet();
/*  84 */         objectsMap.put(instance.getObjectName(), removeInstanceList);
/*     */       }
/*  86 */       addinstanceKey(removeInstanceList, instance);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public FilterMetaData intersect(List<Utf8> reqObjs, FilterMetaData filterMetaData)
/*     */   {
/*  93 */     FilterMetaData intersected = new FilterMetaData();
/*     */     
/*  95 */     union(intersected, this.objSubtract, filterMetaData.objSubtract);
/*     */     
/*     */ 
/*     */ 
/*  99 */     for (Utf8 reqObj : reqObjs) {
/* 100 */       String pathobj = reqObj.toString().toLowerCase();
/* 101 */       Set<InstanceKey> thisObjAdd = (Set)this.objAdds.get(pathobj);
/* 102 */       Set<InstanceKey> newObjAdd = (Set)filterMetaData.objAdds.get(pathobj);
/*     */       
/* 104 */       if ((null != thisObjAdd) || (null != newObjAdd))
/*     */       {
/*     */ 
/*     */ 
/* 108 */         if (null == thisObjAdd) {
/* 109 */           intersected.objAdds.put(pathobj, newObjAdd);
/*     */ 
/*     */         }
/* 112 */         else if (null == newObjAdd) {
/* 113 */           intersected.objAdds.put(pathobj, thisObjAdd);
/*     */         } else {
/* 115 */           Set<InstanceKey> intersection = intersect(thisObjAdd, newObjAdd);
/* 116 */           intersected.objAdds.put(pathobj, intersection);
/*     */         }
/*     */       }
/*     */     }
/* 120 */     return intersected;
/*     */   }
/*     */   
/*     */ 
/*     */   public void addinstanceKey(Set<InstanceKey> instanceSet, ARMAObjectInstanceImpl instance)
/*     */   {
/* 126 */     MergeType mergeType = instance.getMergeType();
/* 127 */     String sysId = String.valueOf(instance.getSystemId());
/* 128 */     String instanceId = String.valueOf(instance.getInstanceKey());
/*     */     
/* 130 */     if (mergeType.equals(MergeType.INDIRECT)) {
/* 131 */       instanceSet.add(new InstanceKey(sysId, instanceId));
/*     */     } else {
/* 133 */       InstanceKey newInstanceKey = new InstanceKey(instanceId);
/* 134 */       boolean exist = false;
/* 135 */       for (InstanceKey instanceKey : instanceSet) {
/* 136 */         if (instanceKey.equals(newInstanceKey)) {
/* 137 */           instanceKey.addSysId(sysId);
/* 138 */           exist = true;
/*     */         }
/*     */       }
/* 141 */       if (!exist) {
/* 142 */         newInstanceKey.addSysId(sysId);
/* 143 */         instanceSet.add(newInstanceKey);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public Set<String> getReqObjs() {
/* 149 */     return this.reqObjs;
/*     */   }
/*     */   
/*     */   private void addEmptyInstances(String objectName) {
/* 153 */     this.objAdds.put(objectName, new HashSet());
/*     */   }
/*     */   
/*     */ 
/*     */   public Map<String, Set<InstanceKey>> consolidate()
/*     */   {
/* 159 */     Map<String, Set<InstanceKey>> parentObjSubtract = consolidaParents();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 165 */     for (String objName : this.objSubtract.keySet()) {
/* 166 */       Set<InstanceKey> removeSet = (Set)this.objSubtract.get(objName);
/* 167 */       Set<InstanceKey> addSet = (Set)this.objAdds.get(objName);
/* 168 */       boolean validAddSet = (null != addSet) && (!addSet.isEmpty());
/* 169 */       boolean validRemoveSet = (null != removeSet) && (!removeSet.isEmpty());
/* 170 */       if ((validAddSet) && (validRemoveSet)) {
/* 171 */         addSet.removeAll(removeSet);
/*     */ 
/*     */ 
/*     */       }
/* 175 */       else if ((this.objSubtract.containsKey(objName)) && (!this.objAdds.containsKey(objName))) {
/* 176 */         this.objAdds.put(objName, new HashSet());
/*     */       }
/*     */     }
/*     */     
/* 180 */     for (String objName : parentObjSubtract.keySet()) {
/* 181 */       Set<InstanceKey> parentRemoveSet = (Set)parentObjSubtract.get(objName);
/* 182 */       Set<InstanceKey> addSet = (Set)this.objAdds.get(objName);
/*     */       
/* 184 */       boolean validAddSet = (null != addSet) && (!addSet.isEmpty());
/* 185 */       boolean validRemoveSet = (null != parentRemoveSet) && (!parentRemoveSet.isEmpty());
/*     */       
/*     */ 
/* 188 */       if ((validAddSet) && (validRemoveSet)) {
/* 189 */         addSet.removeAll(parentRemoveSet);
/*     */       }
/*     */       
/* 192 */       if ((parentObjSubtract.containsKey(objName)) && (!this.objAdds.containsKey(objName))) {
/* 193 */         this.objAdds.put(objName, new HashSet());
/*     */       }
/*     */     }
/* 196 */     return this.objAdds;
/*     */   }
/*     */   
/*     */   private Set<InstanceKey> intersect(Set<InstanceKey> set1, Set<InstanceKey> set2)
/*     */   {
/* 201 */     Set<InstanceKey> intersection = new HashSet();
/*     */     
/* 203 */     if ((set1.isEmpty()) || (set2.isEmpty())) {
/* 204 */       return intersection;
/*     */     }
/*     */     
/* 207 */     for (InstanceKey instanceKey : set1) {
/* 208 */       if (set2.contains(instanceKey)) {
/* 209 */         intersection.add(instanceKey);
/*     */       }
/*     */     }
/* 212 */     return intersection;
/*     */   }
/*     */   
/*     */ 
/*     */   private void union(FilterMetaData intersectedResult, Map<String, Set<InstanceKey>> objSubtract1, Map<String, Set<InstanceKey>> objSubtract2)
/*     */   {
/* 218 */     intersectedResult.objSubtract.putAll(objSubtract1);
/*     */     
/* 220 */     for (String objName : objSubtract2.keySet())
/*     */     {
/* 222 */       if (objSubtract1.containsKey(objName)) {
/* 223 */         Set<InstanceKey> instanceKeys = new HashSet();
/* 224 */         instanceKeys.addAll((Collection)objSubtract2.get(objName));
/* 225 */         instanceKeys.addAll((Collection)objSubtract1.get(objName));
/* 226 */         intersectedResult.objSubtract.put(objName, instanceKeys);
/*     */       } else {
/* 228 */         intersectedResult.objSubtract.put(objName, objSubtract2.get(objName));
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   private Map<String, Set<InstanceKey>> consolidaParents()
/*     */   {
/* 236 */     Map<String, Set<InstanceKey>> parentObjs = new HashMap();
/*     */     
/*     */ 
/* 239 */     for (String pathStr : this.subtractParentInstaces.keySet()) {
/* 240 */       objects = (Map)this.subtractParentInstaces.get(pathStr);
/*     */       
/* 242 */       for (String obj : objects.keySet()) {
/* 243 */         Set<InstanceKey> instanceSet = (Set)parentObjs.get(obj);
/* 244 */         if (null == instanceSet) {
/* 245 */           parentObjs.put(obj, objects.get(obj));
/*     */         } else
/* 247 */           instanceSet.addAll((Collection)objects.get(obj));
/*     */       }
/*     */     }
/*     */     Map<String, Set<InstanceKey>> objects;
/* 251 */     return parentObjs;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\filter\FilterMetaData.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */