/*     */ package com.sun.xml.bind.marshaller;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.Writer;
/*     */ import java.util.Stack;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DataWriter
/*     */   extends XMLWriter
/*     */ {
/*     */   public DataWriter(Writer writer, String encoding, CharacterEscapeHandler _escapeHandler)
/*     */   {
/*  95 */     super(writer, encoding, _escapeHandler);
/*     */   }
/*     */   
/*     */   public DataWriter(Writer writer, String encoding)
/*     */   {
/* 100 */     this(writer, encoding, DumbEscapeHandler.theInstance);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public int getIndentStep()
/*     */   {
/* 126 */     return this.indentStep.length();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setIndentStep(int indentStep)
/*     */   {
/* 142 */     StringBuilder buf = new StringBuilder();
/* 143 */     for (; indentStep > 0; indentStep--)
/* 144 */       buf.append(' ');
/* 145 */     setIndentStep(buf.toString());
/*     */   }
/*     */   
/*     */   public void setIndentStep(String s) {
/* 149 */     this.indentStep = s;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void reset()
/*     */   {
/* 169 */     this.depth = 0;
/* 170 */     this.state = SEEN_NOTHING;
/* 171 */     this.stateStack = new Stack();
/* 172 */     super.reset();
/*     */   }
/*     */   
/*     */   protected void writeXmlDecl(String decl) throws IOException {
/* 176 */     super.writeXmlDecl(decl);
/* 177 */     write('\n');
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void startElement(String uri, String localName, String qName, Attributes atts)
/*     */     throws SAXException
/*     */   {
/* 204 */     this.stateStack.push(SEEN_ELEMENT);
/* 205 */     this.state = SEEN_NOTHING;
/* 206 */     if (this.depth > 0) {
/* 207 */       super.characters("\n");
/*     */     }
/* 209 */     doIndent();
/* 210 */     super.startElement(uri, localName, qName, atts);
/* 211 */     this.depth += 1;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void endElement(String uri, String localName, String qName)
/*     */     throws SAXException
/*     */   {
/* 236 */     this.depth -= 1;
/* 237 */     if (this.state == SEEN_ELEMENT) {
/* 238 */       super.characters("\n");
/* 239 */       doIndent();
/*     */     }
/* 241 */     super.endElement(uri, localName, qName);
/* 242 */     this.state = this.stateStack.pop();
/*     */   }
/*     */   
/*     */   public void endDocument() throws SAXException {
/*     */     try {
/* 247 */       write('\n');
/*     */     } catch (IOException e) {
/* 249 */       throw new SAXException(e);
/*     */     }
/* 251 */     super.endDocument();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void characters(char[] ch, int start, int length)
/*     */     throws SAXException
/*     */   {
/* 300 */     this.state = SEEN_DATA;
/* 301 */     super.characters(ch, start, length);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void doIndent()
/*     */     throws SAXException
/*     */   {
/* 321 */     if (this.depth > 0) {
/* 322 */       char[] ch = this.indentStep.toCharArray();
/* 323 */       for (int i = 0; i < this.depth; i++) {
/* 324 */         characters(ch, 0, ch.length);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 334 */   private static final Object SEEN_NOTHING = new Object();
/* 335 */   private static final Object SEEN_ELEMENT = new Object();
/* 336 */   private static final Object SEEN_DATA = new Object();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 344 */   private Object state = SEEN_NOTHING;
/* 345 */   private Stack<Object> stateStack = new Stack();
/*     */   
/* 347 */   private String indentStep = "";
/* 348 */   private int depth = 0;
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\marshaller\DataWriter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */