/*     */ package com.sun.xml.bind.v2.model.nav;
/*     */ 
/*     */ import com.sun.xml.bind.v2.runtime.Location;
/*     */ import java.lang.reflect.Array;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.GenericArrayType;
/*     */ import java.lang.reflect.GenericDeclaration;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Modifier;
/*     */ import java.lang.reflect.ParameterizedType;
/*     */ import java.lang.reflect.Type;
/*     */ import java.lang.reflect.TypeVariable;
/*     */ import java.lang.reflect.WildcardType;
/*     */ import java.util.Arrays;
/*     */ import java.util.Collection;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ReflectionNavigator
/*     */   implements Navigator<Type, Class, Field, Method>
/*     */ {
/*     */   public Class getSuperClass(Class clazz)
/*     */   {
/*  31 */     return clazz.getSuperclass();
/*     */   }
/*     */   
/*  34 */   private static final TypeVisitor<Type, Class> baseClassFinder = new TypeVisitor()
/*     */   {
/*     */     public Type onClass(Class c, Class sup) {
/*  37 */       if (sup == c) {
/*  38 */         return sup;
/*     */       }
/*     */       
/*     */ 
/*  42 */       Type sc = c.getGenericSuperclass();
/*  43 */       if (sc != null) {
/*  44 */         Type r = (Type)visit(sc, sup);
/*  45 */         if (r != null) { return r;
/*     */         }
/*     */       }
/*  48 */       for (Type i : c.getGenericInterfaces()) {
/*  49 */         Type r = (Type)visit(i, sup);
/*  50 */         if (r != null) { return r;
/*     */         }
/*     */       }
/*  53 */       return null;
/*     */     }
/*     */     
/*     */     public Type onParameterizdType(ParameterizedType p, Class sup) {
/*  57 */       Class raw = (Class)p.getRawType();
/*  58 */       if (raw == sup)
/*     */       {
/*  60 */         return p;
/*     */       }
/*     */       
/*  63 */       Type r = raw.getGenericSuperclass();
/*  64 */       if (r != null)
/*  65 */         r = (Type)visit(bind(r, raw, p), sup);
/*  66 */       if (r != null)
/*  67 */         return r;
/*  68 */       for (Type i : raw.getGenericInterfaces()) {
/*  69 */         r = (Type)visit(bind(i, raw, p), sup);
/*  70 */         if (r != null) return r;
/*     */       }
/*  72 */       return null;
/*     */     }
/*     */     
/*     */ 
/*     */     public Type onGenericArray(GenericArrayType g, Class sup)
/*     */     {
/*  78 */       return null;
/*     */     }
/*     */     
/*     */     public Type onVariable(TypeVariable v, Class sup) {
/*  82 */       return (Type)visit(v.getBounds()[0], sup);
/*     */     }
/*     */     
/*     */     public Type onWildcard(WildcardType w, Class sup)
/*     */     {
/*  87 */       return null;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     private Type bind(Type t, GenericDeclaration decl, ParameterizedType args)
/*     */     {
/*  99 */       return (Type)ReflectionNavigator.binder.visit(t, new ReflectionNavigator.BinderArg(decl, args.getActualTypeArguments()));
/*     */     }
/*     */   };
/*     */   
/*     */   private static class BinderArg {
/*     */     final TypeVariable[] params;
/*     */     final Type[] args;
/*     */     
/*     */     BinderArg(TypeVariable[] params, Type[] args) {
/* 108 */       this.params = params;
/* 109 */       this.args = args;
/* 110 */       assert (params.length == args.length);
/*     */     }
/*     */     
/*     */     public BinderArg(GenericDeclaration decl, Type[] args) {
/* 114 */       this(decl.getTypeParameters(), args);
/*     */     }
/*     */     
/*     */     Type replace(TypeVariable v) {
/* 118 */       for (int i = 0; i < this.params.length; i++)
/* 119 */         if (this.params[i] == v)
/* 120 */           return this.args[i];
/* 121 */       return v;
/*     */     } }
/*     */   
/* 124 */   private static final TypeVisitor<Type, BinderArg> binder = new TypeVisitor() {
/*     */     public Type onClass(Class c, ReflectionNavigator.BinderArg args) {
/* 126 */       return c;
/*     */     }
/*     */     
/*     */     public Type onParameterizdType(ParameterizedType p, ReflectionNavigator.BinderArg args) {
/* 130 */       Type[] params = p.getActualTypeArguments();
/*     */       
/* 132 */       boolean different = false;
/* 133 */       for (int i = 0; i < params.length; i++) {
/* 134 */         Type t = params[i];
/* 135 */         params[i] = ((Type)visit(t, args));
/* 136 */         different |= t != params[i];
/*     */       }
/*     */       
/* 139 */       Type newOwner = p.getOwnerType();
/* 140 */       if (newOwner != null)
/* 141 */         newOwner = (Type)visit(newOwner, args);
/* 142 */       different |= p.getOwnerType() != newOwner;
/*     */       
/* 144 */       if (!different) { return p;
/*     */       }
/* 146 */       return new ParameterizedTypeImpl((Class)p.getRawType(), params, newOwner);
/*     */     }
/*     */     
/*     */     public Type onGenericArray(GenericArrayType g, ReflectionNavigator.BinderArg types) {
/* 150 */       Type c = (Type)visit(g.getGenericComponentType(), types);
/* 151 */       if (c == g.getGenericComponentType()) { return g;
/*     */       }
/* 153 */       return new GenericArrayTypeImpl(c);
/*     */     }
/*     */     
/*     */     public Type onVariable(TypeVariable v, ReflectionNavigator.BinderArg types) {
/* 157 */       return types.replace(v);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public Type onWildcard(WildcardType w, ReflectionNavigator.BinderArg types)
/*     */     {
/* 164 */       Type[] lb = w.getLowerBounds();
/* 165 */       Type[] ub = w.getUpperBounds();
/* 166 */       boolean diff = false;
/*     */       
/* 168 */       for (int i = 0; i < lb.length; i++) {
/* 169 */         Type t = lb[i];
/* 170 */         lb[i] = ((Type)visit(t, types));
/* 171 */         diff |= t != lb[i];
/*     */       }
/*     */       
/* 174 */       for (int i = 0; i < ub.length; i++) {
/* 175 */         Type t = ub[i];
/* 176 */         ub[i] = ((Type)visit(t, types));
/* 177 */         diff |= t != ub[i];
/*     */       }
/*     */       
/* 180 */       if (!diff) { return w;
/*     */       }
/* 182 */       return new WildcardTypeImpl(lb, ub);
/*     */     }
/*     */   };
/*     */   
/*     */   public Type getBaseClass(Type t, Class sup)
/*     */   {
/* 188 */     return (Type)baseClassFinder.visit(t, sup);
/*     */   }
/*     */   
/*     */   public String getClassName(Class clazz) {
/* 192 */     return clazz.getName();
/*     */   }
/*     */   
/*     */   public String getTypeName(Type type) {
/* 196 */     if ((type instanceof Class)) {
/* 197 */       Class c = (Class)type;
/* 198 */       if (c.isArray())
/* 199 */         return getTypeName(c.getComponentType()) + "[]";
/* 200 */       return c.getName();
/*     */     }
/* 202 */     return type.toString();
/*     */   }
/*     */   
/*     */   public String getClassShortName(Class clazz) {
/* 206 */     return clazz.getSimpleName();
/*     */   }
/*     */   
/*     */   public Collection<? extends Field> getDeclaredFields(Class clazz) {
/* 210 */     return Arrays.asList(clazz.getDeclaredFields());
/*     */   }
/*     */   
/*     */   public Field getDeclaredField(Class clazz, String fieldName) {
/*     */     try {
/* 215 */       return clazz.getDeclaredField(fieldName);
/*     */     } catch (NoSuchFieldException e) {}
/* 217 */     return null;
/*     */   }
/*     */   
/*     */   public Collection<? extends Method> getDeclaredMethods(Class clazz)
/*     */   {
/* 222 */     return Arrays.asList(clazz.getDeclaredMethods());
/*     */   }
/*     */   
/*     */   public Class getDeclaringClassForField(Field field) {
/* 226 */     return field.getDeclaringClass();
/*     */   }
/*     */   
/*     */   public Class getDeclaringClassForMethod(Method method) {
/* 230 */     return method.getDeclaringClass();
/*     */   }
/*     */   
/*     */   public Type getFieldType(Field field) {
/* 234 */     return fix(field.getGenericType());
/*     */   }
/*     */   
/*     */   public String getFieldName(Field field) {
/* 238 */     return field.getName();
/*     */   }
/*     */   
/*     */   public String getMethodName(Method method) {
/* 242 */     return method.getName();
/*     */   }
/*     */   
/*     */   public Type getReturnType(Method method) {
/* 246 */     return fix(method.getGenericReturnType());
/*     */   }
/*     */   
/*     */   public Type[] getMethodParameters(Method method) {
/* 250 */     return method.getGenericParameterTypes();
/*     */   }
/*     */   
/*     */   public boolean isStaticMethod(Method method) {
/* 254 */     return Modifier.isStatic(method.getModifiers());
/*     */   }
/*     */   
/*     */   public boolean isSubClassOf(Type sub, Type sup) {
/* 258 */     return erasure(sup).isAssignableFrom(erasure(sub));
/*     */   }
/*     */   
/*     */   public Class ref(Class c) {
/* 262 */     return c;
/*     */   }
/*     */   
/*     */   public Class use(Class c) {
/* 266 */     return c;
/*     */   }
/*     */   
/*     */   public Class asDecl(Type t) {
/* 270 */     return erasure(t);
/*     */   }
/*     */   
/*     */   public Class asDecl(Class c) {
/* 274 */     return c;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 281 */   private static final TypeVisitor<Class, Void> eraser = new TypeVisitor() {
/*     */     public Class onClass(Class c, Void _) {
/* 283 */       return c;
/*     */     }
/*     */     
/*     */     public Class onParameterizdType(ParameterizedType p, Void _)
/*     */     {
/* 288 */       return (Class)visit(p.getRawType(), null);
/*     */     }
/*     */     
/*     */     public Class onGenericArray(GenericArrayType g, Void _) {
/* 292 */       return Array.newInstance((Class)visit(g.getGenericComponentType(), null), 0).getClass();
/*     */     }
/*     */     
/*     */ 
/*     */     public Class onVariable(TypeVariable v, Void _)
/*     */     {
/* 298 */       return (Class)visit(v.getBounds()[0], null);
/*     */     }
/*     */     
/*     */     public Class onWildcard(WildcardType w, Void _) {
/* 302 */       return (Class)visit(w.getUpperBounds()[0], null);
/*     */     }
/*     */   };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T> Class<T> erasure(Type t)
/*     */   {
/* 322 */     return (Class)eraser.visit(t, null);
/*     */   }
/*     */   
/*     */   public boolean isAbstract(Class clazz) {
/* 326 */     return Modifier.isAbstract(clazz.getModifiers());
/*     */   }
/*     */   
/*     */   public boolean isFinal(Class clazz) {
/* 330 */     return Modifier.isFinal(clazz.getModifiers());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Type createParameterizedType(Class rawType, Type... arguments)
/*     */   {
/* 337 */     return new ParameterizedTypeImpl(rawType, arguments, null);
/*     */   }
/*     */   
/*     */   public boolean isArray(Type t) {
/* 341 */     if ((t instanceof Class)) {
/* 342 */       Class c = (Class)t;
/* 343 */       return c.isArray();
/*     */     }
/* 345 */     if ((t instanceof GenericArrayType))
/* 346 */       return true;
/* 347 */     return false;
/*     */   }
/*     */   
/*     */   public boolean isArrayButNotByteArray(Type t) {
/* 351 */     if ((t instanceof Class)) {
/* 352 */       Class c = (Class)t;
/* 353 */       return (c.isArray()) && (c != byte[].class);
/*     */     }
/* 355 */     if ((t instanceof GenericArrayType)) {
/* 356 */       t = ((GenericArrayType)t).getGenericComponentType();
/* 357 */       return t != Byte.TYPE;
/*     */     }
/* 359 */     return false;
/*     */   }
/*     */   
/*     */   public Type getComponentType(Type t)
/*     */   {
/* 364 */     if ((t instanceof Class)) {
/* 365 */       Class c = (Class)t;
/* 366 */       return c.getComponentType();
/*     */     }
/* 368 */     if ((t instanceof GenericArrayType)) {
/* 369 */       return ((GenericArrayType)t).getGenericComponentType();
/*     */     }
/* 371 */     throw new IllegalArgumentException();
/*     */   }
/*     */   
/*     */   public Type getTypeArgument(Type type, int i) {
/* 375 */     if ((type instanceof ParameterizedType)) {
/* 376 */       ParameterizedType p = (ParameterizedType)type;
/* 377 */       return fix(p.getActualTypeArguments()[i]);
/*     */     }
/* 379 */     throw new IllegalArgumentException();
/*     */   }
/*     */   
/*     */   public boolean isParameterizedType(Type type) {
/* 383 */     return type instanceof ParameterizedType;
/*     */   }
/*     */   
/*     */   public boolean isPrimitive(Type type) {
/* 387 */     if ((type instanceof Class)) {
/* 388 */       Class c = (Class)type;
/* 389 */       return c.isPrimitive();
/*     */     }
/* 391 */     return false;
/*     */   }
/*     */   
/*     */   public Type getPrimitive(Class primitiveType) {
/* 395 */     assert (primitiveType.isPrimitive());
/* 396 */     return primitiveType;
/*     */   }
/*     */   
/*     */   public Location getClassLocation(final Class clazz) {
/* 400 */     new Location() {
/*     */       public String toString() {
/* 402 */         return clazz.getName();
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */   public Location getFieldLocation(final Field field) {
/* 408 */     new Location() {
/*     */       public String toString() {
/* 410 */         return field.toString();
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */   public Location getMethodLocation(final Method method) {
/* 416 */     new Location() {
/*     */       public String toString() {
/* 418 */         return method.toString();
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */   public boolean hasDefaultConstructor(Class c) {
/*     */     try {
/* 425 */       c.getDeclaredConstructor(new Class[0]);
/* 426 */       return true;
/*     */     } catch (NoSuchMethodException e) {}
/* 428 */     return false;
/*     */   }
/*     */   
/*     */   public boolean isStaticField(Field field)
/*     */   {
/* 433 */     return Modifier.isStatic(field.getModifiers());
/*     */   }
/*     */   
/*     */   public boolean isPublicMethod(Method method) {
/* 437 */     return Modifier.isPublic(method.getModifiers());
/*     */   }
/*     */   
/*     */   public boolean isPublicField(Field field) {
/* 441 */     return Modifier.isPublic(field.getModifiers());
/*     */   }
/*     */   
/*     */   public boolean isEnum(Class c) {
/* 445 */     return Enum.class.isAssignableFrom(c);
/*     */   }
/*     */   
/*     */   public Field[] getEnumConstants(Class clazz) {
/*     */     try {
/* 450 */       Object[] values = clazz.getEnumConstants();
/* 451 */       Field[] fields = new Field[values.length];
/* 452 */       for (int i = 0; i < values.length; i++) {
/* 453 */         fields[i] = clazz.getField(((Enum)values[i]).name());
/*     */       }
/* 455 */       return fields;
/*     */     }
/*     */     catch (NoSuchFieldException e) {
/* 458 */       throw new NoSuchFieldError(e.getMessage());
/*     */     }
/*     */   }
/*     */   
/*     */   public Type getVoidType() {
/* 463 */     return Void.class;
/*     */   }
/*     */   
/*     */   public String getPackageName(Class clazz) {
/* 467 */     String name = clazz.getName();
/* 468 */     int idx = name.lastIndexOf('.');
/* 469 */     if (idx < 0) return "";
/* 470 */     return name.substring(0, idx);
/*     */   }
/*     */   
/*     */   public Class findClass(String className, Class referencePoint) {
/*     */     try {
/* 475 */       ClassLoader cl = referencePoint.getClassLoader();
/* 476 */       if (cl == null) cl = ClassLoader.getSystemClassLoader();
/* 477 */       return cl.loadClass(className);
/*     */     } catch (ClassNotFoundException e) {}
/* 479 */     return null;
/*     */   }
/*     */   
/*     */   public boolean isBridgeMethod(Method method)
/*     */   {
/* 484 */     return method.isBridge();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isOverriding(Method method)
/*     */   {
/* 498 */     Class<?> s = method.getDeclaringClass().getSuperclass();
/* 499 */     String name = method.getName();
/* 500 */     Class[] params = method.getParameterTypes();
/*     */     
/* 502 */     while (s != null) {
/*     */       try {
/* 504 */         if (s.getDeclaredMethod(name, params) != null) {
/* 505 */           return true;
/*     */         }
/*     */       }
/*     */       catch (NoSuchMethodException e) {}
/*     */       
/* 510 */       s = s.getSuperclass();
/*     */     }
/*     */     
/* 513 */     return false;
/*     */   }
/*     */   
/*     */   public boolean isInterface(Class clazz) {
/* 517 */     return clazz.isInterface();
/*     */   }
/*     */   
/*     */   public boolean isTransient(Field f) {
/* 521 */     return Modifier.isTransient(f.getModifiers());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private Type fix(Type t)
/*     */   {
/* 532 */     if (!(t instanceof GenericArrayType)) {
/* 533 */       return t;
/*     */     }
/* 535 */     GenericArrayType gat = (GenericArrayType)t;
/* 536 */     if ((gat.getGenericComponentType() instanceof Class)) {
/* 537 */       Class c = (Class)gat.getGenericComponentType();
/* 538 */       return Array.newInstance(c, 0).getClass();
/*     */     }
/*     */     
/* 541 */     return t;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\nav\ReflectionNavigator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */