/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import com.sun.xml.bind.DatatypeConverterImpl;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class UTF8XmlOutput
/*     */   extends XmlOutputAbstractImpl
/*     */ {
/*     */   protected final OutputStream out;
/*  24 */   private Encoded[] prefixes = new Encoded[8];
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private int prefixCount;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final Encoded[] localNames;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  43 */   private final Encoded textBuffer = new Encoded();
/*     */   
/*     */ 
/*     */ 
/*  47 */   protected final byte[] octetBuffer = new byte['Ѐ'];
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected int octetBufferIndex;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  57 */   protected boolean closeStartTagPending = false;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public UTF8XmlOutput(OutputStream out, Encoded[] localNames)
/*     */   {
/*  65 */     this.out = out;
/*  66 */     this.localNames = localNames;
/*  67 */     for (int i = 0; i < this.prefixes.length; i++) {
/*  68 */       this.prefixes[i] = new Encoded();
/*     */     }
/*     */   }
/*     */   
/*     */   public void startDocument(XMLSerializer serializer, boolean fragment, int[] nsUriIndex2prefixIndex, NamespaceContextImpl nsContext) throws IOException, SAXException, XMLStreamException {
/*  73 */     super.startDocument(serializer, fragment, nsUriIndex2prefixIndex, nsContext);
/*     */     
/*  75 */     this.octetBufferIndex = 0;
/*  76 */     if (!fragment) {
/*  77 */       write(XML_DECL);
/*     */     }
/*     */   }
/*     */   
/*     */   public void endDocument(boolean fragment) throws IOException, SAXException, XMLStreamException {
/*  82 */     flushBuffer();
/*  83 */     super.endDocument(fragment);
/*     */   }
/*     */   
/*     */ 
/*     */   protected final void closeStartTag()
/*     */     throws IOException
/*     */   {
/*  90 */     if (this.closeStartTagPending) {
/*  91 */       write(62);
/*  92 */       this.closeStartTagPending = false;
/*     */     }
/*     */   }
/*     */   
/*     */   public void beginStartTag(int prefix, String localName) throws IOException {
/*  97 */     closeStartTag();
/*  98 */     int base = pushNsDecls();
/*  99 */     write(60);
/* 100 */     writeName(prefix, localName);
/* 101 */     writeNsDecls(base);
/*     */   }
/*     */   
/*     */   public void beginStartTag(Name name) throws IOException {
/* 105 */     closeStartTag();
/* 106 */     int base = pushNsDecls();
/* 107 */     write(60);
/* 108 */     writeName(name);
/* 109 */     writeNsDecls(base);
/*     */   }
/*     */   
/*     */   private int pushNsDecls() {
/* 113 */     int total = this.nsContext.count();
/* 114 */     NamespaceContextImpl.Element ns = this.nsContext.getCurrent();
/*     */     
/* 116 */     if (total > this.prefixes.length)
/*     */     {
/* 118 */       int m = Math.max(total, this.prefixes.length * 2);
/* 119 */       Encoded[] buf = new Encoded[m];
/* 120 */       System.arraycopy(this.prefixes, 0, buf, 0, this.prefixes.length);
/* 121 */       for (int i = this.prefixes.length; i < buf.length; i++)
/* 122 */         buf[i] = new Encoded();
/* 123 */       this.prefixes = buf;
/*     */     }
/*     */     
/* 126 */     int base = Math.min(this.prefixCount, ns.getBase());
/* 127 */     int size = this.nsContext.count();
/* 128 */     for (int i = base; i < size; i++) {
/* 129 */       String p = this.nsContext.getPrefix(i);
/*     */       
/* 131 */       Encoded e = this.prefixes[i];
/*     */       
/* 133 */       if (p.length() == 0) {
/* 134 */         e.buf = EMPTY_BYTE_ARRAY;
/* 135 */         e.len = 0;
/*     */       } else {
/* 137 */         e.set(p);
/* 138 */         e.append(':');
/*     */       }
/*     */     }
/* 141 */     this.prefixCount = size;
/* 142 */     return base;
/*     */   }
/*     */   
/*     */   protected void writeNsDecls(int base) throws IOException {
/* 146 */     NamespaceContextImpl.Element ns = this.nsContext.getCurrent();
/* 147 */     int size = this.nsContext.count();
/*     */     
/* 149 */     for (int i = ns.getBase(); i < size; i++) {
/* 150 */       writeNsDecl(i);
/*     */     }
/*     */   }
/*     */   
/*     */   protected final void writeNsDecl(int prefixIndex)
/*     */     throws IOException
/*     */   {
/* 157 */     String p = this.nsContext.getPrefix(prefixIndex);
/*     */     
/* 159 */     if (p.length() == 0) {
/* 160 */       if ((this.nsContext.getCurrent().isRootElement()) && (this.nsContext.getNamespaceURI(prefixIndex).length() == 0))
/*     */       {
/* 162 */         return; }
/* 163 */       write(XMLNS_EQUALS);
/*     */     } else {
/* 165 */       Encoded e = this.prefixes[prefixIndex];
/* 166 */       write(XMLNS_COLON);
/* 167 */       write(e.buf, 0, e.len - 1);
/* 168 */       write(EQUALS);
/*     */     }
/* 170 */     doText(this.nsContext.getNamespaceURI(prefixIndex), true);
/* 171 */     write(34);
/*     */   }
/*     */   
/*     */   private void writePrefix(int prefix) throws IOException {
/* 175 */     this.prefixes[prefix].write(this);
/*     */   }
/*     */   
/*     */   private void writeName(Name name) throws IOException {
/* 179 */     writePrefix(this.nsUriIndex2prefixIndex[name.nsUriIndex]);
/* 180 */     this.localNames[name.localNameIndex].write(this);
/*     */   }
/*     */   
/*     */   private void writeName(int prefix, String localName) throws IOException {
/* 184 */     writePrefix(prefix);
/* 185 */     this.textBuffer.set(localName);
/* 186 */     this.textBuffer.write(this);
/*     */   }
/*     */   
/*     */   public void attribute(Name name, String value) throws IOException
/*     */   {
/* 191 */     write(32);
/* 192 */     if (name.nsUriIndex == -1) {
/* 193 */       this.localNames[name.localNameIndex].write(this);
/*     */     } else
/* 195 */       writeName(name);
/* 196 */     write(EQUALS);
/* 197 */     doText(value, true);
/* 198 */     write(34);
/*     */   }
/*     */   
/*     */   public void attribute(int prefix, String localName, String value) throws IOException {
/* 202 */     write(32);
/* 203 */     if (prefix == -1) {
/* 204 */       this.textBuffer.set(localName);
/* 205 */       this.textBuffer.write(this);
/*     */     } else {
/* 207 */       writeName(prefix, localName); }
/* 208 */     write(EQUALS);
/* 209 */     doText(value, true);
/* 210 */     write(34);
/*     */   }
/*     */   
/*     */   public void endStartTag() throws IOException {
/* 214 */     this.closeStartTagPending = true;
/*     */   }
/*     */   
/*     */   public void endTag(Name name) throws IOException
/*     */   {
/* 219 */     if (this.closeStartTagPending) {
/* 220 */       write(EMPTY_TAG);
/* 221 */       this.closeStartTagPending = false;
/*     */     } else {
/* 223 */       write(CLOSE_TAG);
/* 224 */       writeName(name);
/* 225 */       write(62);
/*     */     }
/*     */   }
/*     */   
/*     */   public void endTag(int prefix, String localName) throws IOException {
/* 230 */     if (this.closeStartTagPending) {
/* 231 */       write(EMPTY_TAG);
/* 232 */       this.closeStartTagPending = false;
/*     */     } else {
/* 234 */       write(CLOSE_TAG);
/* 235 */       writeName(prefix, localName);
/* 236 */       write(62);
/*     */     }
/*     */   }
/*     */   
/*     */   public void text(String value, boolean needSP) throws IOException {
/* 241 */     closeStartTag();
/* 242 */     if (needSP)
/* 243 */       write(32);
/* 244 */     doText(value, false);
/*     */   }
/*     */   
/*     */   public void text(Pcdata value, boolean needSP) throws IOException {
/* 248 */     closeStartTag();
/* 249 */     if (needSP)
/* 250 */       write(32);
/* 251 */     value.writeTo(this);
/*     */   }
/*     */   
/*     */   private void doText(String value, boolean isAttribute) throws IOException {
/* 255 */     this.textBuffer.setEscape(value, isAttribute);
/* 256 */     this.textBuffer.write(this);
/*     */   }
/*     */   
/*     */   public final void text(int value) throws IOException {
/* 260 */     closeStartTag();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 267 */     boolean minus = value < 0;
/* 268 */     this.textBuffer.ensureSize(11);
/* 269 */     byte[] buf = this.textBuffer.buf;
/* 270 */     int idx = 11;
/*     */     do
/*     */     {
/* 273 */       int r = value % 10;
/* 274 */       if (r < 0) r = -r;
/* 275 */       buf[(--idx)] = ((byte)(0x30 | r));
/* 276 */       value /= 10;
/* 277 */     } while (value != 0);
/*     */     
/* 279 */     if (minus) { buf[(--idx)] = 45;
/*     */     }
/* 281 */     write(buf, idx, 11 - idx);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void text(byte[] data, int dataLen)
/*     */     throws IOException
/*     */   {
/* 292 */     closeStartTag();
/*     */     
/* 294 */     int start = 0;
/*     */     
/* 296 */     while (dataLen > 0)
/*     */     {
/* 298 */       int batchSize = Math.min((this.octetBuffer.length - this.octetBufferIndex) / 4 * 3, dataLen);
/*     */       
/*     */ 
/* 301 */       this.octetBufferIndex = DatatypeConverterImpl._printBase64Binary(data, start, batchSize, this.octetBuffer, this.octetBufferIndex);
/*     */       
/* 303 */       if (batchSize < dataLen) {
/* 304 */         flushBuffer();
/*     */       }
/* 306 */       start += batchSize;
/* 307 */       dataLen -= batchSize;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void write(int i)
/*     */     throws IOException
/*     */   {
/* 326 */     if (this.octetBufferIndex < this.octetBuffer.length) {
/* 327 */       this.octetBuffer[(this.octetBufferIndex++)] = ((byte)i);
/*     */     } else {
/* 329 */       this.out.write(this.octetBuffer);
/* 330 */       this.octetBufferIndex = 1;
/* 331 */       this.octetBuffer[0] = ((byte)i);
/*     */     }
/*     */   }
/*     */   
/*     */   protected final void write(byte[] b) throws IOException {
/* 336 */     write(b, 0, b.length);
/*     */   }
/*     */   
/*     */   protected final void write(byte[] b, int start, int length) throws IOException {
/* 340 */     if (this.octetBufferIndex + length < this.octetBuffer.length) {
/* 341 */       System.arraycopy(b, start, this.octetBuffer, this.octetBufferIndex, length);
/* 342 */       this.octetBufferIndex += length;
/*     */     } else {
/* 344 */       this.out.write(this.octetBuffer, 0, this.octetBufferIndex);
/* 345 */       this.out.write(b, start, length);
/* 346 */       this.octetBufferIndex = 0;
/*     */     }
/*     */   }
/*     */   
/*     */   protected final void flushBuffer() throws IOException {
/* 351 */     this.out.write(this.octetBuffer, 0, this.octetBufferIndex);
/* 352 */     this.octetBufferIndex = 0;
/*     */   }
/*     */   
/*     */   public void flush() throws IOException {
/* 356 */     flushBuffer();
/* 357 */     this.out.flush();
/*     */   }
/*     */   
/*     */ 
/*     */   static byte[] toBytes(String s)
/*     */   {
/* 363 */     byte[] buf = new byte[s.length()];
/* 364 */     for (int i = s.length() - 1; i >= 0; i--)
/* 365 */       buf[i] = ((byte)s.charAt(i));
/* 366 */     return buf;
/*     */   }
/*     */   
/* 369 */   private static final byte[] XMLNS_EQUALS = toBytes(" xmlns=\"");
/* 370 */   private static final byte[] XMLNS_COLON = toBytes(" xmlns:");
/* 371 */   private static final byte[] EQUALS = toBytes("=\"");
/* 372 */   private static final byte[] CLOSE_TAG = toBytes("</");
/* 373 */   private static final byte[] EMPTY_TAG = toBytes("/>");
/* 374 */   private static final byte[] EMPTY_BYTE_ARRAY = new byte[0];
/* 375 */   private static final byte[] XML_DECL = toBytes("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>");
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\UTF8XmlOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */