/*      */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*      */ 
/*      */ import com.sun.istack.NotNull;
/*      */ import com.sun.istack.SAXParseException2;
/*      */ import com.sun.xml.bind.IDResolver;
/*      */ import com.sun.xml.bind.api.AccessorException;
/*      */ import com.sun.xml.bind.unmarshaller.InfosetScanner;
/*      */ import com.sun.xml.bind.v2.ClassFactory;
/*      */ import com.sun.xml.bind.v2.runtime.AssociationMap;
/*      */ import com.sun.xml.bind.v2.runtime.Coordinator;
/*      */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*      */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*      */ import java.lang.reflect.InvocationTargetException;
/*      */ import java.lang.reflect.Method;
/*      */ import java.util.ArrayList;
/*      */ import java.util.Collection;
/*      */ import java.util.Collections;
/*      */ import java.util.HashMap;
/*      */ import java.util.Iterator;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import java.util.concurrent.Callable;
/*      */ import javax.xml.bind.JAXBElement;
/*      */ import javax.xml.bind.UnmarshalException;
/*      */ import javax.xml.bind.ValidationEvent;
/*      */ import javax.xml.bind.ValidationEventHandler;
/*      */ import javax.xml.bind.ValidationEventLocator;
/*      */ import javax.xml.bind.helpers.ValidationEventImpl;
/*      */ import javax.xml.bind.helpers.ValidationEventLocatorImpl;
/*      */ import javax.xml.namespace.NamespaceContext;
/*      */ import javax.xml.namespace.QName;
/*      */ import org.xml.sax.ErrorHandler;
/*      */ import org.xml.sax.SAXException;
/*      */ import org.xml.sax.helpers.LocatorImpl;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public final class UnmarshallingContext
/*      */   extends Coordinator
/*      */   implements NamespaceContext, ValidationEventHandler, ErrorHandler, XmlVisitor, XmlVisitor.TextPredictor
/*      */ {
/*      */   private final State root;
/*      */   private State current;
/*      */   @NotNull
/*   64 */   private LocatorEx locator = DUMMY_INSTANCE;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private Object result;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private JaxBeanInfo expectedType;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private IDResolver idResolver;
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*   93 */   private boolean isUnmarshalInProgress = true;
/*   94 */   private boolean aborted = false;
/*      */   
/*      */ 
/*      */ 
/*      */   public final UnmarshallerImpl parent;
/*      */   
/*      */ 
/*      */ 
/*      */   private final AssociationMap assoc;
/*      */   
/*      */ 
/*      */ 
/*      */   private boolean isInplaceMode;
/*      */   
/*      */ 
/*      */ 
/*      */   private InfosetScanner scanner;
/*      */   
/*      */ 
/*      */ 
/*      */   private Object currentElement;
/*      */   
/*      */ 
/*      */ 
/*      */   private NamespaceContext environmentNamespaceContext;
/*      */   
/*      */ 
/*      */ 
/*      */   private final Map<Class, Factory> factories;
/*      */   
/*      */ 
/*      */ 
/*      */   private Patcher[] patchers;
/*      */   
/*      */ 
/*      */ 
/*      */   private int patchersLen;
/*      */   
/*      */ 
/*      */ 
/*      */   private String[] nsBind;
/*      */   
/*      */ 
/*      */   private int nsLen;
/*      */   
/*      */ 
/*      */   private Scope[] scopes;
/*      */   
/*      */ 
/*      */   private int scopeTop;
/*      */   
/*      */ 
/*      */   private static final Loader DEFAULT_ROOT_LOADER;
/*      */   
/*      */ 
/*      */   private static final Loader EXPECTED_TYPE_ROOT_LOADER;
/*      */   
/*      */ 
/*      */   private static final LocatorEx DUMMY_INSTANCE;
/*      */   
/*      */ 
/*      */ 
/*      */   public final class State
/*      */   {
/*      */     public Loader loader;
/*      */     
/*      */ 
/*      */     public Receiver receiver;
/*      */     
/*      */ 
/*      */     public Intercepter intercepter;
/*      */     
/*      */ 
/*      */     public Object target;
/*      */     
/*      */ 
/*      */     public Object backup;
/*      */     
/*      */ 
/*      */     private int numNsDecl;
/*      */     
/*      */ 
/*      */     public String elementDefaultValue;
/*      */     
/*      */ 
/*      */     public final State prev;
/*      */     
/*      */ 
/*      */     private State next;
/*      */     
/*      */ 
/*      */ 
/*      */     public UnmarshallingContext getContext()
/*      */     {
/*  188 */       return UnmarshallingContext.this;
/*      */     }
/*      */     
/*      */     private State(State prev) {
/*  192 */       this.prev = prev;
/*  193 */       if (prev != null)
/*  194 */         prev.next = this;
/*      */     }
/*      */     
/*      */     private void push() {
/*  198 */       if (this.next == null)
/*  199 */         UnmarshallingContext.this.allocateMoreStates();
/*  200 */       State n = this.next;
/*  201 */       n.numNsDecl = UnmarshallingContext.this.nsLen;
/*  202 */       UnmarshallingContext.this.current = n;
/*      */     }
/*      */     
/*      */     private void pop() {
/*  206 */       assert (this.prev != null);
/*  207 */       this.loader = null;
/*  208 */       this.receiver = null;
/*  209 */       this.intercepter = null;
/*  210 */       this.elementDefaultValue = null;
/*  211 */       this.target = null;
/*  212 */       UnmarshallingContext.this.current = this.prev;
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private static class Factory
/*      */   {
/*      */     private final Object factorInstance;
/*      */     private final Method method;
/*      */     
/*      */     public Factory(Object factorInstance, Method method)
/*      */     {
/*  224 */       this.factorInstance = factorInstance;
/*  225 */       this.method = method;
/*      */     }
/*      */     
/*      */     public Object createInstance() throws SAXException {
/*      */       try {
/*  230 */         return this.method.invoke(this.factorInstance, new Object[0]);
/*      */       } catch (IllegalAccessException e) {
/*  232 */         UnmarshallingContext.getInstance().handleError(e, false);
/*      */       } catch (InvocationTargetException e) {
/*  234 */         UnmarshallingContext.getInstance().handleError(e, false);
/*      */       }
/*  236 */       return null;
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public UnmarshallingContext(UnmarshallerImpl _parent, AssociationMap assoc)
/*      */   {
/*  289 */     this.factories = new HashMap();
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  592 */     this.patchers = null;
/*  593 */     this.patchersLen = 0;
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  677 */     this.nsBind = new String[16];
/*  678 */     this.nsLen = 0;
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  812 */     this.scopes = new Scope[16];
/*      */     
/*      */ 
/*      */ 
/*  816 */     this.scopeTop = 0;
/*      */     
/*      */ 
/*  819 */     for (int i = 0; i < this.scopes.length; i++) {
/*  820 */       this.scopes[i] = new Scope(this);
/*      */     }
/*  249 */     this.parent = _parent;
/*  250 */     this.assoc = assoc;
/*  251 */     this.root = (this.current = new State(null, null));
/*  252 */     allocateMoreStates();
/*      */   }
/*      */   
/*      */   public void reset(InfosetScanner scanner, boolean isInplaceMode, JaxBeanInfo expectedType, IDResolver idResolver) {
/*  256 */     this.scanner = scanner;
/*  257 */     this.isInplaceMode = isInplaceMode;
/*  258 */     this.expectedType = expectedType;
/*  259 */     this.idResolver = idResolver;
/*      */   }
/*      */   
/*      */   public JAXBContextImpl getJAXBContext() {
/*  263 */     return this.parent.context;
/*      */   }
/*      */   
/*      */   public State getCurrentState() {
/*  267 */     return this.current;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private void allocateMoreStates()
/*      */   {
/*  279 */     assert (this.current.next == null);
/*      */     
/*  281 */     State s = this.current;
/*  282 */     for (int i = 0; i < 8; i++) {
/*  283 */       s = new State(s, null);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setFactories(Object factoryInstances)
/*      */   {
/*  292 */     this.factories.clear();
/*  293 */     if (factoryInstances == null) {
/*  294 */       return;
/*      */     }
/*  296 */     if ((factoryInstances instanceof Object[])) {
/*  297 */       for (Object factory : (Object[])factoryInstances)
/*      */       {
/*  299 */         addFactory(factory);
/*      */       }
/*      */     } else {
/*  302 */       addFactory(factoryInstances);
/*      */     }
/*      */   }
/*      */   
/*      */   private void addFactory(Object factory) {
/*  307 */     for (Method m : factory.getClass().getMethods())
/*      */     {
/*  309 */       if (m.getName().startsWith("create"))
/*      */       {
/*  311 */         if (m.getParameterTypes().length <= 0)
/*      */         {
/*      */ 
/*  314 */           Class type = m.getReturnType();
/*      */           
/*  316 */           this.factories.put(type, new Factory(factory, m));
/*      */         } } }
/*      */   }
/*      */   
/*      */   public void startDocument(LocatorEx locator, NamespaceContext nsContext) throws SAXException {
/*  321 */     this.locator = locator;
/*  322 */     this.environmentNamespaceContext = nsContext;
/*      */     
/*  324 */     this.result = null;
/*  325 */     this.current = this.root;
/*      */     
/*  327 */     this.patchersLen = 0;
/*  328 */     this.aborted = false;
/*  329 */     this.isUnmarshalInProgress = true;
/*  330 */     this.nsLen = 0;
/*      */     
/*  332 */     startPrefixMapping("", "");
/*      */     
/*  334 */     setThreadAffinity();
/*      */     
/*  336 */     if (this.expectedType != null) {
/*  337 */       this.root.loader = EXPECTED_TYPE_ROOT_LOADER;
/*      */     } else {
/*  339 */       this.root.loader = DEFAULT_ROOT_LOADER;
/*      */     }
/*  341 */     this.idResolver.startDocument(this);
/*      */   }
/*      */   
/*      */   public void startElement(TagName tagName) throws SAXException {
/*  345 */     pushCoordinator();
/*      */     try {
/*  347 */       _startElement(tagName);
/*      */     } finally {
/*  349 */       popCoordinator();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private void _startElement(TagName tagName)
/*      */     throws SAXException
/*      */   {
/*  359 */     if (this.assoc != null) {
/*  360 */       this.currentElement = this.scanner.getCurrentElement();
/*      */     }
/*  362 */     Loader h = this.current.loader;
/*  363 */     this.current.push();
/*      */     
/*      */ 
/*  366 */     h.childElement(this.current, tagName);
/*  367 */     assert (this.current.loader != null);
/*      */     
/*  369 */     this.current.loader.startElement(this.current, tagName);
/*      */   }
/*      */   
/*      */   public void text(CharSequence pcdata) throws SAXException {
/*  373 */     State cur = this.current;
/*  374 */     pushCoordinator();
/*      */     try {
/*  376 */       if ((cur.elementDefaultValue != null) && 
/*  377 */         (pcdata.length() == 0))
/*      */       {
/*  379 */         pcdata = cur.elementDefaultValue;
/*      */       }
/*      */       
/*  382 */       cur.loader.text(cur, pcdata);
/*      */     } finally {
/*  384 */       popCoordinator();
/*      */     }
/*      */   }
/*      */   
/*      */   public final void endElement(TagName tagName) throws SAXException {
/*  389 */     pushCoordinator();
/*      */     try {
/*  391 */       State child = this.current;
/*      */       
/*      */ 
/*  394 */       child.loader.leaveElement(child, tagName);
/*      */       
/*      */ 
/*  397 */       Object target = child.target;
/*  398 */       Receiver recv = child.receiver;
/*  399 */       Intercepter intercepter = child.intercepter;
/*  400 */       child.pop();
/*      */       
/*      */ 
/*  403 */       if (intercepter != null)
/*  404 */         target = intercepter.intercept(this.current, target);
/*  405 */       if (recv != null)
/*  406 */         recv.receive(this.current, target);
/*      */     } finally {
/*  408 */       popCoordinator();
/*      */     }
/*      */   }
/*      */   
/*      */   public void endDocument() throws SAXException {
/*  413 */     runPatchers();
/*  414 */     this.idResolver.endDocument();
/*      */     
/*  416 */     this.isUnmarshalInProgress = false;
/*  417 */     this.currentElement = null;
/*  418 */     this.locator = DUMMY_INSTANCE;
/*  419 */     this.environmentNamespaceContext = null;
/*      */     
/*      */ 
/*  422 */     assert (this.root == this.current);
/*      */     
/*  424 */     resetThreadAffinity();
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public boolean expectText()
/*      */   {
/*  432 */     return this.current.loader.expectText;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   @Deprecated
/*      */   public XmlVisitor.TextPredictor getPredictor()
/*      */   {
/*  440 */     return this;
/*      */   }
/*      */   
/*      */   public UnmarshallingContext getContext() {
/*  444 */     return this;
/*      */   }
/*      */   
/*      */ 
/*      */   public Object getResult()
/*      */     throws UnmarshalException
/*      */   {
/*  451 */     if (this.isUnmarshalInProgress) {
/*  452 */       throw new IllegalStateException();
/*      */     }
/*  454 */     if (!this.aborted) { return this.result;
/*      */     }
/*      */     
/*  457 */     throw new UnmarshalException((String)null);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   public Object createInstance(Class<?> clazz)
/*      */     throws SAXException
/*      */   {
/*  465 */     if (!this.factories.isEmpty()) {
/*  466 */       Factory factory = (Factory)this.factories.get(clazz);
/*  467 */       if (factory != null)
/*  468 */         return factory.createInstance();
/*      */     }
/*  470 */     return ClassFactory.create(clazz);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   public Object createInstance(JaxBeanInfo beanInfo)
/*      */     throws SAXException
/*      */   {
/*  478 */     if (!this.factories.isEmpty()) {
/*  479 */       Factory factory = (Factory)this.factories.get(beanInfo.jaxbType);
/*  480 */       if (factory != null)
/*  481 */         return factory.createInstance();
/*      */     }
/*      */     try {
/*  484 */       return beanInfo.createInstance(this);
/*      */     } catch (IllegalAccessException e) {
/*  486 */       Loader.reportError("Unable to create an instance of " + beanInfo.jaxbType.getName(), e, false);
/*      */     } catch (InvocationTargetException e) {
/*  488 */       Loader.reportError("Unable to create an instance of " + beanInfo.jaxbType.getName(), e, false);
/*      */     } catch (InstantiationException e) {
/*  490 */       Loader.reportError("Unable to create an instance of " + beanInfo.jaxbType.getName(), e, false);
/*      */     }
/*  492 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void handleEvent(ValidationEvent event, boolean canRecover)
/*      */     throws SAXException
/*      */   {
/*  514 */     ValidationEventHandler eventHandler = this.parent.getEventHandler();
/*      */     
/*  516 */     boolean recover = eventHandler.handleEvent(event);
/*      */     
/*      */ 
/*      */ 
/*  520 */     if (!recover) { this.aborted = true;
/*      */     }
/*  522 */     if ((!canRecover) || (!recover)) {
/*  523 */       throw new SAXParseException2(event.getMessage(), this.locator, new UnmarshalException(event.getMessage(), event.getLinkedException()));
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   public boolean handleEvent(ValidationEvent event)
/*      */   {
/*      */     try
/*      */     {
/*  532 */       boolean recover = this.parent.getEventHandler().handleEvent(event);
/*  533 */       if (!recover) this.aborted = true;
/*  534 */       return recover;
/*      */     }
/*      */     catch (RuntimeException re) {}
/*      */     
/*  538 */     return false;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void handleError(Exception e)
/*      */     throws SAXException
/*      */   {
/*  548 */     handleError(e, true);
/*      */   }
/*      */   
/*      */   public void handleError(Exception e, boolean canRecover) throws SAXException {
/*  552 */     handleEvent(new ValidationEventImpl(1, e.getMessage(), this.locator.getLocation(), e), canRecover);
/*      */   }
/*      */   
/*      */   public void handleError(String msg) {
/*  556 */     handleEvent(new ValidationEventImpl(1, msg, this.locator.getLocation()));
/*      */   }
/*      */   
/*      */   protected ValidationEventLocator getLocation() {
/*  560 */     return this.locator.getLocation();
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public LocatorEx getLocator()
/*      */   {
/*  569 */     return this.locator;
/*      */   }
/*      */   
/*      */   public void errorUnresolvedIDREF(Object bean, String idref)
/*      */     throws SAXException
/*      */   {
/*  575 */     handleEvent(new ValidationEventImpl(1, Messages.UNRESOLVED_IDREF.format(new Object[] { idref }), new ValidationEventLocatorImpl(bean)), true);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void addPatcher(Patcher job)
/*      */   {
/*  605 */     if (this.patchers == null)
/*  606 */       this.patchers = new Patcher[32];
/*  607 */     if (this.patchers.length == this.patchersLen) {
/*  608 */       Patcher[] buf = new Patcher[this.patchersLen * 2];
/*  609 */       System.arraycopy(this.patchers, 0, buf, 0, this.patchersLen);
/*  610 */       this.patchers = buf;
/*      */     }
/*  612 */     this.patchers[(this.patchersLen++)] = job;
/*      */   }
/*      */   
/*      */   private void runPatchers() throws SAXException
/*      */   {
/*  617 */     if (this.patchers != null) {
/*  618 */       for (int i = 0; i < this.patchersLen; i++) {
/*  619 */         this.patchers[i].run();
/*  620 */         this.patchers[i] = null;
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public String addToIdTable(String id)
/*      */     throws SAXException
/*      */   {
/*  652 */     Object o = this.current.target;
/*  653 */     if (o == null)
/*  654 */       o = this.current.prev.target;
/*  655 */     this.idResolver.bind(id, o);
/*  656 */     return id;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Callable getObjectFromId(String id, Class targetType)
/*      */     throws SAXException
/*      */   {
/*  669 */     return this.idResolver.resolve(id, targetType);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void startPrefixMapping(String prefix, String uri)
/*      */   {
/*  681 */     if (this.nsBind.length == this.nsLen)
/*      */     {
/*  683 */       String[] n = new String[this.nsLen * 2];
/*  684 */       System.arraycopy(this.nsBind, 0, n, 0, this.nsLen);
/*  685 */       this.nsBind = n;
/*      */     }
/*  687 */     this.nsBind[(this.nsLen++)] = prefix;
/*  688 */     this.nsBind[(this.nsLen++)] = uri;
/*      */   }
/*      */   
/*  691 */   public void endPrefixMapping(String prefix) { this.nsLen -= 2; }
/*      */   
/*      */   private String resolveNamespacePrefix(String prefix) {
/*  694 */     if (prefix.equals("xml")) {
/*  695 */       return "http://www.w3.org/XML/1998/namespace";
/*      */     }
/*  697 */     for (int i = this.nsLen - 2; i >= 0; i -= 2) {
/*  698 */       if (prefix.equals(this.nsBind[i])) {
/*  699 */         return this.nsBind[(i + 1)];
/*      */       }
/*      */     }
/*  702 */     if (this.environmentNamespaceContext != null)
/*      */     {
/*  704 */       return this.environmentNamespaceContext.getNamespaceURI(prefix.intern());
/*      */     }
/*  706 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public String[] getNewlyDeclaredPrefixes()
/*      */   {
/*  717 */     return getPrefixList(this.current.prev.numNsDecl);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public String[] getAllDeclaredPrefixes()
/*      */   {
/*  728 */     return getPrefixList(2);
/*      */   }
/*      */   
/*      */   private String[] getPrefixList(int startIndex) {
/*  732 */     int size = (this.current.numNsDecl - startIndex) / 2;
/*  733 */     String[] r = new String[size];
/*  734 */     for (int i = 0; i < r.length; i++)
/*  735 */       r[i] = this.nsBind[(startIndex + i * 2)];
/*  736 */     return r;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Iterator<String> getPrefixes(String uri)
/*      */   {
/*  747 */     return Collections.unmodifiableList(getAllPrefixesInList(uri)).iterator();
/*      */   }
/*      */   
/*      */   private List<String> getAllPrefixesInList(String uri)
/*      */   {
/*  752 */     List<String> a = new ArrayList();
/*      */     
/*  754 */     if (uri == null)
/*  755 */       throw new IllegalArgumentException();
/*  756 */     if (uri.equals("http://www.w3.org/XML/1998/namespace")) {
/*  757 */       a.add("xml");
/*  758 */       return a;
/*      */     }
/*  760 */     if (uri.equals("http://www.w3.org/2000/xmlns/")) {
/*  761 */       a.add("xmlns");
/*  762 */       return a;
/*      */     }
/*      */     
/*  765 */     for (int i = this.nsLen - 2; i >= 0; i -= 2) {
/*  766 */       if ((uri.equals(this.nsBind[(i + 1)])) && 
/*  767 */         (getNamespaceURI(this.nsBind[i]).equals(this.nsBind[(i + 1)])))
/*      */       {
/*  769 */         a.add(this.nsBind[i]); }
/*      */     }
/*  771 */     return a;
/*      */   }
/*      */   
/*      */   public String getPrefix(String uri) {
/*  775 */     if (uri == null)
/*  776 */       throw new IllegalArgumentException();
/*  777 */     if (uri.equals("http://www.w3.org/XML/1998/namespace"))
/*  778 */       return "xml";
/*  779 */     if (uri.equals("http://www.w3.org/2000/xmlns/")) {
/*  780 */       return "xmlns";
/*      */     }
/*  782 */     for (int i = this.nsLen - 2; i >= 0; i -= 2) {
/*  783 */       if ((uri.equals(this.nsBind[(i + 1)])) && 
/*  784 */         (getNamespaceURI(this.nsBind[i]).equals(this.nsBind[(i + 1)])))
/*      */       {
/*  786 */         return this.nsBind[i]; }
/*      */     }
/*  788 */     if (this.environmentNamespaceContext != null) {
/*  789 */       return this.environmentNamespaceContext.getPrefix(uri);
/*      */     }
/*  791 */     return null;
/*      */   }
/*      */   
/*      */   public String getNamespaceURI(String prefix) {
/*  795 */     if (prefix == null)
/*  796 */       throw new IllegalArgumentException();
/*  797 */     if (prefix.equals("xmlns")) {
/*  798 */       return "http://www.w3.org/2000/xmlns/";
/*      */     }
/*  800 */     return resolveNamespacePrefix(prefix);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void startScope(int frameSize)
/*      */   {
/*  839 */     this.scopeTop += frameSize;
/*      */     
/*      */ 
/*  842 */     if (this.scopeTop >= this.scopes.length) {
/*  843 */       Scope[] s = new Scope[Math.max(this.scopeTop + 1, this.scopes.length * 2)];
/*  844 */       System.arraycopy(this.scopes, 0, s, 0, this.scopes.length);
/*  845 */       for (int i = this.scopes.length; i < s.length; i++)
/*  846 */         s[i] = new Scope(this);
/*  847 */       this.scopes = s;
/*      */     }
/*      */   }
/*      */   
/*      */   public void endScope(int frameSize)
/*      */     throws SAXException
/*      */   {
/*      */     try
/*      */     {
/*  863 */       for (; 
/*      */           
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  863 */           frameSize > 0; frameSize--)
/*  864 */         this.scopes[(this.scopeTop--)].finish();
/*      */     } catch (AccessorException e) {
/*  866 */       handleError(e);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Scope getScope(int offset)
/*      */   {
/*  880 */     return this.scopes[(this.scopeTop - offset)];
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private static final class DefaultRootLoader
/*      */     extends Loader
/*      */     implements Receiver
/*      */   {
/*      */     public void childElement(UnmarshallingContext.State state, TagName ea)
/*      */       throws SAXException
/*      */     {
/*  906 */       JAXBContextImpl jaxbContext = state.getContext().getJAXBContext();
/*      */       
/*  908 */       Loader loader = jaxbContext.selectRootLoader(state, ea);
/*  909 */       if (loader != null) {
/*  910 */         state.loader = loader;
/*  911 */         state.receiver = this;
/*  912 */         return;
/*      */       }
/*      */       
/*      */ 
/*      */ 
/*  917 */       JaxBeanInfo beanInfo = XsiTypeLoader.parseXsiType(state, ea);
/*  918 */       if (beanInfo == null)
/*      */       {
/*  920 */         reportUnexpectedChildElement(ea, false);
/*  921 */         return;
/*      */       }
/*      */       
/*  924 */       state.loader = beanInfo.getLoader(null, false);
/*  925 */       state.prev.backup = new JAXBElement(ea.createQName(), Object.class, null);
/*  926 */       state.receiver = this;
/*      */     }
/*      */     
/*      */     public Collection<QName> getExpectedChildElements()
/*      */     {
/*  931 */       return UnmarshallingContext.getInstance().getJAXBContext().getValidRootNames();
/*      */     }
/*      */     
/*      */     public void receive(UnmarshallingContext.State state, Object o) {
/*  935 */       if (state.backup != null) {
/*  936 */         ((JAXBElement)state.backup).setValue(o);
/*  937 */         o = state.backup;
/*      */       }
/*  939 */       state.getContext().result = o;
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private static final class ExpectedTypeRootLoader
/*      */     extends Loader
/*      */     implements Receiver
/*      */   {
/*      */     public void childElement(UnmarshallingContext.State state, TagName ea)
/*      */     {
/*  953 */       UnmarshallingContext context = state.getContext();
/*      */       
/*      */ 
/*  956 */       QName qn = new QName(ea.uri, ea.local);
/*  957 */       state.prev.target = new JAXBElement(qn, context.expectedType.jaxbType, null, null);
/*  958 */       state.receiver = this;
/*      */       
/*      */ 
/*      */ 
/*      */ 
/*  963 */       state.loader = new XsiNilLoader(context.expectedType.getLoader(null, true));
/*      */     }
/*      */     
/*      */     public void receive(UnmarshallingContext.State state, Object o) {
/*  967 */       JAXBElement e = (JAXBElement)state.target;
/*  968 */       e.setValue(o);
/*  969 */       state.getContext().recordOuterPeer(e);
/*  970 */       state.getContext().result = e;
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void recordInnerPeer(Object innerPeer)
/*      */   {
/*  987 */     if (this.assoc != null) {
/*  988 */       this.assoc.addInner(this.currentElement, innerPeer);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Object getInnerPeer()
/*      */   {
/*  999 */     if ((this.assoc != null) && (this.isInplaceMode)) {
/* 1000 */       return this.assoc.getInnerPeer(this.currentElement);
/*      */     }
/* 1002 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void recordOuterPeer(Object outerPeer)
/*      */   {
/* 1013 */     if (this.assoc != null) {
/* 1014 */       this.assoc.addOuter(this.currentElement, outerPeer);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public Object getOuterPeer()
/*      */   {
/* 1025 */     if ((this.assoc != null) && (this.isInplaceMode)) {
/* 1026 */       return this.assoc.getOuterPeer(this.currentElement);
/*      */     }
/* 1028 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public String getXMIMEContentType()
/*      */   {
/* 1050 */     Object t = this.current.target;
/* 1051 */     if (t == null) return null;
/* 1052 */     return getJAXBContext().getXMIMEContentType(t);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public static UnmarshallingContext getInstance()
/*      */   {
/* 1060 */     return (UnmarshallingContext)Coordinator._getInstance();
/*      */   }
/*      */   
/*      */   static
/*      */   {
/*  893 */     DEFAULT_ROOT_LOADER = new DefaultRootLoader(null);
/*  894 */     EXPECTED_TYPE_ROOT_LOADER = new ExpectedTypeRootLoader(null);
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 1066 */     LocatorImpl loc = new LocatorImpl();
/* 1067 */     loc.setPublicId(null);
/* 1068 */     loc.setSystemId(null);
/* 1069 */     loc.setLineNumber(-1);
/* 1070 */     loc.setColumnNumber(-1);
/* 1071 */     DUMMY_INSTANCE = new LocatorExWrapper(loc);
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\UnmarshallingContext.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */