/*     */ package net.rubyeye.xmemcached.utils;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import com.google.code.yanf4j.util.ByteBufferMatcher;
/*     */ import java.io.UnsupportedEncodingException;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.nio.charset.Charset;
/*     */ import net.rubyeye.xmemcached.codec.MemcachedDecoder;
/*     */ import net.rubyeye.xmemcached.monitor.Constants;
/*     */ import org.slf4j.Logger;
/*     */ import org.slf4j.LoggerFactory;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ByteUtils
/*     */ {
/*  33 */   public static final Logger log = LoggerFactory.getLogger(ByteUtils.class);
/*     */   public static final String DEFAULT_CHARSET_NAME = "utf-8";
/*  35 */   public static final Charset DEFAULT_CHARSET = Charset.forName("utf-8");
/*  36 */   public static final ByteBuffer SPLIT = ByteBuffer.wrap(Constants.CRLF);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static boolean testing;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final byte[] getBytes(String k)
/*     */   {
/*  49 */     if ((k == null) || (k.length() == 0)) {
/*  50 */       throw new IllegalArgumentException("Key must not be blank");
/*     */     }
/*     */     try {
/*  53 */       return k.getBytes("utf-8");
/*     */     }
/*     */     catch (UnsupportedEncodingException e) {
/*  56 */       throw new RuntimeException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public static final void setArguments(IoBuffer bb, Object... args)
/*     */   {
/*  62 */     boolean wasFirst = true;
/*  63 */     for (Object o : args) {
/*  64 */       if (wasFirst) {
/*  65 */         wasFirst = false;
/*     */       }
/*     */       else {
/*  68 */         bb.put((byte)32);
/*     */       }
/*  70 */       if ((o instanceof byte[])) {
/*  71 */         bb.put((byte[])o);
/*     */       }
/*     */       else {
/*  74 */         bb.put(getBytes(String.valueOf(o)));
/*     */       }
/*     */     }
/*  77 */     bb.put(Constants.CRLF);
/*     */   }
/*     */   
/*     */   public static final int setArguments(byte[] bb, int index, Object... args)
/*     */   {
/*  82 */     boolean wasFirst = true;
/*  83 */     int s = index;
/*  84 */     for (Object o : args) {
/*  85 */       if (wasFirst) {
/*  86 */         wasFirst = false;
/*     */       }
/*     */       else {
/*  89 */         bb[(s++)] = 32;
/*     */       }
/*  91 */       if ((o instanceof byte[])) {
/*  92 */         byte[] tmp = (byte[])o;
/*  93 */         System.arraycopy(tmp, 0, bb, s, tmp.length);
/*  94 */         s += tmp.length;
/*     */       }
/*  96 */       else if ((o instanceof Integer)) {
/*  97 */         int v = ((Integer)o).intValue();
/*  98 */         s += stringSize(v);
/*  99 */         getBytes(v, s, bb);
/*     */       }
/* 101 */       else if ((o instanceof String)) {
/* 102 */         byte[] tmp = getBytes((String)o);
/* 103 */         System.arraycopy(tmp, 0, bb, s, tmp.length);
/* 104 */         s += tmp.length;
/*     */       }
/* 106 */       else if ((o instanceof Long)) {
/* 107 */         long v = ((Long)o).longValue();
/* 108 */         s += stringSize(v);
/* 109 */         getBytes(v, s, bb);
/*     */       }
/*     */     }
/*     */     
/* 113 */     System.arraycopy(Constants.CRLF, 0, bb, s, 2);
/* 114 */     s += 2;
/* 115 */     return s;
/*     */   }
/*     */   
/*     */ 
/*     */   public static final void checkKey(byte[] keyBytes)
/*     */   {
/* 121 */     if (keyBytes.length > maxKeyLength) {
/* 122 */       throw new IllegalArgumentException("Key is too long (maxlen = " + maxKeyLength + ")");
/*     */     }
/*     */     
/* 125 */     if ((memcachedProtocol == Protocol.Text) || (testing)) {
/* 126 */       for (byte b : keyBytes) {
/* 127 */         if ((b == 32) || (b == 10) || (b == 13) || (b == 0)) {
/*     */           try {
/* 129 */             throw new IllegalArgumentException("Key contains invalid characters:  " + new String(keyBytes, "utf-8"));
/*     */           }
/*     */           catch (UnsupportedEncodingException e) {}
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final void checkKey(String key)
/*     */   {
/* 143 */     if ((key == null) || (key.length() == 0)) {
/* 144 */       throw new IllegalArgumentException("Key must not be blank");
/*     */     }
/* 146 */     byte[] keyBytes = getBytes(key);
/* 147 */     if (keyBytes.length > maxKeyLength) {
/* 148 */       throw new IllegalArgumentException("Key is too long (maxlen = " + maxKeyLength + ")");
/*     */     }
/* 150 */     if ((memcachedProtocol == Protocol.Text) || (testing))
/*     */     {
/* 152 */       for (byte b : keyBytes) {
/* 153 */         if ((b == 32) || (b == 10) || (b == 13) || (b == 0)) {
/*     */           try {
/* 155 */             throw new IllegalArgumentException("Key contains invalid characters:" + new String(keyBytes, "utf-8"));
/*     */           }
/*     */           catch (UnsupportedEncodingException e) {}
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 167 */   private static Protocol memcachedProtocol = Protocol.Text;
/*     */   
/* 169 */   private static int maxKeyLength = 250;
/*     */   
/*     */   public static void setProtocol(Protocol protocol)
/*     */   {
/* 173 */     if (protocol == null) {
/* 174 */       throw new NullPointerException("Null Protocol");
/*     */     }
/* 176 */     memcachedProtocol = protocol;
/* 177 */     if (protocol == Protocol.Text) {
/* 178 */       maxKeyLength = 250;
/*     */     }
/*     */     else {
/* 181 */       maxKeyLength = 65535;
/*     */     }
/*     */   }
/*     */   
/*     */   public static final int normalizeCapacity(int requestedCapacity)
/*     */   {
/* 187 */     switch (requestedCapacity) {
/*     */     case 0: 
/*     */     case 1: 
/*     */     case 2: 
/*     */     case 4: 
/*     */     case 8: 
/*     */     case 16: 
/*     */     case 32: 
/*     */     case 64: 
/*     */     case 128: 
/*     */     case 256: 
/*     */     case 512: 
/*     */     case 1024: 
/*     */     case 2048: 
/*     */     case 4096: 
/*     */     case 8192: 
/*     */     case 16384: 
/*     */     case 32768: 
/*     */     case 65536: 
/*     */     case 131072: 
/*     */     case 262144: 
/*     */     case 524288: 
/*     */     case 2097152: 
/*     */     case 4194304: 
/*     */     case 8388608: 
/*     */     case 16777216: 
/*     */     case 33554432: 
/*     */     case 67108864: 
/*     */     case 134217728: 
/*     */     case 268435456: 
/*     */     case 536870912: 
/*     */     case 1073741824: 
/*     */     case 2147483647: 
/* 220 */       return requestedCapacity;
/*     */     }
/*     */     
/* 223 */     int newCapacity = 1;
/* 224 */     while (newCapacity < requestedCapacity) {
/* 225 */       newCapacity <<= 1;
/* 226 */       if (newCapacity < 0) {
/* 227 */         return Integer.MAX_VALUE;
/*     */       }
/*     */     }
/* 230 */     return newCapacity;
/*     */   }
/*     */   
/*     */   public static final boolean stepBuffer(ByteBuffer buffer, int remaining)
/*     */   {
/* 235 */     if (buffer.remaining() >= remaining) {
/* 236 */       buffer.position(buffer.position() + remaining);
/* 237 */       return true;
/*     */     }
/*     */     
/* 240 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final String nextLine(ByteBuffer buffer)
/*     */   {
/* 251 */     if (buffer == null) {
/* 252 */       return null;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 258 */     int index = MemcachedDecoder.SPLIT_MATCHER.matchFirst(IoBuffer.wrap(buffer));
/* 259 */     if (index >= 0) {
/* 260 */       int limit = buffer.limit();
/* 261 */       buffer.limit(index);
/* 262 */       byte[] bytes = new byte[buffer.remaining()];
/* 263 */       buffer.get(bytes);
/* 264 */       buffer.limit(limit);
/* 265 */       buffer.position(index + SPLIT.remaining());
/* 266 */       return getString(bytes);
/*     */     }
/*     */     
/* 269 */     return null;
/*     */   }
/*     */   
/*     */   public static String getString(byte[] bytes)
/*     */   {
/*     */     try {
/* 275 */       return new String(bytes, "utf-8");
/*     */     }
/*     */     catch (UnsupportedEncodingException e) {
/* 278 */       throw new RuntimeException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public static void byte2hex(byte b, StringBuffer buf)
/*     */   {
/* 284 */     char[] hexChars = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
/* 285 */     int high = (b & 0xF0) >> 4;
/* 286 */     int low = b & 0xF;
/* 287 */     buf.append(hexChars[high]);
/* 288 */     buf.append(hexChars[low]);
/*     */   }
/*     */   
/*     */   public static void int2hex(int a, StringBuffer str)
/*     */   {
/* 293 */     str.append(Integer.toHexString(a));
/*     */   }
/*     */   
/*     */   public static void short2hex(int a, StringBuffer str)
/*     */   {
/* 298 */     str.append(Integer.toHexString(a));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static void getBytes(long i, int index, byte[] buf)
/*     */   {
/* 305 */     int pos = index;
/* 306 */     byte sign = 0;
/*     */     
/* 308 */     if (i < 0L) {
/* 309 */       sign = 45;
/* 310 */       i = -i;
/*     */     }
/*     */     
/*     */ 
/* 314 */     while (i > 2147483647L) {
/* 315 */       long q = i / 100L;
/*     */       
/* 317 */       int r = (int)(i - ((q << 6) + (q << 5) + (q << 2)));
/* 318 */       i = q;
/* 319 */       buf[(--pos)] = DigitOnes[r];
/* 320 */       buf[(--pos)] = DigitTens[r];
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 325 */     int i2 = (int)i;
/* 326 */     while (i2 >= 65536) {
/* 327 */       int q2 = i2 / 100;
/*     */       
/* 329 */       int r = i2 - ((q2 << 6) + (q2 << 5) + (q2 << 2));
/* 330 */       i2 = q2;
/* 331 */       buf[(--pos)] = DigitOnes[r];
/* 332 */       buf[(--pos)] = DigitTens[r];
/*     */     }
/*     */     
/*     */ 
/*     */     for (;;)
/*     */     {
/* 338 */       int q2 = i2 * 52429 >>> 19;
/* 339 */       int r = i2 - ((q2 << 3) + (q2 << 1));
/* 340 */       buf[(--pos)] = digits[r];
/* 341 */       i2 = q2;
/* 342 */       if (i2 == 0)
/*     */         break;
/*     */     }
/* 345 */     if (sign != 0) {
/* 346 */       buf[(--pos)] = sign;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   static void getBytes(int i, int index, byte[] buf)
/*     */   {
/* 361 */     int pos = index;
/* 362 */     byte sign = 0;
/*     */     
/* 364 */     if (i < 0) {
/* 365 */       sign = 45;
/* 366 */       i = -i;
/*     */     }
/*     */     
/*     */ 
/* 370 */     while (i >= 65536) {
/* 371 */       int q = i / 100;
/*     */       
/* 373 */       int r = i - ((q << 6) + (q << 5) + (q << 2));
/* 374 */       i = q;
/* 375 */       buf[(--pos)] = DigitOnes[r];
/* 376 */       buf[(--pos)] = DigitTens[r];
/*     */     }
/*     */     
/*     */ 
/*     */     for (;;)
/*     */     {
/* 382 */       int q = i * 52429 >>> 19;
/* 383 */       int r = i - ((q << 3) + (q << 1));
/* 384 */       buf[(--pos)] = digits[r];
/* 385 */       i = q;
/* 386 */       if (i == 0)
/*     */         break;
/*     */     }
/* 389 */     if (sign != 0) {
/* 390 */       buf[(--pos)] = sign;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 397 */   static final byte[] digits = { 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122 };
/*     */   
/*     */ 
/*     */ 
/* 401 */   static final byte[] DigitTens = { 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 52, 52, 52, 52, 52, 52, 52, 52, 52, 52, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57 };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 409 */   static final byte[] DigitOnes = { 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57 };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 417 */   static final int[] sizeTable = { 9, 99, 999, 9999, 99999, 999999, 9999999, 99999999, 999999999, Integer.MAX_VALUE };
/*     */   
/*     */ 
/*     */   public static final int stringSize(int x)
/*     */   {
/* 422 */     for (int i = 0;; i++) {
/* 423 */       if (x <= sizeTable[i]) {
/* 424 */         return i + 1;
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public static final int stringSize(long x) {
/* 430 */     long p = 10L;
/* 431 */     for (int i = 1; i < 19; i++) {
/* 432 */       if (x < p)
/* 433 */         return i;
/* 434 */       p = 10L * p;
/*     */     }
/* 436 */     return 19;
/*     */   }
/*     */   
/* 439 */   static final int[] byte_len_array = new int['Ā'];
/*     */   
/* 441 */   static { for (int i = -128; i <= 127; i++) {
/* 442 */       int size = i < 0 ? stringSize(-i) + 1 : stringSize(i);
/* 443 */       byte_len_array[(i & 0xFF)] = size;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\utils\ByteUtils.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */