/*     */ package org.apache.avro.io.parsing;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.Schema.Field;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ValidatingGrammarGenerator
/*     */ {
/*     */   public Symbol generate(Schema schema)
/*     */   {
/*  36 */     return Symbol.root(new Symbol[] { generate(schema, new HashMap()) });
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Symbol generate(Schema sc, Map<LitS, Symbol> seen)
/*     */   {
/*  50 */     switch (sc.getType()) {
/*     */     case NULL: 
/*  52 */       return Symbol.NULL;
/*     */     case BOOLEAN: 
/*  54 */       return Symbol.BOOLEAN;
/*     */     case INT: 
/*  56 */       return Symbol.INT;
/*     */     case LONG: 
/*  58 */       return Symbol.LONG;
/*     */     case FLOAT: 
/*  60 */       return Symbol.FLOAT;
/*     */     case DOUBLE: 
/*  62 */       return Symbol.DOUBLE;
/*     */     case STRING: 
/*  64 */       return Symbol.STRING;
/*     */     case BYTES: 
/*  66 */       return Symbol.BYTES;
/*     */     case FIXED: 
/*  68 */       return Symbol.seq(new Symbol[] { new Symbol.IntCheckAction(sc.getFixedSize()), Symbol.FIXED });
/*     */     
/*     */     case ENUM: 
/*  71 */       return Symbol.seq(new Symbol[] { new Symbol.IntCheckAction(sc.getEnumSymbols().size()), Symbol.ENUM });
/*     */     
/*     */     case ARRAY: 
/*  74 */       return Symbol.seq(new Symbol[] { Symbol.repeat(Symbol.ARRAY_END, new Symbol[] { generate(sc.getElementType(), seen) }), Symbol.ARRAY_START });
/*     */     
/*     */     case MAP: 
/*  77 */       return Symbol.seq(new Symbol[] { Symbol.repeat(Symbol.MAP_END, new Symbol[] { generate(sc.getValueType(), seen), Symbol.STRING }), Symbol.MAP_START });
/*     */     
/*     */ 
/*     */     case RECORD: 
/*  81 */       LitS wsc = new LitS(sc);
/*  82 */       Symbol rresult = (Symbol)seen.get(wsc);
/*  83 */       Symbol[] production; int i; if (rresult == null) {
/*  84 */         production = new Symbol[sc.getFields().size()];
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  90 */         rresult = Symbol.seq(production);
/*  91 */         seen.put(wsc, rresult);
/*     */         
/*  93 */         i = production.length;
/*  94 */         for (Schema.Field f : sc.getFields()) {
/*  95 */           production[(--i)] = generate(f.schema(), seen);
/*     */         }
/*     */       }
/*  98 */       return rresult;
/*     */     
/*     */     case UNION: 
/* 101 */       List<Schema> subs = sc.getTypes();
/* 102 */       Symbol[] symbols = new Symbol[subs.size()];
/* 103 */       String[] labels = new String[subs.size()];
/*     */       
/* 105 */       int i = 0;
/* 106 */       for (Schema b : sc.getTypes()) {
/* 107 */         symbols[i] = generate(b, seen);
/* 108 */         labels[i] = b.getFullName();
/* 109 */         i++;
/*     */       }
/* 111 */       return Symbol.seq(new Symbol[] { Symbol.alt(symbols, labels), Symbol.UNION });
/*     */     }
/*     */     
/* 114 */     throw new RuntimeException("Unexpected schema type");
/*     */   }
/*     */   
/*     */   static class LitS {
/*     */     public final Schema actual;
/*     */     
/*     */     public LitS(Schema actual) {
/* 121 */       this.actual = actual;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public boolean equals(Object o)
/*     */     {
/* 128 */       if (!(o instanceof LitS)) return false;
/* 129 */       return this.actual == ((LitS)o).actual;
/*     */     }
/*     */     
/*     */     public int hashCode() {
/* 133 */       return this.actual.hashCode();
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\io\parsing\ValidatingGrammarGenerator.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */