/*     */ package org.codehaus.jackson.map.type;
/*     */ 
/*     */ import java.util.Map;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class MapLikeType
/*     */   extends TypeBase
/*     */ {
/*     */   protected final JavaType _keyType;
/*     */   protected final JavaType _valueType;
/*     */   
/*     */   protected MapLikeType(Class<?> mapType, JavaType keyT, JavaType valueT)
/*     */   {
/*  37 */     super(mapType, keyT.hashCode() ^ valueT.hashCode());
/*  38 */     this._keyType = keyT;
/*  39 */     this._valueType = valueT;
/*     */   }
/*     */   
/*     */ 
/*     */   public static MapLikeType construct(Class<?> rawType, JavaType keyT, JavaType valueT)
/*     */   {
/*  45 */     return new MapLikeType(rawType, keyT, valueT);
/*     */   }
/*     */   
/*     */ 
/*     */   protected JavaType _narrow(Class<?> subclass)
/*     */   {
/*  51 */     return new MapLikeType(subclass, this._keyType, this._valueType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JavaType narrowContentsBy(Class<?> contentClass)
/*     */   {
/*  58 */     if (contentClass == this._valueType.getRawClass()) {
/*  59 */       return this;
/*     */     }
/*  61 */     return new MapLikeType(this._class, this._keyType, this._valueType.narrowBy(contentClass)).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */   public JavaType widenContentsBy(Class<?> contentClass)
/*     */   {
/*  67 */     if (contentClass == this._valueType.getRawClass()) {
/*  68 */       return this;
/*     */     }
/*  70 */     return new MapLikeType(this._class, this._keyType, this._valueType.widenBy(contentClass)).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */   public JavaType narrowKey(Class<?> keySubclass)
/*     */   {
/*  76 */     if (keySubclass == this._keyType.getRawClass()) {
/*  77 */       return this;
/*     */     }
/*  79 */     return new MapLikeType(this._class, this._keyType.narrowBy(keySubclass), this._valueType).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JavaType widenKey(Class<?> keySubclass)
/*     */   {
/*  88 */     if (keySubclass == this._keyType.getRawClass()) {
/*  89 */       return this;
/*     */     }
/*  91 */     return new MapLikeType(this._class, this._keyType.widenBy(keySubclass), this._valueType).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public MapLikeType withTypeHandler(Object h)
/*     */   {
/*  98 */     MapLikeType newInstance = new MapLikeType(this._class, this._keyType, this._valueType);
/*  99 */     newInstance._typeHandler = h;
/* 100 */     return newInstance;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public MapLikeType withContentTypeHandler(Object h)
/*     */   {
/* 107 */     return new MapLikeType(this._class, this._keyType, this._valueType.withTypeHandler(h));
/*     */   }
/*     */   
/*     */   protected String buildCanonicalName()
/*     */   {
/* 112 */     StringBuilder sb = new StringBuilder();
/* 113 */     sb.append(this._class.getName());
/* 114 */     if (this._keyType != null) {
/* 115 */       sb.append('<');
/* 116 */       sb.append(this._keyType.toCanonical());
/* 117 */       sb.append(',');
/* 118 */       sb.append(this._valueType.toCanonical());
/* 119 */       sb.append('>');
/*     */     }
/* 121 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isContainerType()
/*     */   {
/* 131 */     return true;
/*     */   }
/*     */   
/* 134 */   public boolean isMapLikeType() { return true; }
/*     */   
/*     */   public JavaType getKeyType() {
/* 137 */     return this._keyType;
/*     */   }
/*     */   
/* 140 */   public JavaType getContentType() { return this._valueType; }
/*     */   
/*     */   public int containedTypeCount() {
/* 143 */     return 2;
/*     */   }
/*     */   
/*     */   public JavaType containedType(int index) {
/* 147 */     if (index == 0) return this._keyType;
/* 148 */     if (index == 1) return this._valueType;
/* 149 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String containedTypeName(int index)
/*     */   {
/* 159 */     if (index == 0) return "K";
/* 160 */     if (index == 1) return "V";
/* 161 */     return null;
/*     */   }
/*     */   
/*     */   public StringBuilder getErasedSignature(StringBuilder sb)
/*     */   {
/* 166 */     return _classSignature(this._class, sb, true);
/*     */   }
/*     */   
/*     */ 
/*     */   public StringBuilder getGenericSignature(StringBuilder sb)
/*     */   {
/* 172 */     _classSignature(this._class, sb, false);
/* 173 */     sb.append('<');
/* 174 */     this._keyType.getGenericSignature(sb);
/* 175 */     this._valueType.getGenericSignature(sb);
/* 176 */     sb.append(">;");
/* 177 */     return sb;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isTrueMapType()
/*     */   {
/* 195 */     return Map.class.isAssignableFrom(this._class);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 207 */     return "[map-like type; class " + this._class.getName() + ", " + this._keyType + " -> " + this._valueType + "]";
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean equals(Object o)
/*     */   {
/* 213 */     if (o == this) return true;
/* 214 */     if (o == null) return false;
/* 215 */     if (o.getClass() != getClass()) { return false;
/*     */     }
/* 217 */     MapLikeType other = (MapLikeType)o;
/* 218 */     return (this._class == other._class) && (this._keyType.equals(other._keyType)) && (this._valueType.equals(other._valueType));
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\type\MapLikeType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */