/*     */ package org.slf4j;
/*     */ 
/*     */ import java.util.Map;
/*     */ import org.slf4j.helpers.NOPMDCAdapter;
/*     */ import org.slf4j.helpers.Util;
/*     */ import org.slf4j.impl.StaticMDCBinder;
/*     */ import org.slf4j.spi.MDCAdapter;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class MDC
/*     */ {
/*     */   static final String NULL_MDCA_URL = "http://www.slf4j.org/codes.html#null_MDCA";
/*     */   static final String NO_STATIC_MDC_BINDER_URL = "http://www.slf4j.org/codes.html#no_static_mdc_binder";
/*     */   static MDCAdapter mdcAdapter;
/*     */   
/*     */   static
/*     */   {
/*     */     try
/*     */     {
/*  74 */       mdcAdapter = StaticMDCBinder.SINGLETON.getMDCA();
/*     */     } catch (NoClassDefFoundError ncde) {
/*  76 */       mdcAdapter = new NOPMDCAdapter();
/*  77 */       String msg = ncde.getMessage();
/*  78 */       if ((msg != null) && (msg.indexOf("StaticMDCBinder") != -1)) {
/*  79 */         Util.report("Failed to load class \"org.slf4j.impl.StaticMDCBinder\".");
/*  80 */         Util.report("Defaulting to no-operation MDCAdapter implementation.");
/*  81 */         Util.report("See http://www.slf4j.org/codes.html#no_static_mdc_binder for further details.");
/*     */       }
/*     */       else {
/*  84 */         throw ncde;
/*     */       }
/*     */     }
/*     */     catch (Exception e) {
/*  88 */       Util.report("MDC binding unsuccessful.", e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void put(String key, String val)
/*     */     throws IllegalArgumentException
/*     */   {
/* 106 */     if (key == null) {
/* 107 */       throw new IllegalArgumentException("key parameter cannot be null");
/*     */     }
/* 109 */     if (mdcAdapter == null) {
/* 110 */       throw new IllegalStateException("MDCAdapter cannot be null. See also http://www.slf4j.org/codes.html#null_MDCA");
/*     */     }
/*     */     
/* 113 */     mdcAdapter.put(key, val);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String get(String key)
/*     */     throws IllegalArgumentException
/*     */   {
/* 128 */     if (key == null) {
/* 129 */       throw new IllegalArgumentException("key parameter cannot be null");
/*     */     }
/*     */     
/* 132 */     if (mdcAdapter == null) {
/* 133 */       throw new IllegalStateException("MDCAdapter cannot be null. See also http://www.slf4j.org/codes.html#null_MDCA");
/*     */     }
/*     */     
/* 136 */     return mdcAdapter.get(key);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void remove(String key)
/*     */     throws IllegalArgumentException
/*     */   {
/* 149 */     if (key == null) {
/* 150 */       throw new IllegalArgumentException("key parameter cannot be null");
/*     */     }
/*     */     
/* 153 */     if (mdcAdapter == null) {
/* 154 */       throw new IllegalStateException("MDCAdapter cannot be null. See also http://www.slf4j.org/codes.html#null_MDCA");
/*     */     }
/*     */     
/* 157 */     mdcAdapter.remove(key);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static void clear()
/*     */   {
/* 164 */     if (mdcAdapter == null) {
/* 165 */       throw new IllegalStateException("MDCAdapter cannot be null. See also http://www.slf4j.org/codes.html#null_MDCA");
/*     */     }
/*     */     
/* 168 */     mdcAdapter.clear();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Map getCopyOfContextMap()
/*     */   {
/* 179 */     if (mdcAdapter == null) {
/* 180 */       throw new IllegalStateException("MDCAdapter cannot be null. See also http://www.slf4j.org/codes.html#null_MDCA");
/*     */     }
/*     */     
/* 183 */     return mdcAdapter.getCopyOfContextMap();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void setContextMap(Map contextMap)
/*     */   {
/* 196 */     if (mdcAdapter == null) {
/* 197 */       throw new IllegalStateException("MDCAdapter cannot be null. See also http://www.slf4j.org/codes.html#null_MDCA");
/*     */     }
/*     */     
/* 200 */     mdcAdapter.setContextMap(contextMap);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static MDCAdapter getMDCAdapter()
/*     */   {
/* 210 */     return mdcAdapter;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\slf4j\MDC.class
 * Java compiler version: 3 (47.0)
 * JD-Core Version:       0.7.1
 */