/*     */ package com.google.code.yanf4j.buffer;
/*     */ 
/*     */ import java.nio.ByteBuffer;
/*     */ import java.nio.ByteOrder;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SimpleBufferAllocator
/*     */   implements IoBufferAllocator
/*     */ {
/*     */   public IoBuffer allocate(int capacity, boolean direct)
/*     */   {
/*  37 */     return wrap(allocateNioBuffer(capacity, direct));
/*     */   }
/*     */   
/*     */   public ByteBuffer allocateNioBuffer(int capacity, boolean direct) {
/*     */     ByteBuffer nioBuffer;
/*     */     ByteBuffer nioBuffer;
/*  43 */     if (direct) {
/*  44 */       nioBuffer = ByteBuffer.allocateDirect(capacity);
/*     */     }
/*     */     else {
/*  47 */       nioBuffer = ByteBuffer.allocate(capacity);
/*     */     }
/*  49 */     return nioBuffer;
/*     */   }
/*     */   
/*     */   public IoBuffer wrap(ByteBuffer nioBuffer)
/*     */   {
/*  54 */     return new SimpleBuffer(nioBuffer);
/*     */   }
/*     */   
/*     */   public void dispose() {}
/*     */   
/*     */   private class SimpleBuffer
/*     */     extends AbstractIoBuffer
/*     */   {
/*     */     private ByteBuffer buf;
/*     */     
/*     */     protected SimpleBuffer(ByteBuffer buf)
/*     */     {
/*  66 */       super(buf.capacity());
/*  67 */       this.buf = buf;
/*  68 */       buf.order(ByteOrder.BIG_ENDIAN);
/*     */     }
/*     */     
/*     */     protected SimpleBuffer(SimpleBuffer parent, ByteBuffer buf)
/*     */     {
/*  73 */       super();
/*  74 */       this.buf = buf;
/*     */     }
/*     */     
/*     */ 
/*     */     public ByteBuffer buf()
/*     */     {
/*  80 */       return this.buf;
/*     */     }
/*     */     
/*     */ 
/*     */     protected void buf(ByteBuffer buf)
/*     */     {
/*  86 */       this.buf = buf;
/*     */     }
/*     */     
/*     */ 
/*     */     protected IoBuffer duplicate0()
/*     */     {
/*  92 */       return new SimpleBuffer(SimpleBufferAllocator.this, this, this.buf.duplicate());
/*     */     }
/*     */     
/*     */ 
/*     */     protected IoBuffer slice0()
/*     */     {
/*  98 */       return new SimpleBuffer(SimpleBufferAllocator.this, this, this.buf.slice());
/*     */     }
/*     */     
/*     */ 
/*     */     protected IoBuffer asReadOnlyBuffer0()
/*     */     {
/* 104 */       return new SimpleBuffer(SimpleBufferAllocator.this, this, this.buf.asReadOnlyBuffer());
/*     */     }
/*     */     
/*     */ 
/*     */     public byte[] array()
/*     */     {
/* 110 */       return this.buf.array();
/*     */     }
/*     */     
/*     */ 
/*     */     public int arrayOffset()
/*     */     {
/* 116 */       return this.buf.arrayOffset();
/*     */     }
/*     */     
/*     */ 
/*     */     public boolean hasArray()
/*     */     {
/* 122 */       return this.buf.hasArray();
/*     */     }
/*     */     
/*     */     public void free() {}
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\buffer\SimpleBufferAllocator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */