/*    */ package com.jaspersoft.jasperserver.jaxrs.client.core;
/*    */ 
/*    */ import java.math.BigInteger;
/*    */ import java.net.URLEncoder;
/*    */ import java.security.KeyFactory;
/*    */ import java.security.PublicKey;
/*    */ import java.security.spec.RSAPublicKeySpec;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import javax.crypto.Cipher;
/*    */ import javax.ws.rs.core.Response;
/*    */ import org.bouncycastle.jce.provider.BouncyCastleProvider;
/*    */ import org.codehaus.jettison.json.JSONException;
/*    */ import org.codehaus.jettison.json.JSONObject;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class EncryptionUtils
/*    */ {
/*    */   public static String encryptPassword(String plainPassword, String n, String e)
/*    */   {
/*    */     String encryptedUtfProPass;
/*    */     try
/*    */     {
/* 46 */       PublicKey publicKey = getPublicKey(n, e);
/* 47 */       encryptedUtfProPass = getEncryptedPassword(publicKey, plainPassword);
/*    */     }
/*    */     catch (Exception ex) {
/* 50 */       throw new RuntimeException("Failed inFolder encrypt password.", ex);
/*    */     }
/* 52 */     return encryptedUtfProPass;
/*    */   }
/*    */   
/*    */   public static Map<String, String> parseEncryptionParams(Response response) {
/* 56 */     Map<String, String> encryptionParams = new HashMap();
/* 57 */     String encryptionParamsJson = (String)response.readEntity(String.class);
/*    */     try {
/* 59 */       JSONObject json = new JSONObject(encryptionParamsJson);
/* 60 */       encryptionParams.put("n", json.getString("n"));
/* 61 */       encryptionParams.put("e", json.getString("e"));
/*    */     }
/*    */     catch (JSONException e1) {
/* 64 */       return null;
/*    */     }
/* 66 */     return encryptionParams;
/*    */   }
/*    */   
/*    */   private static String byteArrayToHexString(byte[] byteArr) {
/* 70 */     StringBuffer sb = new StringBuffer();
/* 71 */     for (int i = 0; i < byteArr.length; i++) {
/* 72 */       byte b = byteArr[i];
/* 73 */       int high = (b & 0xF0) >> 4;
/* 74 */       int low = b & 0xF;
/* 75 */       sb.append(Character.forDigit(high, 16));
/* 76 */       sb.append(Character.forDigit(low, 16));
/*    */     }
/* 78 */     return sb.toString();
/*    */   }
/*    */   
/*    */   private static String getEncryptedPassword(PublicKey publicKey, String pwd) throws Exception
/*    */   {
/* 83 */     Cipher enc = Cipher.getInstance("RSA/NONE/NoPadding", new BouncyCastleProvider());
/* 84 */     enc.init(1, publicKey);
/* 85 */     String utfPass = URLEncoder.encode(pwd, "UTF-8");
/* 86 */     byte[] encryptedUtfPass = enc.doFinal(utfPass.getBytes());
/*    */     
/* 88 */     return byteArrayToHexString(encryptedUtfPass);
/*    */   }
/*    */   
/*    */   private static PublicKey getPublicKey(String n, String e) throws Exception {
/* 92 */     KeyFactory keyFactory = KeyFactory.getInstance("RSA");
/* 93 */     int radix = 16;
/* 94 */     BigInteger modulus = new BigInteger(n, radix);
/* 95 */     BigInteger publicExponent = new BigInteger(e, radix);
/* 96 */     RSAPublicKeySpec publicKeySpec = new RSAPublicKeySpec(modulus, publicExponent);
/* 97 */     return keyFactory.generatePublic(publicKeySpec);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\core\EncryptionUtils.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */