/*    */ package com.netapp.asup.data.objects;
/*    */ 
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import com.netapp.asup.exception.ARMAConfigurationException;
/*    */ import java.io.ByteArrayOutputStream;
/*    */ import java.io.IOException;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.generic.GenericDatumWriter;
/*    */ import org.apache.avro.io.EncoderFactory;
/*    */ import org.apache.avro.io.JsonEncoder;
/*    */ 
/*    */ 
/*    */ public abstract class AvroObject<T>
/*    */ {
/* 15 */   protected static final AsupLogger logger = AsupLogger.getLogger(AvroObject.class);
/*    */   
/*    */   protected T object;
/*    */   
/*    */   protected ARMASchema schema;
/* 20 */   protected static EncoderFactory encoderFactory = new EncoderFactory();
/*    */   
/* 22 */   protected JsonEncoder jsonEncoder = null;
/*    */   
/*    */   protected String id;
/*    */   
/*    */ 
/*    */   AvroObject() {}
/*    */   
/*    */ 
/*    */   public AvroObject(ARMASchema schema, String id)
/*    */   {
/* 32 */     this.schema = schema;
/* 33 */     this.id = id;
/*    */   }
/*    */   
/*    */   public AvroObject(ARMASchema schema, T object, String id) {
/* 37 */     this.schema = schema;
/* 38 */     this.id = id;
/* 39 */     this.object = object;
/*    */   }
/*    */   
/*    */   public String getId() {
/* 43 */     return this.id;
/*    */   }
/*    */   
/*    */   public T getObject() throws IOException {
/* 47 */     return (T)this.object;
/*    */   }
/*    */   
/*    */   public Schema getSchema() {
/* 51 */     return this.schema.getSchema();
/*    */   }
/*    */   
/*    */   public String toString()
/*    */   {
/* 56 */     ByteArrayOutputStream bos = new ByteArrayOutputStream();
/*    */     try {
/* 58 */       this.jsonEncoder = encoderFactory.jsonEncoder(this.schema.getSchema(), bos);
/* 59 */       this.schema.getWriter().write(getObject(), this.jsonEncoder);
/* 60 */       this.jsonEncoder.flush();
/* 61 */       return bos.toString();
/*    */     } catch (IOException e) {
/* 63 */       new ARMAConfigurationException(logger, "Unable to read object in json format caused by :" + e.getMessage(), e);
/* 64 */       return null;
/*    */     } finally {
/*    */       try {
/* 67 */         bos.close();
/*    */       } catch (IOException e) {
/* 69 */         new ARMAConfigurationException(logger, "Unable to read object in json format caused by :" + e.getMessage(), e);
/*    */       }
/*    */     }
/*    */   }
/*    */   
/*    */   public void merge(Object existingInstance)
/*    */     throws IOException
/*    */   {}
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\AvroObject.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */