/*    */ package com.netapp.asup.data.objects;
/*    */ 
/*    */ import java.util.ArrayList;
/*    */ import java.util.List;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Field;
/*    */ import org.apache.avro.generic.GenericData.Array;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class StatusHeader
/*    */   extends AvroGenericRecordObject
/*    */ {
/*    */   private static final String SUCCESS = "SUCCESS";
/*    */   private static final String FAILURE = "FAILURE";
/*    */   private static final String STATE = "state";
/*    */   private static final String ERRORMESSAGES = "errorMessages";
/* 20 */   private List<String> errorMessages = new ArrayList();
/*    */   
/*    */   public StatusHeader(String id) {
/* 23 */     super(ARMASchema.STATUS_HEADER, id);
/*    */   }
/*    */   
/*    */   public StatusHeader(GenericRecord object, String id) {
/* 27 */     super(ARMASchema.STATUS_HEADER, object, id);
/*    */   }
/*    */   
/*    */   public void addErrorMessage(String message) {
/* 31 */     this.errorMessages.add(message);
/*    */   }
/*    */   
/*    */   public GenericData.Array<Utf8> getErrorMessages()
/*    */   {
/* 36 */     return (GenericData.Array)getObject().get("errorMessages");
/*    */   }
/*    */   
/*    */   public String getState() {
/* 40 */     return getStringValue("state");
/*    */   }
/*    */   
/*    */   public GenericRecord getObject()
/*    */   {
/* 45 */     int size = this.errorMessages.size();
/* 46 */     GenericData.Array<Utf8> errMsg = new GenericData.Array(size, ARMASchema.STATUS_HEADER.getSchema().getField("errorMessages").schema());
/*    */     
/*    */ 
/*    */ 
/* 50 */     for (String errorMessage : this.errorMessages) {
/* 51 */       errMsg.add(new Utf8(errorMessage));
/*    */     }
/* 53 */     ((GenericRecord)this.object).put("errorMessages", errMsg);
/*    */     
/* 55 */     String status = size > 0 ? "FAILURE" : "SUCCESS";
/* 56 */     putStringValue("state", status);
/*    */     
/* 58 */     return (GenericRecord)this.object;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\StatusHeader.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */