/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerLong<BeanT>
/*    */   extends Lister<BeanT, long[], Long, LongArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Long.TYPE, new PrimitiveArrayListerLong());
/*    */   }
/*    */   
/*    */   public ListIterator<Long> iterator(final long[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Long next()
/*    */       {
/* 30 */         return Long.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public LongArrayPack startPacking(BeanT current, Accessor<BeanT, long[]> acc) {
/* 36 */     return new LongArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(LongArrayPack objects, Long o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(LongArrayPack pack, BeanT bean, Accessor<BeanT, long[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, long[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new long[0]);
/*    */   }
/*    */   
/*    */   static final class LongArrayPack {
/* 52 */     long[] buf = new long[16];
/*    */     int size;
/*    */     
/*    */     void add(Long b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         long[] nb = new long[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.longValue();
/*    */     }
/*    */     
/*    */     long[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       long[] r = new long[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerLong.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */