/*    */ package net.rubyeye.xmemcached.command.binary;
/*    */ 
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.concurrent.CountDownLatch;
/*    */ import net.rubyeye.xmemcached.command.CommandType;
/*    */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class BinaryStoreCommand
/*    */   extends BaseBinaryCommand
/*    */ {
/*    */   public BinaryStoreCommand(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch, int exp, long cas, Object value, boolean noreply, Transcoder transcoder)
/*    */   {
/* 43 */     super(key, keyBytes, cmdType, latch, exp, cas, value, noreply, transcoder);
/*    */     
/* 45 */     switch (cmdType) {
/*    */     case SET: 
/* 47 */       this.opCode = (noreply ? OpCode.SET_QUIETLY : OpCode.SET);
/* 48 */       break;
/*    */     case REPLACE: 
/* 50 */       this.opCode = (noreply ? OpCode.REPLACE_QUIETLY : OpCode.REPLACE);
/* 51 */       break;
/*    */     case ADD: 
/* 53 */       this.opCode = (noreply ? OpCode.ADD_QUIETLY : OpCode.ADD);
/* 54 */       break;
/*    */     
/*    */     default: 
/* 57 */       throw new IllegalArgumentException("Unknow cmd type for storage commands:" + cmdType);
/*    */     }
/*    */     
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   protected void readHeader(ByteBuffer buffer)
/*    */   {
/* 67 */     super.readHeader(buffer);
/* 68 */     if (this.responseStatus == ResponseStatus.NO_ERROR) {
/* 69 */       this.decodeStatus = BinaryDecodeStatus.DONE;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\binary\BinaryStoreCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */