/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.List;
/*     */ import net.rubyeye.xmemcached.HashAlgorithm;
/*     */ import net.rubyeye.xmemcached.networking.MemcachedSession;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class PHPMemcacheSessionLocator
/*     */   extends AbstractMemcachedSessionLocator
/*     */ {
/*     */   private HashAlgorithm hashAlgorithm;
/*     */   private volatile transient List<Session> sessions;
/*     */   
/*     */   public PHPMemcacheSessionLocator()
/*     */   {
/*  38 */     this.hashAlgorithm = HashAlgorithm.NATIVE_HASH;
/*     */   }
/*     */   
/*     */   public PHPMemcacheSessionLocator(HashAlgorithm hashAlgorithm) {
/*  42 */     this.hashAlgorithm = hashAlgorithm;
/*     */   }
/*     */   
/*     */   public final void setHashAlgorighm(HashAlgorithm hashAlgorithm) {
/*  46 */     this.hashAlgorithm = hashAlgorithm;
/*     */   }
/*     */   
/*     */   public final long getHash(int size, String key) {
/*  50 */     long hash = this.hashAlgorithm.hash(key);
/*  51 */     hash = hash >> 16 & 0x7FFF;
/*  52 */     return hash % size;
/*     */   }
/*     */   
/*     */   public final Session getSessionByKey(String key) {
/*  56 */     if ((this.sessions == null) || (this.sessions.size() == 0)) {
/*  57 */       return null;
/*     */     }
/*     */     
/*  60 */     List<Session> sessionList = this.sessions;
/*  61 */     int size = sessionList.size();
/*  62 */     if (size == 0) {
/*  63 */       return null;
/*     */     }
/*  65 */     long start = getHash(size, key);
/*  66 */     Session session = (Session)sessionList.get((int)start);
/*     */     
/*  68 */     if ((!this.failureMode) && ((session == null) || (session.isClosed()))) {
/*  69 */       long next = getNext(size, start);
/*  70 */       while (((session == null) || (session.isClosed())) && (next != start)) {
/*  71 */         session = (Session)sessionList.get((int)next);
/*  72 */         next = getNext(size, next);
/*     */       }
/*     */     }
/*  75 */     return session;
/*     */   }
/*     */   
/*     */   public final long getNext(int size, long start) {
/*  79 */     if (start == size - 1) {
/*  80 */       return 0L;
/*     */     }
/*  82 */     return start + 1L;
/*     */   }
/*     */   
/*     */   public final void updateSessions(Collection<Session> list)
/*     */   {
/*  87 */     Collection<Session> copySessions = list;
/*  88 */     List<Session> newSessions = new ArrayList(copySessions.size() * 2);
/*     */     
/*  90 */     for (Session session : copySessions) {
/*  91 */       if ((session instanceof MemcachedTCPSession)) {
/*  92 */         int weight = ((MemcachedSession)session).getWeight();
/*  93 */         for (int i = 0; i < weight; i++) {
/*  94 */           newSessions.add(session);
/*     */         }
/*     */       } else {
/*  97 */         newSessions.add(session);
/*     */       }
/*     */     }
/* 100 */     this.sessions = newSessions;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\PHPMemcacheSessionLocator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */