/*    */ package net.rubyeye.xmemcached.impl;
/*    */ 
/*    */ import com.google.code.yanf4j.core.Session;
/*    */ import java.util.ArrayList;
/*    */ import java.util.Collection;
/*    */ import java.util.List;
/*    */ import java.util.concurrent.atomic.AtomicInteger;
/*    */ import net.rubyeye.xmemcached.MemcachedSessionLocator;
/*    */ import net.rubyeye.xmemcached.networking.MemcachedSession;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class RoundRobinMemcachedSessionLocator
/*    */   implements MemcachedSessionLocator
/*    */ {
/*    */   private volatile transient List<Session> sessions;
/* 24 */   private AtomicInteger sets = new AtomicInteger(0);
/*    */   
/*    */   public Session getSessionByKey(String key) {
/* 27 */     List<Session> copyList = this.sessions;
/* 28 */     if ((copyList == null) || (copyList.isEmpty()))
/* 29 */       return null;
/* 30 */     int size = copyList.size();
/* 31 */     return (Session)copyList.get(Math.abs(this.sets.getAndIncrement()) % size);
/*    */   }
/*    */   
/*    */   public final void updateSessions(Collection<Session> list) {
/* 35 */     Collection<Session> copySessions = list;
/* 36 */     List<Session> newSessions = new ArrayList(copySessions.size() * 2);
/*    */     
/* 38 */     for (Session session : copySessions) {
/* 39 */       if ((session instanceof MemcachedTCPSession)) {
/* 40 */         int weight = ((MemcachedSession)session).getWeight();
/* 41 */         for (int i = 0; i < weight; i++) {
/* 42 */           newSessions.add(session);
/*    */         }
/*    */       } else {
/* 45 */         newSessions.add(session);
/*    */       }
/*    */     }
/* 48 */     this.sessions = newSessions;
/*    */   }
/*    */   
/*    */   public void setFailureMode(boolean failureMode) {}
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\RoundRobinMemcachedSessionLocator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */