/*     */ package net.rubyeye.xmemcached.transcoders;
/*     */ 
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.Arrays;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class CachedData
/*     */ {
/*  16 */   public static int MAX_SIZE = 1048576;
/*     */   
/*     */   private int flag;
/*     */   private byte[] data;
/*     */   private long cas;
/*  21 */   private int capacity = -1;
/*     */   
/*  23 */   private int size = 0;
/*     */   
/*     */   public final int getSize() {
/*  26 */     return this.size;
/*     */   }
/*     */   
/*     */   public final void fillData(ByteBuffer buffer, int offset, int length) {
/*  30 */     buffer.get(this.data, offset, length);
/*  31 */     this.size += length;
/*     */   }
/*     */   
/*     */   public final void fillData(ByteBuffer buffer, int length) {
/*  35 */     buffer.get(this.data, this.size, length);
/*  36 */     this.size += length;
/*     */   }
/*     */   
/*     */   public final int getCapacity() {
/*  40 */     return this.capacity;
/*     */   }
/*     */   
/*     */   public final void setSize(int size) {
/*  44 */     this.size = size;
/*     */   }
/*     */   
/*     */   public final void setCapacity(int dataLen) {
/*  48 */     this.capacity = dataLen;
/*     */   }
/*     */   
/*     */   public static final int getMAX_SIZE() {
/*  52 */     return MAX_SIZE;
/*     */   }
/*     */   
/*     */   public final void setFlag(int flags) {
/*  56 */     this.flag = flags;
/*     */   }
/*     */   
/*     */   public final void setData(byte[] data) {
/*  60 */     if (data.length > this.capacity) {
/*  61 */       throw new IllegalArgumentException("Cannot cache data larger than 1MB (you tried to cache a " + data.length + " byte object)");
/*     */     }
/*     */     
/*     */ 
/*  65 */     this.data = data;
/*     */   }
/*     */   
/*     */   public final void setCas(long cas) {
/*  69 */     this.cas = cas;
/*     */   }
/*     */   
/*     */   public long getCas() {
/*  73 */     return this.cas;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public CachedData() {}
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public CachedData(int f, byte[] d, int capacity, long casId)
/*     */   {
/*  92 */     this.capacity = capacity;
/*  93 */     this.size = (d != null ? d.length : 0);
/*  94 */     if ((d != null) && (d.length > capacity)) {
/*  95 */       throw new IllegalArgumentException("Cannot cache data larger than 1MB (you tried to cache a " + d.length + " byte object)");
/*     */     }
/*     */     
/*     */ 
/*  99 */     this.flag = f;
/* 100 */     this.data = d;
/* 101 */     this.cas = casId;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public CachedData(int f, byte[] d)
/*     */   {
/* 113 */     this(f, d, MAX_SIZE, -1L);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final byte[] getData()
/*     */   {
/* 120 */     return this.data;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final int getFlag()
/*     */   {
/* 127 */     return this.flag;
/*     */   }
/*     */   
/*     */   public String toString()
/*     */   {
/* 132 */     return "{CachedData flags=" + this.flag + " data=" + Arrays.toString(this.data) + "}";
/*     */   }
/*     */   
/*     */   public int remainingCapacity()
/*     */   {
/* 137 */     if (getCapacity() < 0) {
/* 138 */       return -1;
/*     */     }
/* 140 */     int remainingCapacity = getCapacity() - getSize();
/* 141 */     return remainingCapacity;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\transcoders\CachedData.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */