/*    */ package org.codehaus.janino.util.iterator;
/*    */ 
/*    */ import java.util.Arrays;
/*    */ import java.util.Collection;
/*    */ import java.util.Enumeration;
/*    */ import java.util.Iterator;
/*    */ import java.util.List;
/*    */ import java.util.NoSuchElementException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class MultiDimensionalIterator
/*    */   implements Iterator
/*    */ {
/*    */   private final Iterator[] nest;
/* 44 */   private static final Iterator EMPTY_ITERATOR = new Iterator() {
/* 45 */     public boolean hasNext() { return false; }
/* 46 */     public Object next() { throw new NoSuchElementException(); }
/* 47 */     public void remove() { throw new UnsupportedOperationException("remove"); }
/*    */   };
/*    */   
/*    */   public MultiDimensionalIterator(Iterator delegate, int dimensionCount) {
/* 51 */     this.nest = new Iterator[dimensionCount];
/* 52 */     this.nest[0] = delegate;
/* 53 */     for (int i = 1; i < dimensionCount; i++) { this.nest[i] = EMPTY_ITERATOR;
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public boolean hasNext()
/*    */   {
/* 62 */     if (this.nest[(this.nest.length - 1)].hasNext()) { return true;
/*    */     }
/* 64 */     int i = this.nest.length - 2;
/* 65 */     if (i < 0) return false;
/*    */     for (;;)
/*    */     {
/* 68 */       if (!this.nest[i].hasNext()) {
/* 69 */         if (i == 0) return false;
/* 70 */         i--;
/*    */       } else {
/* 72 */         if (i == this.nest.length - 1) return true;
/* 73 */         Object o = this.nest[i].next();
/* 74 */         if ((o instanceof Iterator)) {
/* 75 */           this.nest[(++i)] = ((Iterator)o);
/*    */         }
/* 77 */         else if ((o instanceof Object[])) {
/* 78 */           this.nest[(++i)] = Arrays.asList((Object[])(Object[])o).iterator();
/*    */         }
/* 80 */         else if ((o instanceof Collection)) {
/* 81 */           this.nest[(++i)] = ((Collection)o).iterator();
/*    */         }
/* 83 */         else if ((o instanceof Enumeration)) {
/* 84 */           this.nest[(++i)] = new EnumerationIterator((Enumeration)o);
/*    */         }
/*    */         else {
/* 87 */           throw new UniterableElementException();
/*    */         }
/*    */       }
/*    */     }
/*    */   }
/*    */   
/*    */   public Object next() {
/* 94 */     if (!hasNext()) throw new NoSuchElementException();
/* 95 */     return this.nest[(this.nest.length - 1)].next();
/*    */   }
/*    */   
/* 98 */   public void remove() { throw new UnsupportedOperationException("remove"); }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\iterator\MultiDimensionalIterator.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */