package prefuse.action.animate;

import prefuse.action.ItemAction;
import prefuse.util.ColorLib;
import prefuse.util.PrefuseLib;
import prefuse.util.collections.CopyOnWriteArrayList;
import prefuse.visual.VisualItem;

public class ColorAnimator
  extends ItemAction
{
  private static final String[] DEFAULTS = { VisualItem.STROKECOLOR, VisualItem.FILLCOLOR, VisualItem.TEXTCOLOR };
  private CopyOnWriteArrayList m_colorFields;
  
  public ColorAnimator()
  {
    setColorFields(DEFAULTS);
  }
  
  public ColorAnimator(String paramString)
  {
    super(paramString);
    setColorFields(DEFAULTS);
  }
  
  public ColorAnimator(String paramString1, String paramString2)
  {
    super(paramString1);
    setColorFields(new String[] { paramString2 });
  }
  
  public ColorAnimator(String paramString, String[] paramArrayOfString)
  {
    super(paramString);
    setColorFields(paramArrayOfString);
  }
  
  public void setColorFields(String[] paramArrayOfString)
  {
    if (paramArrayOfString == null) {
      throw new IllegalArgumentException();
    }
    if (this.m_colorFields == null) {
      this.m_colorFields = new CopyOnWriteArrayList();
    } else {
      this.m_colorFields.clear();
    }
    for (int i = 0; i < paramArrayOfString.length; i++)
    {
      this.m_colorFields.add(paramArrayOfString[i]);
      this.m_colorFields.add(PrefuseLib.getStartField(paramArrayOfString[i]));
      this.m_colorFields.add(PrefuseLib.getEndField(paramArrayOfString[i]));
    }
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    if (this.m_colorFields == null) {
      return;
    }
    Object[] arrayOfObject = this.m_colorFields.getArray();
    for (int i = 0; i < arrayOfObject.length; i += 3)
    {
      String str1 = (String)arrayOfObject[i];
      String str2 = (String)arrayOfObject[(i + 1)];
      String str3 = (String)arrayOfObject[(i + 2)];
      int j = paramVisualItem.getInt(str2);
      int k = paramVisualItem.getInt(str3);
      int m = ColorLib.interp(j, k, paramDouble);
      paramVisualItem.setInt(str1, m);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\animate\ColorAnimator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */