package prefuse.action.assignment;

import java.awt.Font;
import java.util.logging.Logger;
import prefuse.action.ItemAction;
import prefuse.data.expression.Predicate;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.util.FontLib;
import prefuse.util.PredicateChain;
import prefuse.visual.VisualItem;

public class FontAction
  extends ItemAction
{
  protected PredicateChain m_chain = null;
  protected Font defaultFont = FontLib.getFont("SansSerif", 0, 10);
  
  public FontAction() {}
  
  public FontAction(String paramString)
  {
    super(paramString);
  }
  
  public FontAction(String paramString, Font paramFont)
  {
    super(paramString);
    this.defaultFont = paramFont;
  }
  
  public void setDefaultFont(Font paramFont)
  {
    this.defaultFont = paramFont;
  }
  
  public Font getDefaultFont()
  {
    return this.defaultFont;
  }
  
  public void add(Predicate paramPredicate, Font paramFont)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, paramFont);
  }
  
  public void add(String paramString, Font paramFont)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramFont);
  }
  
  public void add(Predicate paramPredicate, FontAction paramFontAction)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, paramFontAction);
  }
  
  public void add(String paramString, FontAction paramFontAction)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramFontAction);
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    Font localFont1 = getFont(paramVisualItem);
    Font localFont2 = paramVisualItem.getFont();
    paramVisualItem.setStartFont(localFont2);
    paramVisualItem.setEndFont(localFont1);
    paramVisualItem.setFont(localFont1);
  }
  
  public Font getFont(VisualItem paramVisualItem)
  {
    if (this.m_chain != null)
    {
      Object localObject = this.m_chain.get(paramVisualItem);
      if (localObject != null)
      {
        if ((localObject instanceof FontAction)) {
          return ((FontAction)localObject).getFont(paramVisualItem);
        }
        if ((localObject instanceof Font)) {
          return (Font)localObject;
        }
        Logger.getLogger(getClass().getName()).warning("Unrecognized Object from predicate chain.");
      }
    }
    return this.defaultFont;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\assignment\FontAction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */