package prefuse.action.filter;

import java.util.Iterator;
import prefuse.Visualization;
import prefuse.action.GroupAction;
import prefuse.data.expression.OrPredicate;
import prefuse.data.expression.Predicate;
import prefuse.util.PrefuseLib;
import prefuse.visual.VisualItem;
import prefuse.visual.expression.VisiblePredicate;

public class VisibilityFilter
  extends GroupAction
{
  private Predicate m_filter;
  private Predicate m_predicate;
  
  public VisibilityFilter(Predicate paramPredicate)
  {
    setPredicate(paramPredicate);
  }
  
  public VisibilityFilter(String paramString, Predicate paramPredicate)
  {
    super(paramString);
    setPredicate(paramPredicate);
  }
  
  public VisibilityFilter(Visualization paramVisualization, String paramString, Predicate paramPredicate)
  {
    super(paramVisualization, paramString);
    setPredicate(paramPredicate);
  }
  
  protected void setPredicate(Predicate paramPredicate)
  {
    this.m_predicate = paramPredicate;
    this.m_filter = new OrPredicate(paramPredicate, VisiblePredicate.TRUE);
  }
  
  public void run(double paramDouble)
  {
    Iterator localIterator = this.m_vis.items(this.m_group, this.m_filter);
    while (localIterator.hasNext())
    {
      VisualItem localVisualItem = (VisualItem)localIterator.next();
      PrefuseLib.updateVisible(localVisualItem, this.m_predicate.getBoolean(localVisualItem));
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\filter\VisibilityFilter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */