package prefuse.data.io;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import prefuse.data.parser.DataParseException;
import prefuse.data.parser.ParserFactory;

public class DelimitedTextTableReader
  extends AbstractTextTableReader
{
  private String m_delim;
  
  public DelimitedTextTableReader()
  {
    this("\t");
  }
  
  public DelimitedTextTableReader(ParserFactory paramParserFactory)
  {
    this("\t", paramParserFactory);
  }
  
  public DelimitedTextTableReader(String paramString)
  {
    this.m_delim = paramString;
  }
  
  public DelimitedTextTableReader(String paramString, ParserFactory paramParserFactory)
  {
    super(paramParserFactory);
    this.m_delim = paramString;
  }
  
  protected void read(InputStream paramInputStream, TableReadListener paramTableReadListener)
    throws IOException, DataParseException
  {
    int i = 0;
    BufferedReader localBufferedReader = new BufferedReader(new InputStreamReader(paramInputStream));
    String str;
    while ((str = localBufferedReader.readLine()) != null)
    {
      i++;
      String[] arrayOfString = str.split(this.m_delim);
      for (int j = 0; j < arrayOfString.length; j++) {
        paramTableReadListener.readValue(i, j + 1, arrayOfString[j]);
      }
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\io\DelimitedTextTableReader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */