package prefuse.data.io.sql;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.HashMap;
import prefuse.data.Table;

public class CompositeSQLDataHandler
  implements SQLDataHandler
{
  private SQLDataHandler m_default;
  private HashMap m_overrides;
  
  public CompositeSQLDataHandler()
  {
    this(new DefaultSQLDataHandler());
  }
  
  public CompositeSQLDataHandler(SQLDataHandler paramSQLDataHandler)
  {
    this.m_default = paramSQLDataHandler;
  }
  
  public void addHandler(String paramString, SQLDataHandler paramSQLDataHandler)
  {
    if (this.m_overrides == null) {
      this.m_overrides = new HashMap(3);
    }
    this.m_overrides.put(paramString, paramSQLDataHandler);
  }
  
  public boolean removeHandler(String paramString)
  {
    if (this.m_overrides == null) {
      return false;
    }
    return this.m_overrides.remove(paramString) != null;
  }
  
  public void process(Table paramTable, int paramInt1, ResultSet paramResultSet, int paramInt2)
    throws SQLException
  {
    Object localObject = this.m_default;
    if ((this.m_overrides != null) && (this.m_overrides.size() > 0))
    {
      ResultSetMetaData localResultSetMetaData = paramResultSet.getMetaData();
      String str = localResultSetMetaData.getColumnName(paramInt2);
      SQLDataHandler localSQLDataHandler = (SQLDataHandler)this.m_overrides.get(str);
      if (localSQLDataHandler != null) {
        localObject = localSQLDataHandler;
      }
    }
    ((SQLDataHandler)localObject).process(paramTable, paramInt1, paramResultSet, paramInt2);
  }
  
  public Class getDataType(String paramString, int paramInt)
  {
    Object localObject = this.m_default;
    if ((this.m_overrides != null) && (this.m_overrides.size() > 0))
    {
      SQLDataHandler localSQLDataHandler = (SQLDataHandler)this.m_overrides.get(paramString);
      if (localSQLDataHandler != null) {
        localObject = localSQLDataHandler;
      }
    }
    return ((SQLDataHandler)localObject).getDataType(paramString, paramInt);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\io\sql\CompositeSQLDataHandler.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */