package prefuse.data.io.sql;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class ConnectionFactory
{
  public static final String DRIVER_MYSQL = "com.mysql.jdbc.Driver";
  public static final String DRIVER_JDBC_OBDC = "sun.jdbc.odbc.JdbcOdbcDriver";
  public static final String PROTOCOL_JDBC = "jdbc:";
  public static final String SUBPROTOCOL_MYSQL = "mysql:";
  public static final String SUBPROTOCOL_JDBC_ODBC = "odbc:";
  
  public static SQLDataHandler getDefaultHandler()
  {
    return new DefaultSQLDataHandler();
  }
  
  public static DatabaseDataSource getDatabaseConnection(Connection paramConnection, SQLDataHandler paramSQLDataHandler)
    throws SQLException
  {
    return new DatabaseDataSource(paramConnection, paramSQLDataHandler);
  }
  
  public static DatabaseDataSource getDatabaseConnection(Connection paramConnection)
    throws SQLException
  {
    return getDatabaseConnection(paramConnection, getDefaultHandler());
  }
  
  public static DatabaseDataSource getDatabaseConnection(String paramString1, String paramString2, String paramString3, String paramString4, SQLDataHandler paramSQLDataHandler)
    throws SQLException, ClassNotFoundException
  {
    Class.forName(paramString1);
    Connection localConnection = DriverManager.getConnection(paramString2, paramString3, paramString4);
    return getDatabaseConnection(localConnection, paramSQLDataHandler);
  }
  
  public static DatabaseDataSource getDatabaseConnection(String paramString1, String paramString2, String paramString3, String paramString4)
    throws SQLException, ClassNotFoundException
  {
    return getDatabaseConnection(paramString1, paramString2, paramString3, paramString4, getDefaultHandler());
  }
  
  public static DatabaseDataSource getMySQLConnection(String paramString1, String paramString2, String paramString3, String paramString4, SQLDataHandler paramSQLDataHandler)
    throws SQLException, ClassNotFoundException
  {
    String str = "jdbc:mysql://" + paramString1 + "/" + paramString2;
    return getDatabaseConnection("com.mysql.jdbc.Driver", str, paramString3, paramString4, paramSQLDataHandler);
  }
  
  public static DatabaseDataSource getMySQLConnection(String paramString1, String paramString2, String paramString3, String paramString4)
    throws SQLException, ClassNotFoundException
  {
    return getMySQLConnection(paramString1, paramString2, paramString3, paramString4, getDefaultHandler());
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\io\sql\ConnectionFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */