package prefuse.data.search;

import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Set;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import prefuse.data.Tuple;
import prefuse.data.tuple.DefaultTupleSet;
import prefuse.data.tuple.TupleSet;
import prefuse.util.StringLib;

public class RegexSearchTupleSet
  extends SearchTupleSet
{
  private String m_query = "";
  private boolean m_caseSensitive;
  private LinkedHashMap m_source = new LinkedHashMap();
  
  public RegexSearchTupleSet()
  {
    this(false);
  }
  
  public RegexSearchTupleSet(boolean paramBoolean)
  {
    this.m_caseSensitive = paramBoolean;
  }
  
  public String getQuery()
  {
    return this.m_query;
  }
  
  public void search(String paramString)
  {
    if (paramString == null) {
      paramString = "";
    }
    if (!this.m_caseSensitive) {
      paramString = paramString.toLowerCase();
    }
    if (paramString.equals(this.m_query)) {
      return;
    }
    Pattern localPattern = null;
    try
    {
      localPattern = Pattern.compile(paramString);
    }
    catch (Exception localException)
    {
      localObject = Logger.getLogger(getClass().getName());
      ((Logger)localObject).warning("Pattern compile failed.\n" + StringLib.getStackTrace(localException));
      return;
    }
    Tuple[] arrayOfTuple = clearInternal();
    this.m_query = paramString;
    Object localObject = this.m_source.keySet().iterator();
    while (((Iterator)localObject).hasNext())
    {
      str1 = (String)((Iterator)localObject).next();
      TupleSet localTupleSet = (TupleSet)this.m_source.get(str1);
      Iterator localIterator = localTupleSet.tuples();
      while (localIterator.hasNext())
      {
        Tuple localTuple = (Tuple)localIterator.next();
        String str2 = localTuple.getString(str1);
        if (!this.m_caseSensitive) {
          str2 = str2.toLowerCase();
        }
        if (localPattern.matcher(str2).matches()) {
          addInternal(localTuple);
        }
      }
    }
    String str1 = getTupleCount() > 0 ? toArray() : null;
    fireTupleEvent(str1, arrayOfTuple);
  }
  
  public void index(Tuple paramTuple, String paramString)
  {
    Object localObject = (TupleSet)this.m_source.get(paramString);
    if (localObject == null)
    {
      localObject = new DefaultTupleSet();
      this.m_source.put(paramString, localObject);
    }
    ((TupleSet)localObject).addTuple(paramTuple);
  }
  
  public void unindex(Tuple paramTuple, String paramString)
  {
    TupleSet localTupleSet = (TupleSet)this.m_source.get(paramString);
    if (localTupleSet != null) {
      localTupleSet.removeTuple(paramTuple);
    }
  }
  
  public boolean isUnindexSupported()
  {
    return true;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\search\RegexSearchTupleSet.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */