package prefuse.render;

import prefuse.data.expression.Predicate;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.util.PredicateChain;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;

public class DefaultRendererFactory
  implements RendererFactory
{
  private PredicateChain m_chain = new PredicateChain();
  private Renderer m_itemRenderer;
  private Renderer m_edgeRenderer;
  
  public DefaultRendererFactory()
  {
    this(new ShapeRenderer());
  }
  
  public DefaultRendererFactory(Renderer paramRenderer)
  {
    this(paramRenderer, new EdgeRenderer());
  }
  
  public DefaultRendererFactory(Renderer paramRenderer1, Renderer paramRenderer2)
  {
    this.m_itemRenderer = paramRenderer1;
    this.m_edgeRenderer = paramRenderer2;
  }
  
  public void setDefaultRenderer(Renderer paramRenderer)
  {
    this.m_itemRenderer = paramRenderer;
  }
  
  public Renderer getDefaultRenderer()
  {
    return this.m_itemRenderer;
  }
  
  public void setDefaultEdgeRenderer(Renderer paramRenderer)
  {
    this.m_edgeRenderer = paramRenderer;
  }
  
  public Renderer getDefaultEdgeRenderer()
  {
    return this.m_edgeRenderer;
  }
  
  public void add(Predicate paramPredicate, Renderer paramRenderer)
  {
    this.m_chain.add(paramPredicate, paramRenderer);
  }
  
  public void add(String paramString, Renderer paramRenderer)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramRenderer);
  }
  
  public Renderer getRenderer(VisualItem paramVisualItem)
  {
    Renderer localRenderer = (Renderer)this.m_chain.get(paramVisualItem);
    if (localRenderer != null) {
      return localRenderer;
    }
    if ((paramVisualItem instanceof EdgeItem)) {
      return this.m_edgeRenderer;
    }
    return this.m_itemRenderer;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\render\DefaultRendererFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */