package prefuse.util;

import prefuse.data.Tuple;
import prefuse.data.expression.Expression;
import prefuse.data.expression.IfExpression;
import prefuse.data.expression.ObjectLiteral;
import prefuse.data.expression.Predicate;

public class PredicateChain
{
  private Expression m_head = new ObjectLiteral(null);
  private IfExpression m_tail = null;
  
  public Expression getExpression()
  {
    return this.m_head;
  }
  
  public Object get(Tuple paramTuple)
  {
    return this.m_head.get(paramTuple);
  }
  
  public void add(Predicate paramPredicate, Object paramObject)
  {
    if (this.m_tail == null)
    {
      this.m_tail = new IfExpression(paramPredicate, new ObjectLiteral(paramObject), this.m_head);
      this.m_head = this.m_tail;
    }
    else
    {
      IfExpression localIfExpression = new IfExpression(paramPredicate, new ObjectLiteral(paramObject), this.m_tail.getElseExpression());
      this.m_tail.setElseExpression(localIfExpression);
      this.m_tail = localIfExpression;
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\PredicateChain.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */