package prefuse.util.collections;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

public class ByteArrayList
{
  private byte[] m_bytes;
  private int m_size;
  
  public ByteArrayList()
  {
    this(4096);
  }
  
  public ByteArrayList(int paramInt)
  {
    this.m_bytes = new byte[paramInt];
    this.m_size = 0;
  }
  
  private void rangeCheck(int paramInt)
  {
    if ((paramInt < 0) || (paramInt >= this.m_size)) {
      throw new IndexOutOfBoundsException("Index: " + paramInt + " Size: " + this.m_size);
    }
  }
  
  private void ensureCapacity(int paramInt)
  {
    if (this.m_bytes.length < paramInt)
    {
      int i = Math.max(3 * this.m_bytes.length / 2 + 1, paramInt);
      byte[] arrayOfByte = new byte[i];
      System.arraycopy(this.m_bytes, 0, arrayOfByte, 0, this.m_size);
      this.m_bytes = arrayOfByte;
    }
  }
  
  public byte get(int paramInt)
  {
    rangeCheck(paramInt);
    return this.m_bytes[paramInt];
  }
  
  public void set(int paramInt, byte paramByte)
  {
    rangeCheck(paramInt);
    this.m_bytes[paramInt] = paramByte;
  }
  
  public int size()
  {
    return this.m_size;
  }
  
  public void add(byte paramByte)
  {
    ensureCapacity(this.m_size + 1);
    this.m_bytes[(this.m_size++)] = paramByte;
  }
  
  public void add(byte[] paramArrayOfByte, int paramInt1, int paramInt2)
  {
    ensureCapacity(this.m_size + paramInt2);
    System.arraycopy(paramArrayOfByte, paramInt1, this.m_bytes, this.m_size, paramInt2);
    this.m_size += paramInt2;
  }
  
  public InputStream getAsInputStream()
  {
    return new ByteArrayInputStream(this.m_bytes, 0, this.m_size);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\collections\ByteArrayList.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */