package prefuse.util.collections;

import java.util.NoSuchElementException;

public class CompositeIntIterator
  extends IntIterator
{
  private IntIterator[] m_iters;
  private int m_cur;
  
  public CompositeIntIterator(IntIterator paramIntIterator1, IntIterator paramIntIterator2)
  {
    this(new IntIterator[] { paramIntIterator1, paramIntIterator2 });
  }
  
  public CompositeIntIterator(IntIterator[] paramArrayOfIntIterator)
  {
    this.m_iters = paramArrayOfIntIterator;
    this.m_cur = 0;
  }
  
  public int nextInt()
  {
    if (hasNext()) {
      return this.m_iters[this.m_cur].nextInt();
    }
    throw new NoSuchElementException();
  }
  
  public boolean hasNext()
  {
    if (this.m_iters == null) {
      return false;
    }
    do
    {
      if (this.m_iters[this.m_cur].hasNext()) {
        return true;
      }
    } while (++this.m_cur < this.m_iters.length);
    this.m_iters = null;
    return false;
  }
  
  public void remove()
  {
    throw new UnsupportedOperationException();
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\collections\CompositeIntIterator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */