package prefuse.util.ui;

import java.awt.Container;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import prefuse.data.Edge;
import prefuse.data.Graph;
import prefuse.data.Node;
import prefuse.data.Tree;
import prefuse.data.event.GraphListener;
import prefuse.util.StringLib;
import prefuse.util.collections.CopyOnWriteArrayList;
import prefuse.visual.VisualTree;

public class JPrefuseTree
  extends JTree
{
  private Tree m_tree;
  private String m_field;
  
  public JPrefuseTree(Tree paramTree, String paramString)
  {
    this.m_tree = paramTree;
    this.m_field = paramString;
    PrefuseTreeModel localPrefuseTreeModel = new PrefuseTreeModel();
    super.setModel(localPrefuseTreeModel);
    this.m_tree.addGraphModelListener(localPrefuseTreeModel);
  }
  
  public Tree getTree()
  {
    return this.m_tree;
  }
  
  public String convertValueToText(Object paramObject, boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3, int paramInt, boolean paramBoolean4)
  {
    if (paramObject == null) {
      return "";
    }
    if ((paramObject instanceof Node))
    {
      Object localObject = ((Node)paramObject).get(this.m_field);
      if (localObject.getClass().isArray()) {
        return StringLib.getArrayString(localObject);
      }
      return localObject.toString();
    }
    return paramObject.toString();
  }
  
  public static JFrame showTreeWindow(Tree paramTree, String paramString)
  {
    JPrefuseTree localJPrefuseTree = new JPrefuseTree(paramTree, paramString);
    String str = paramTree.toString();
    if ((paramTree instanceof VisualTree)) {
      str = ((VisualTree)paramTree).getGroup() + " " + str;
    }
    JFrame localJFrame = new JFrame(str);
    localJFrame.getContentPane().add(new JScrollPane(localJPrefuseTree));
    localJFrame.pack();
    localJFrame.setVisible(true);
    return localJFrame;
  }
  
  public class PrefuseTreeModel
    implements TreeModel, GraphListener
  {
    private CopyOnWriteArrayList m_listeners = new CopyOnWriteArrayList();
    
    public PrefuseTreeModel() {}
    
    public Object getRoot()
    {
      return JPrefuseTree.this.m_tree.getRoot();
    }
    
    public Object getChild(Object paramObject, int paramInt)
    {
      Node localNode = ((Node)paramObject).getChild(paramInt);
      if (localNode == null) {
        throw new IllegalArgumentException("Index out of range: " + paramInt);
      }
      return localNode;
    }
    
    public int getChildCount(Object paramObject)
    {
      return ((Node)paramObject).getChildCount();
    }
    
    public boolean isLeaf(Object paramObject)
    {
      return ((Node)paramObject).getChildCount() == 0;
    }
    
    public void valueForPathChanged(TreePath paramTreePath, Object paramObject) {}
    
    public int getIndexOfChild(Object paramObject1, Object paramObject2)
    {
      return ((Node)paramObject1).getChildIndex((Node)paramObject2);
    }
    
    public void addTreeModelListener(TreeModelListener paramTreeModelListener)
    {
      if (!this.m_listeners.contains(paramTreeModelListener)) {
        this.m_listeners.add(paramTreeModelListener);
      }
    }
    
    public void removeTreeModelListener(TreeModelListener paramTreeModelListener)
    {
      this.m_listeners.remove(paramTreeModelListener);
    }
    
    public void graphChanged(Graph paramGraph, String paramString, int paramInt1, int paramInt2, int paramInt3, int paramInt4)
    {
      if ((this.m_listeners == null) || (this.m_listeners.size() == 0)) {
        return;
      }
      boolean bool = paramString.equals(Graph.NODES);
      if ((paramInt4 != 0) && (bool)) {
        return;
      }
      if ((paramInt4 == 0) && (!bool)) {
        return;
      }
      for (int i = paramInt1; i <= paramInt2; i++)
      {
        Node localNode = null;
        if (bool) {
          localNode = paramGraph.getNode(i);
        } else {
          localNode = paramGraph.getEdge(i).getTargetNode();
        }
        Object[] arrayOfObject1 = new Object[localNode.getDepth() + 1];
        int j = arrayOfObject1.length;
        for (;;)
        {
          j--;
          if (j < 0) {
            break;
          }
          arrayOfObject1[j] = localNode;
          localNode = localNode.getParent();
        }
        TreeModelEvent localTreeModelEvent = new TreeModelEvent(this, arrayOfObject1);
        Object[] arrayOfObject2 = this.m_listeners.getArray();
        for (int k = 0; k < arrayOfObject2.length; k++)
        {
          TreeModelListener localTreeModelListener = (TreeModelListener)arrayOfObject2[k];
          switch (paramInt4)
          {
          case 1: 
            localTreeModelListener.treeNodesInserted(localTreeModelEvent);
            break;
          case -1: 
            localTreeModelListener.treeNodesRemoved(localTreeModelEvent);
            break;
          case 0: 
            localTreeModelListener.treeNodesChanged(localTreeModelEvent);
          }
        }
      }
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\ui\JPrefuseTree.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */